History of Previous Changes

> This page details the changes made in previous versions only. Current changes are detailed in Changes.

> Changes sections are chronologically ordered from top (most recent) to bottom (least recent)

> # Version 5.6.1

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Pull request #6010 - Use UTF-8 as a default encoding in HTTP sampler. It enables sending parameter names, and filenames with unicode characters
> - Pull request #6010 - Test Recorder will use UTF-8 encoding by default, so it will infer human-readable arguments rather than percent-encoded ones

> Non-functional changes

> - Pull request #6000 - Add release-drafter for populating GitHub releases info based on the merged PRs
> - Pull request #5989 - Use Gradle toolchains for JDK provisioning, enable building and testing with different JDKs, start testing with Java 21
> - Pull request #5991 - Update jackson-core, jackson-databind, jackson-annotations to 2.15.2 (from 2.15.1)
> - Pull request #5993 - Update ph-commons to 10.2.5 (from 10.2.4)
> - Pull request #6017 - Update kotlin-stdlib to 1.8.22 (from 1.8.21)
> - Pull request #6020 - Update error_prone_annotations to 2.20.0 (from 2.19.1)
> - Pull request #6023 - Update checker-qual to 3.35.0 (from 3.34.0)

> ### Other Samplers

> - Pull request #6028 - Change default value for `sampleresult.default.encoding` to UTF-8 (it inherits default HTTP encoding which was modified in Pull request #6010 - )

> Bug fixes

> ### Thread Groups

> - Pull request #6011 - Regression since 5.6: ThreadGroups are running endlessly in non-gui mode: use default value for LoopController.continue_forever rather than initializing it in the constructor

> ### Other Samplers

> - Pull request #6012 - Java Request sampler cannot be enabled again after disabling in UI (regression since 5.6)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Alex Schwartz, @alexsch01

> We also thank bug reporters who helped us improve JMeter.

> - David Getzlaff, @dgetzlaf
> - LeeBaul, @libaolu

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - `pom.xml` misses `<version>` tags for `auto-service-annotations`, so Maven can't infer transitive dependencies. The issue is resolved in 5.6.2
> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.14.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 (or later) and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.3/nashorn-core-15.3.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.5/asm-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.5/asm-commons-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.5/asm-util-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.5/asm-tree-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.5/asm-analysis-9.5.jar
>         popd
>         export JVM_ARGS="--module-path $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.6

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> Improvements

> ### Thread Groups

> - Issue #5682 Pull request #717 - Open Model Thread Group: avoid skipping rows from CSV Data Set Config
> - Support custom thread group implementations in "Add think time" and "Save as test fragment" actions
> - Open Model Thread Group: interrupt pending HTTP requests and other `Interruptible` test elements on test stop

> ### HTTP Samplers and Test Script Recorder

> - Pull request #5911 - Use Caffeine for caching HTTP headers instead of commons-collections4 LRUMap
> - Pull request #5947 - Fetch resources referenced in `<link "rel"="preload"...>` elements
> - Pull request #5869 - Allow more templates to format sampler names in the recorder: `#{url}`, `#{method}`, `#{scheme}`, `#{host}`, `#{port}`

> ### Other samplers

> - Pull request #5909 - Use Caffeine for caching compiled scripts in JSR223 samplers instead of commons-collections4 LRUMap

> ### General

> - Pull request #5792 - Add KeyStroke for start_no_timers (Start no pauses: CRTL+SHIFT+n)
> - Pull request #5899 - Speed up CPU-bound tests by skipping `recoverRunningVersion` for elements that are shared between threads (the ones that implement `NoThreadClone`)
> - Pull request #5914 - Use `Locale.ROOT` instead of default locale for `toUpperCase`, and `toLowerCase` to avoid surprises with dotless I in `tr_TR` locale
> - Pull request #5885 - Use Java's `ServiceLoader` for loading plugins instead of classpath scanning. It enables faster startup
> - Pull request #5788 - `FunctionProperty` no longer caches the value. Previously it cached the values based on iteration number only which triggered wrong results on concurrent executions. The previous behavior can be temporary restored with `function.cache.per.iteration` property.
> - Pull request #5920 - Improve HTTP HeaderManager performance when it contains many headers: skip reinitialization on each iteration
> - Pull request #5920 - Use AtomicInteger and AtomicLong instead of synchronized primitives for JMeterContextService#numberOfThreads
> - Pull request #5920 - Cache bean properties in `TestBeanHelper` and avoid synchronization, so test plans with `TestBean`-based elements is faster
> - Pull request #5920 - Improve computation when many threads actively produce samplers by using `LongAdder` and similar concurrency classes to avoid synchronization in `Calculator`
> - Pull request #5920 - Reduce synchronization contention on `AbstractTestElement` that are shared between threads (the ones that implement `NoThreadClone`)
> - Pull request #5934 - Added caching for date formatters for `__time` function
> - Pull request #710 - Issue #5666Added Shortcut key event for Reset search: `ctrl + alt + F`, `cmd + alt + F`
> - Pull request #5959 - `TestElement` has been migrated to Kotlin, so nullable types are annotated better
> - Pull request #5944 - Add PI for declaring `TestElement` schemas so element properties are easier to access in code (see `TestElementSchema`, `TestElement#getSchema()`, `TestElement#getProps()`)
> - Pull request #5944 - Enable usage of `${...}` expressions for checkbox controls (see context menus for checkboxes, however, the individual components should be adapted individually)
> - Pull request #678 - Experimental Kotlin and Java DSL for programmatic test plan generation (see Creating a plan with Kotlin DSL)

> Non-functional changes

> - Pull request #725 - Add Chinese Simplified Translation for Open Model Thread Group
> - Pull request #5710 - Add GitHub Issue templates
> - Pull request #5910 - Use Caffeine for caching customizers in TestBeanGUI instead of commons-collections4 LRUMap
> - Pull request #5713 - Pull request #5931 - Update Spock to 2.3-groovy-3.0 (from 2.1-groovy-3.0)
> - Issue #5718Update Apache commons-text to 1.10.0 (from 1.9)
> - Pull request #5731 - Update docs for `changeCase` function. `UPPER` is the default
> - Pull request #5924 - Update Apache commons-io to 2.12.0 (from 2.11.0)
> - Pull request #5921 - Update Jackson Core to 2.15.1 (from 2.13.3)
> - Pull request #5921 - Update Jackson Databind to 2.15.1 (from 2.13.3)
> - Pull request #5725 - Update Tika Parser to 1.28.5 (from 1.28.3)
> - Pull request #5725 - Update JSoup to 1.16.1 (from 1.15.1)
> - Pull request #5725 - Update Apache commons-net to 3.9.0 (from 3.8.0)
> - Pull request #5725 - Update XStream to 1.4.20 (from 1.4.19)
> - Pull request #5763 - Pull request #5814 - Updated Gradle to 8.1.1 (from 7.2)
> - Pull request #5854 - Added Apache Httpclient5 5.1.3
> - Pull request #5833 - Update Apache Freemarker to 2.3.32 (from 2.3.31)
> - Pull request #5830 - Update Apache Groovy to 3.0.17 (from 3.0.11)
> - Pull request #5862 - Update Apache Httpclient to 4.5.14 (from 4.5.13)
> - Pull request #5880 - Update Apache Xalan to 2.7.3 (from 2.7.2)
> - Pull request #5854 - Update Saxon-HE to 11.5 (from 11.5)
> - Pull request #5840 - Pull request #5930 - Update accessors-smart to 2.4.11 (from 2.4.8)
> - Pull request #5837 - Update asm to 9.5 (from 9.3)
> - Pull request #5840 - Pull request #5930 - Update json-smart to 2.4.11 (from 2.4.8)
> - Pull request #5814 - Update kotlin-stdlib to 1.8.21 (from 1.6.21)
> - Pull request #5889 - Pull request #5918 - Pull request #5814 - Update kotlinx-coroutines-core to 1.8.21 (from 1.6.21)
> - Pull request #5889 - Pull request #5918 - Pull request #5814 - Update kotlinx-coroutines-swing to 1.8.21 (from 1.6.21)
> - Pull request #5907 - Update lets-plot-batik to 3.2.0 (from 2.1.1)
> - Pull request #5907 - Update lets-plot-jvm to 4.3.0 (from 3.1.1)
> - Pull request #5859 - Update log4j-1.2-api to 2.20.0 (from 2.17.2)
> - Pull request #5859 - Update log4j-api to 2.20.0 (from 2.17.2)
> - Pull request #5859 - Update log4j-core to 2.20.0 (from 2.17.2)
> - Pull request #5859 - Update log4j-slf4j-impl to 2.20.0 (from 2.17.2)
> - Pull request #5861 - Update neo4j-java-driver to 4.4.11 (from 4.4.6)
> - Pull request #5853 - Update org.jetbrains:annotations to 24.0.1 (from 23.0.0)
> - Pull request #5868 - Pull request #5886 - Update ph-commons to 10.2.4 (from 10.1.6)
> - Pull request #5861 - Update reactive-streams to 1.0.4 (from 1.0.3)
> - Pull request #5847 - Update rsyntaxtextarea to 3.3.3 (from 3.2.0)
> - Pull request #5839 - Update svgSalamander to 1.1.4 (from 1.1.2.4)
> - Pull request #5852 - Update xmlgraphics-commons to 2.8 (from 2.7)
> - Pull request #5854 - Update xmlresolver to 4.6.4 (from 4.2.0)
> - Pull request #693 - Added randomized test GitHub Actions matrix for better coverage of locales and time zones
> - Pull request #5960 - Add OpenJDK JMH for creating microbenchmarks in JMeter code
> - Issue #5961Deprecate TestElement.threadName as it is not related to TestElement

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Pull request #5901 - Fix NumberFormatException when counter is empty or not a digit on Proxy Settings panel
> - Pull request #5987 - Issue #4546Encode unicode characters in filenames when sending files in HTTP Sampler

> ### Other Samplers

> - Pull request #5736 - Issue #5733Allow `SampleResult#setEndTime` be set in `JSR223Sampler`

> ### Listeners

> - Issue #5740 Pull request #5741 - Fix Aggregated Graph component to cope with empty names of samplers
> - Issue #5807Fix an `ArrayIndexOutOfBoundsException` on HTTP parameters line on special case when key and value are empty, i.e.: "`k1=v1&=&k2=v2`"
> - Issue #5654 Pull request #5785 - Fix `InfluxDBRawBackendListenerClient` missing data. Allow InfluxDB to insert multiple entries with the same `timestamp` but with different `threadName`. Contributed by Victor Peralta (vperaltac at github)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Pull request #5717 - Add jsonpath string to JSON Path Assertion error message so the error is easier to understand
> - Pull request #723 - Use correct number format on JSON Path Assertion. Contributed by andreaslind01 (andreaslind01 at gmail.com)

> ### Report / Dashboard

> - Bug 66140 - Guess the delimiter of the CSV source, when configured one seems wrong. This is in line with the behaviour of CSVSaveService.

> ### Documentation

> - Issue #5694Document changed formatter for __time(). A warning will be logged, if the code `u` is found in the format string, as the meaning for that code has changed from day-of-week to year.

> ### General

> - Bug 66157 - Pull request #719 - Correct theme for darklaf on rsyntaxtextarea
> - Issue #5872 Pull request #5874 - Trim name in Argument objects.
> - Pull request #693 - Avoid wrong results when `Object.hashCode()` happen to collide. Use `IdentityHashMap` instead of `HashMap` when key is `TestElement`
> - Refresh UI when dragging JMeter window from one monitor to another, so rich syntax text areas are properly editable after window movement
> - Pull request #5984 - `AbstractTestElement#clone` might produce non-identical clones if element constructor adds a non-default property value

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Alex Schwartz, @alexsch01
> - Andreas Lind, @andreaslind01
> - Arnout Engelen, @raboof
> - Clay Johnson, @clayburn
> - David Getzlaff, @dgetzlaf
> - Kai Lehmann, @lehmannk
> - kaola89, @kaola89
> - Matt Tansley, @matthewt-assurity
> - Mohamed Ibrahim, @rollno748
> - Ori Marko, @orimarko
> - PJ Fanning, @pjfanning
> - Sandra Thieme, @sandra-thieme
> - Stefan Seide, @sseide
> - Victor Peralta, @vperaltac
> - Vincent DABURON, @vdaburon

> We also thank bug reporters who helped us improve JMeter.

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - Issue #6008 ThreadGroups are running endlessly in non-gui mode (fixed in 5.6.1, see Pull request #6011 - )
> - Pull request #5987 - HTTP sampler sends filenames with percent-encoded UTF-8, however it is not aligned with the browsers. The workaround is to refrain non-ASCII filenames
> - Issue #6004Java Request sampler cannot be enabled again after disabling in UI (fixed in 5.6.1, Pull request #6012 - )
> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.14.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 (or later) and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.3/nashorn-core-15.3.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.5/asm-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.5/asm-commons-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.5/asm-util-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.5/asm-tree-9.5.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.5/asm-analysis-9.5.jar
>         popd
>         export JVM_ARGS="--module-path $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.5

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> JMeter now supports Java 17

> JMeter 5.5 ships with log4j2 2.17.2

> Open Model Thread Group

> New component: `Open Model Thread Group` allows creating load profiles with variable load.

> For example, if you need to gradually increase load from `0/sec` to `10/sec` during `minute` you could previously use `Thread Group + Timer` combinations. However, then you need to compute the expected number of threads, ensure they are created only when needed, and so on.

> With `Open Model Thread Group` you can configure the same load profile as `rate(0/sec) random_arrivals(1 minute) rate(10/sec)`. The thread group would spawn threads as needed to drive the configured load. The load profile can use properties, so you can launch the same script with slightly different load levels, however, the profile can't be updated while the test is running.

> The new thread group is experimental in JMeter 5.5, so please feel free to submit your feedback.

> Open Model Thread Group sample

> Preparing the deprecation of Oro Regex usage

> Another experimental feature in JMeter 5.5 is the ability to replace the Oro based Regex implementation by the built-in Java based one. To choose the Java based one, set the JMeter property `jmeter.regex.engine` to the value `java`.

> Core improvements

> Kotlin language is now used in some core classes and tests (e.g. Open Model Thread Group). JMeter is compiled with `apiTarget=1.5`, and it ships with `kotlin-stdlib` 1.6.

> lets-plot-kotlin charting library is added, so it will be easier to refine and create new charts in UI in the future.

> Improvements

> ### Thread Groups

> - New component: `Open Model Thread Group`

> ### HTTP Samplers and Test Script Recorder

> - Bug 65027 - Detect mime-type for files automatically when adding files to HTTP Sampler
> - Bug 65020 - HTTP Sampler/Files upload tab – add missing buttons
> - Pull request #650 - HTTP Sampler timestamp fix when exception is caught. Contributed by Konstantin Kalinin (konstantin at kkalinin.pro)
> - Bug 65328 - Pull request #666 - HTTP 308 Permanent Redirect is not supported. Contributed by Baptiste Gaillard (baptiste.gaillard at gmail.com)

> ### Other samplers

> - Bug 65149 - Pull request #644 - Encode the personal part of email addresses in SMTP Sampler
> - Pull request #638 - Various additions to the Bolt Sampler. Added `transaction timeout`, `database` option required for Neo4j 4.x (with multi-database support) and `access mode` option, that allows running against a Neo4j Enterprise Causal Cluster. Contributed by David Pecollet (david.pecollet at gmail.com)

> ### Controllers

> - Pull request #665 - Increase visible lines of code in `IfController` and `WhileController`. Based on an idea by David Getzlaff (david.getzlaff at t-systems.com>).

> ### Listeners

> - Bug 64988 - Sort properties and variables in a human expected order for DebugPostProcessor and DebugSampler
> - Bug 63061 - Sort View Results in Table in a human expected order
> - Pull request #706 - Try to keep UI responsive when displaying large text results. Can be configured with the new property `view.results.tree.simple_view_limit`

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Pull request #638 - Bolt Connection Configuration: added `ConnectionPoolMaxSize` parameter. Contributed by David Pecollet (david.pecollet at gmail.com)
> - Bug 65515 - Allow pooling of Prepared Statements in JDBC
> - Bug 65299 - JSONPathAssertion attributes are out of order/Compare JSON objects and not their string representations.

> ### Report / Dashboard

> - Bug 65353 - Make the estimator used for calculating percentiles on the dashboard configurable

> ### General

> - Bug 61805 - Pull request #663 - Add simple HTTP request template. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 65611 - Pull request #673 - Add support for IPv6 addresses when specifying a remote worker node. Based on a patch by Peter Wong (peter.wong at csexperts.com)
> - Reduce memory consumption by the logging panel (disable undo events for it)
> - Bug 63620 - Pull request #694 - Fix GUI freeze when viewing response body with long line breaks
> - Pull request #699 - Add documentation for Graphite Backend Listener. Contributed by Ji Hun (jihunkimkw at gmail.com)
> - Bug 57672 - Pull request #700 - Add a switch (`jmeter.regex.engine`) to replace Oro Regex implementation by the built-in Java one.

> Non-functional changes

> - Added Kotlin 1.6.21 for JMeter engine implementation (apiVersion=1.5). The set of JSR 223 languages is intact.
> - Bug 65128 - Pull request #643 - Add missing documentation about `Same user on each iteration` for Thread Groups. Contributed by njkuzas.
> - Pull request #648 - Updated xmlgraphics-commons to 2.6 (from 2.3). Contributed by Stefan Seide (stefan at trilobyte-se.de)
> - Pull request #655 - Pull request #667 - Pull request #675 - Pull request #698 - Updated x-stream to 1.4.19 (from 1.4.15). Contributed by Stefan Seide (stefan at trilobyte-se.de)
> - Pull request #656 - Pull request #668 - Updated json-smart to 2.4.8 (from 2.3), accessors-smart to 2.4.8 (from 1.2) and asm 9.3 (from 9.0). Contributed by Stefan Seide (stefan at trilobyte-se.de)
> - Bug 64831 - Log truststore entries in debug level for logger `org.apache.jmeter.util.keystore.JmeterKeyStore`
> - Bug 65232 - Hide splash screen when an error is displayed because the test plan could not be parsed.
> - Updated Groovy to 3.0.11 (from 3.0.7).
> - Updated Darklaf to 2.7.3 (from 2.5.4).
> - Updated Apache ActiveMQ to 15.6.4 (from 15.6.0).
> - Updated Asm to 9.2 (from 9.1).
> - Updated Bouncycastle to 1.70 (from 1.67).
> - Updated Caffeine to 2.9.3 (from 2.8.8).
> - Updated Apache commons-dbcp2 to 2.9.0 (from 2.8.0).
> - Updated Apache commons-io to 2.11.0 (from 2.8.0).
> - Updated Apache commons-lang3 to 3.12.0 (from 3.11).
> - Updated Apache commons-net to 3.8.0 (from 3.7.2).
> - Updated Apache commons-pool2 to 2.11.1 (from 2.9.0).
> - Updated equalsverifier to 3.10 (from 3.4.2).
> - Updated Apache Freemarker to 2.3.31 (from 2.3.30).
> - Updated hsqldb to 2.5.2 (from 2.5.0).
> - Updated Apache HttpClient to 4.5.13 (from 4.5.12).
> - Updated Apache HttpCore to 4.4.15 (from 4.4.13).
> - Updated jacoco to 0.8.7 (from 0.8.5).
> - Updated json-path to 2.7.0 (from 2.4.0).
> - Updated jsoup to 1.15.1 (from 1.13.1).
> - Updated JUnit to 4.13.2 and 5.8.2 (from 4.13.1 and 5.7.0).
> - Updated Apache log4j2 to 2.17.2 (from 2.13.3).
> - Updated Miglayout to 5.3 (from 5.2).
> - Updated Neo4j Java driver to 4.4.6 (from 4.2.0).
> - Updated Objenesis to 3.2 (from 2.6).
> - Updated ktlint to 0.40.0
> - Updated PH CSS and PH commons to 6.5.4 and 10.1.6 (from 6.2.3 and 9.5.1).
> - Updated RSyntaxTextArea to 3.2.0 (from 3.1.1).
> - Updated SLF4J to 1.7.36 (from 1.7.30).
> - Updated SvgSalamander to 1.1.2.4 (from 1.1.2.1).
> - Pull request #698 - Updated Apache Tika to 1.28.3 (from 1.26).
> - Updated WireMock-JRE8 to 2.30.0 (from 2.24.1).
> - Updated com.github.vlsi.vlsi-release-plugins 1.76 (from 1.74).
> - Updated jackson to 2.13.3 (from 2.10.5)
> - Updated jmespath to 0.5.1
> - Updated Saxon-HE to 11.2 (from 9.9.1-8)
> - Updated Apache xmlgraphics commons to 2.7 (from 2.6)
> - Pull request #671 - Move example definition of property `jmeter.reportgenerator.statistic_window` to `user.properties`, as it is read from that place. Contributed by Rithvik Patibandla (rithvikp98 at gmail.com)
> - Bug 65456 - Updated commons-jexl 3 to 3.2.1 (from 3.1). Contributed by Ori Marko (orimarko at gmail.com>)
> - Pull request #654 - Try do give better feedback while loading keystores
> - Pull request #672 - Add more details to documentation for timeShift function. Contributed by Mariusz (mawasak at gmail.com)
> - Updated Gradle to 7.3 (from 7.2)
> - Pull request #689 - Code clean up in StringFromFile. Contributed by Sampath Kumar Krishnasamy (sampathkumar.krishnasamykuppusamy at aexp.com)
> - Pull request #690 - Refactor a few unit tests. Contributed by Sampath Kumar Krishnasamy (sampathkumar.krishnasamykuppusamy at aexp.com)
> - Pull request #692> - Fix a few deprecation warnings for Gradle. Contributed by Sampath Kumar Krishnasamy (sampathkumar.krishnasamykuppusamy at aexp.com)
> - Pull request #697> - Junit 5 tests to use asserts from Junit 5 API. Contributed by Sampath Kumar Krishnasamy (sampathkumar.krishnasamykuppusamy at aexp.com)
> - Bug 65983 - Pull request #707 - Use current screenshot for save-to-file listener in documentation. Based on patch by NaveenKumar Namachivayam (catch.nkn at gmail.com)
> - Pull request #708 - Make errorprone happier. Based on patch by Wilson Kurniawan (wilson at visenze.com)>
> - Updated Rhino JavaScript to 1.7.14 (from 1.7.13)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 65310 - Don't let users override `multipart/form-data` `content-type` header in HC4 sampler.
> - Bug 65363 - `NullPointerException` in `HTTPHC4Impl$ManagedCredentialsProvider.getAuthorizationForAuthScope` when `401` response from remote and `httpclient4.auth.preemptive=false`
> - Bug 65692 - HTTP(s) Test Script Recorder: Enable setting enabled cipher suite and enabled protocols on SSLContext/ Align SSL properties between Java and HC4 implementation
> - Bug 65108 - Support JMeter variables in GraphQL HTTP Request
> - Bug 65864 - Catch `NullPointerException` from JSoup when recording a test plan

> ### Other Samplers

> - Bug 65152 - OS Process Sampler – Cannot `Add from Clipboard` Command parameters
> - Pull request #638 - Bolt Sampler: fixed error displaying results when "Record Query Results" is enabled. Contributed by David Pecollet (david.pecollet at gmail.com)

> ### Controllers

> ### Listeners

> - Bug 64962 - Save CSV sub-results recursively from View Results Tree
> - Bug 65784 - No Graphs displayed in Aggregate Report/Response Time Graph
> - Bug 65884 - GUI doesn't display response for multipart request manually encoded

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 65257 - JMESPathExtractor writes error log entries if JMESPath filter returns empty result
> - Bug 65259 - JMESPathExtractor Attribute `Match No.` Required
> - Bug 65269 - JSON Extractor and JSON JMESPath Extractor ignore sub-samples
> - Bug 65352 - Warning logged when Boundary Extractor doesn't find any match
> - Bug 65681 - Use default values for `null` values when extracting with JSONPostProcessor
> - Allow setters in ConstantThroughputTimer to update the values during run time
> - Bug 65782 - Use correct message format for MessageFormat in HTMLAssertion
> - Bug 65794 - JSON Assertion always successful with indefinite paths

> ### Functions

> ### I18N

> ### Report / Dashboard

> ### Documentation

> - Pull request #658 - Improve javadoc. Contributed by Ori Marko (orimarko at gmail.com)

> ### General

> - Bug 64318 - DNS Cache Manager – custom DNS resolver does not use system resolver by default
> - Pull request #641 - Pull request #698 - Updated xercesImpl to 2.12.2 (from 2.12.0). Based on patch by Stefan Seide (stefan at trilobyte-se.de).
> - Pull request #645 - Add escaping for new lines in `AbstractInfluxdbMetricsSender`. Contributed by David Getzlaff (david.getzlaff at t-systems.com>)
> - Bug 65198 - Can't copy generated function from FunctionHelper
> - Pull request #661 - Fix wording in doc. Contributed by BugKing (wangzhen at fit2cloud.com)
> - Pull request #664 - Allow whitespace in path. Contributed by Till Neunast (github.com/tilln)
> - Bug 65270 - POST `application/x-www-form-urlencoded` cURL code generated from Postman is not imported correctly
> - Silence warnings of missing font Arial on startup under Linux
> - Bug 65300 - `IllegalAccessError` when opening file dialog with Java 16
> - Bug 65336 - Blank labels when different elements had the same name
> - Bug 65522 - Restart doesn't work, when parameters contain spaces
> - Bug 63914 - Simplify `:src:dist:clean` configuration, ensure `/lib/junit/test.jar` is removed on clean
> - Pull request #696 - Keep JSyntaxTextArea text value for use in headless mode. Contributed by Peter Paul Bakker (peter.paul.bakker at stokpop.nl)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Stefan Seide (stefan at trilobyte-se.de)
> - njzukas (github.com/njzukas)
> - David Getzlaff (david.getzlaff at t-systems.com>)
> - Konstantin Kalinin (konstantin at kkalinin.pro)
> - David Pecollet (david.pecollet at gmail.com)
> - Ori Marko (orimarko at gmail.com)
> - BugKing (wangzhen at fit2cloud.com)
> - Till Neunast (github.com/tilln)
> - Baptiste Gaillard (baptiste.gaillard at gmail.com)
> - Rithvik Patibandla (rithvikp98 at gmail.com)
> - Mariusz (mawasak at gmail.com)
> - peter.wong@csexperts.com
> - Woonsan Ko (woonsan.ko at bloomreach.com)
> - Chromico Rek (atech5122 at gmail.com)
> - Magnus Spångdal (magnus.spangdal as avanza.se)
> - Piotr Smietana (piotrsmietana1998 at gmail.com)
> - Sampath Kumar Krishnasamy (sampathkumar.krishnasamykuppusamy at aexp.com)
> - Ji Hun (jihunkimkw at gmail.com)
> - Peter Paul Bakker (peter.paul.bakker at stokpop.nl)
> - NaveenKumar Namachivayam (catch.nkn at gmail.com)
> - Wilson Kurniawan (wilson at visenze.com)

> We also thank bug reporters who helped us improve JMeter.

> - Nikola Aleksic (nalexic at gmail.com)
> - Vladimir Rosu (rosuvladimir at gmail.com)

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.14.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 (or later) and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.3/nashorn-core-15.3.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.2/asm-9.2.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.2/asm-commons-9.2.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.2/asm-util-9.2.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.2/asm-tree-9.2.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.2/asm-analysis-9.2.jar
>         popd
>         export JVM_ARGS="--module-path $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.4.3

> Summary

> This version is a fix release against the vulnerability CVE-2021-45105: Apache Log4j2 versions 2.0-alpha1 through 2.16.0 (excluding 2.12.3) did not protect from uncontrolled recursion from self-referential lookups. This allows an attacker with control over Thread Context Map data to cause a denial of service when a crafted string is interpreted.

> - Non-functional changes
> - Known problems and workarounds

> Non-functional changes

> - Updated Apache log4j2 to 2.17.0 (from 2.16.0).

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.13.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.0/nashorn-core-15.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.0/asm-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.0/asm-commons-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.0/asm-util-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.0/asm-tree-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.0/asm-analysis-9.0.jar
>         popd
>         export JVM_ARGS="--modulepath $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.4.2

> Summary

> This version is a fix release against the vulnerability CVE-2021-44228: Apache Log4j2 JNDI features do not protect against attacker controlled LDAP and other JNDI related endpoints.

> - Non-functional changes
> - Known problems and workarounds

> Non-functional changes

> - Updated Apache log4j2 to 2.16.0 (from 2.13.3).

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.13.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.0/nashorn-core-15.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.0/asm-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.0/asm-commons-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.0/asm-util-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.0/asm-tree-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.0/asm-analysis-9.0.jar
>         popd
>         export JVM_ARGS="--modulepath $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.4.1

> Summary

> - Incompatible changes
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> Incompatible changes

> - Restart after LAF change has been reinstated, it had been removed in JMeter 5.3

> Improvements

> ### General

> - Bug 65028 - Add documentation for the property `client.rmi.localport`
> - Bug 65012 - Better handling of displaying long comments in the GUI

> Non-functional changes

> - Updated SaxonHE to 9.9.1-8 (from 9.9.1-7)
> - Updated asm to 9.0 (from 7.3.1)
> - Updated bouncycastle to 1.67 (from 1.66)
> - Updated caffeine to 2.8.8 (from 2.8.0)
> - Updated commons-codec to 1.15 (from 1.14)
> - Updated commons-io to 2.8.0 (from 2.7)
> - Updated commons-net to 3.7.2 (from 3.7)
> - Updated jackson to 2.10.5 (from 2.10.3)
> - Updated junit to 4.13.1 (from 4.13)
> - Updated ph-commons to 9.5.1 (from 9.4.1)
> - Updated ph-css to 6.2.3 (from 6.2.1)
> - Updated groovy to 3.0.7 (from 3.0.5)
> - Updated xstream to 1.4.15 (from 1.4.14)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 64955 - Keystore password not reset on reload
> - Bug 65002 - HTTP(S) Test Script recorder creates an invalid Basic authentication URL. Contributed by Ubik Load Pack (https://ubikloadpack.com)
> - Bug 65004 - HTTP(S) Test Script recorder computes wrong HTTP Request breaking the application. Contributed by Ubik Load Pack (https://ubikloadpack.com)
> - Bug 64543 - On MacOSX, Darklaf- IntelliJ Theme throws NPE in javax.swing.ToolTipManager.initiateToolTip
> - Bug 65024 - Sending mime type with parameter throws IllegalArgumentException
> - Bug 65029 - Try harder to correctly guess the URL for applets, when download embedded URLs is enabled

> ### Other Samplers

> - Bug 65034 - Ignore `SocketTimeoutException` on `BinaryTCPClientImpl`, when no EOM Byte is set. Regression introduced by commit c190641e4f0474a34a366a72364b0a8dd25bfc81 which fixed Bug 52104 - . That bug was bout handling the case of waiting for an EOM.

> ### Listeners

> - Bug 64821 - When importing XML formatted jtl files, sub samplers will get renamed
> - Bug 65052 - XPath2 Tester and JSON JMESPath Tester are missing in `view.results.tree.renderers_order` property

> ### Documentation

> - Bug 64960 - Change scheduler reference in Thread Group documentation. Contributed by Ori Marko
> - Bug 65006 - Illustration for completed HTTP Request Defaults element (Figure 4.4) contains misleading info

> ### General

> - Bug 64957 - When importing example test plan JMeter displays an NullPointerException
> - Bug 64961 - Darklaf: On Windows 7, NPE in BasicEditorPaneUI.cleanDisplayProperties with Darklaf Intellij
> - Bug 64963 - Blank comment tooltip is visible
> - Bug 64969 - RemoteJMeterEngineImpl#rexit doesn't unexport RemoteJMeterEngineImpl on exit. Contributed by luo_isaiah at qq.com
> - Bug 64984 - Darklaf LAF: Selecting a Test element does not work under certain screen resolutions on Windows. With the help of Jannis Weis
> - Bug 65008 - SampleResult.setIgnore() called from PostProcessor is not considered
> - Bug 64993 - Daklaf LAF: Menu navigation not working with keyboard shortcuts. With the help of Jannis Weis
> - Bug 65013 - POST multipart/form-data cURL code with quoted arguments is not imported correctly

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Ori Marko (orimarko at gmail.com)
> - 罗寅卓 (luo_isaiah at qq.com)
> - Ubik Load Pack
> - Jannis Weis

> We also thank bug reporters who helped us improve JMeter.

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.13.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.0/nashorn-core-15.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.0/asm-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.0/asm-commons-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.0/asm-util-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.0/asm-tree-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.0/asm-analysis-9.0.jar
>         popd
>         export JVM_ARGS="--modulepath $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.4

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> UX improvements

> Bug 62179 - Bug 64658 - The splash screen is now application-modal rather than system-modal, so it does not block other applications when JMeter is starting up.

> Incompatible changes

> - Remove LogKit logger functionality from some classes. This was intended to completely remove `LoggingManager` class (it has been deprecated since JMeter 3.2), but as jmeter-plugins depended on it, `LoggingManager` and our `LogKit`-adapter will remain for this version (but is still deprecated).

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 53848 - Bug 63527 - Implement a new setting to allow the exclusion of embedded URLs
> - Bug 64696 - Pull request #571 - Pull request #595 - Freestyle format for names in (Default)SamplerCreater. Based on a patch by Vincent Daburon (vdaburon at gmail.com)
> - Bug 64752 - Add GraphQL/HTTP Request Sampler. Contributed by woonsan.

> ### Other samplers

> - Bug 64555 - Set JMSType header field through JMSProperties. Contributed by Daniel van den Ouden

> ### Controllers

> ### Listeners

> - Pull request #544 - Add BackendListener that sends "raw" results to InfluxDB. Contributed by Graham Russell (graham at ham1.co.uk)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> ### Functions

> ### I18N

> ### Report / Dashboard

> - Bug 64824 - Dashboard/HTML Report: Rename `KO` to `FAIL`
> - Bug 64936 - Increase generate_report_ui.generation_timeout to 5 minutes to handle large performance test

> ### General

> - Bug 64446 - Better parse curl commands with backslash at line endings and support `PUT` method with data arguments
> - Pull request #599 - Ensure all buttons added to the toolbar behave/look consistently. Contributed by Jannis Weis
> - Bug 64581 - Allow `SampleResult#setIgnore` to influence behaviour on Sampler Error
> - Bug 64680 - Fall back to `JMETER_HOME` on startup to detect JMeter's installation directory
> - Bug 64787 - Pull request #630 - Add Korean translation. Contributed by Woonsan Ko (woonsan at apache.org)
> - Bug 64776 - Add the ability to install additional SecurityProvider. Contributed by Timo (ASF.Software.Timo at Leefers.eu)

> Non-functional changes

> - Build system upgraded from Gradle to 6.7 (from 6.6)
> - Pull request #594 - Updated neo4j-java-driver to 4.2.0 (from 1.7.5)
> - Bug 64454 - More precise error message, when no datasource value can be found in JDBC sampler
> - Bug 64440 - Log exeptions reported via `JMeterUtils#reportToUser` even when in GUI mode
> - Pull request #591 - Remove deprecated sudo flag from travis file. Deng Liming (liming.d.pro at gmail.com)
> - Updated Darklaf to 2.4.10 (from 2.1.1)
> - Updated Groovy to 3.0.5 (from 3.0.3)
> - Pull request #596 - Use neutral words in documentation
> - Bug 63809 - Pull request #557 - Updated commons-collections to 4.4 (from 3.2.2) while keeping the jars for the old commons-collections 3.x for compatibility
> - Pull request #598 - Add another option for creating diffs to the building page. Contributed by jmetertea (github.com/jmetertea)
> - Pull request #609 - Make use of newer API for darklaf installation. Jannis Weis
> - Pull request #612 - Correct typos in `README.md`. Based on patches by Pooja Chandak (poojachandak002 at gmail.com)
> - Pull request #613 - Add documentation for Darklaf properties. Jannis Weis
> - Update SpotBugs to 4.1.2 (from 4.1.1), upgrade spotbugs-gradle-plugin to 4.5.0 (from 2.0.0)
> - Update org.sonarqube Gradle plugin to 3.0 (from 2.7.1)
> - Update Apache ActiveMQ to 5.16.0 (from 5.15.11)
> - Update Bouncycastle to 1.66 (from 1.64)
> - Update Apache commons-io to 2.7 (from 2.6)
> - Update Apache commons-lang3 to 3.11 (from 3.10)
> - Update Apache commons-net to 3.7 (from 3.6)
> - Update Apache commons-pool2 to 2.9.0 (from 2.8.0)
> - Update Apache commons-text to 1.9 (from 1.8)
> - Update equalsverifier to 3.4.2 (from 3.1.13)
> - Update junit5 to 5.6.2 (from 5.6.0)
> - Update Apache log4j2 to 2.13.3 (from 2.13.1)
> - Update rsyntaxtextarea to 3.1.1 (from 3.1.0)
> - Update JUnit5 to 5.7.0 (from 5.6.2)
> - Update Rhino to 1.7.13 (from 1.7.12)
> - Update XStream to 1.4.14 (from 1.4.14.1)
> - Update Apache commons-dbcp2 to 2.8.0 (from 2.7.0)
> - Pull request #635 - Correct some image ratios in the documentation. Patch provided by Vincent Daburon (vdaburon at gmail.com)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 64479 - Regression: HTTP(s) Script Recorder prevents proper shutdown in non-GUI mode
> - Bug 64653 - Exclude Javascript and JSON from parsing for charsets from forms by proxy

> ### Other Samplers

> ### Controllers

> - Bug 64795 - Generate summary report may not output a summary line in the configured interval (`summariser.interval`): Clarify documentation

> ### Listeners

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 64638 - JSON JMESPath Assertion / JSON Assertion: Opening GUI shows a horizontal scrollbar that keeps sliding
> - Bug 64915 - JMeter Cache Manager misbehaving when "Use Cache-Control/Expires header" is checked

> ### Functions

> ### I18N

> ### Report / Dashboard

> - Bug 64547 - Report/Dashboard: Ensure graphs Response codes per second is not broken by empty response code in SampleResult. Contributed by Ubik Load Pack (https://ubikloadpack.com)
> - Bug 64617 - HTML report: In graph Response Time Percentiles Over Time 90,95,99th percentile correspond in reality to 0.90, 0.95 and 0.99 percentiles
> - Bug 64553 - When using Transaction Controller, send Bytes and Received Bytes are displayed as 0 in the influxdb(BackendListener)
> - Bug 64624 - Use less aggressive escaping for JSON Strings in reports error messages

> ### Documentation

> - Pull request #571 - Correct documented name of generated CA when using proxy script recorder. Part of a bigger PR. Vincent Daburon (vdaburon at gmail.com)
> - Change documentation of the special header functionality of the mirror server to reflect the implementation.

> ### General

> - Bug 64448 - User Defined Variable Duplication in Right Click Context Menu
> - Bug 64499 - Exiting JMeter when `jmeterengine.stopfail.system.exit=true` takes too much time if threads are not stopped
> - Bug 64510 - Darklaf- IntelliJ Theme throws NPE in DarkTreeUI on MacOS
> - Bug 64594 - Unable to enter variable values instead of numeric values in components using PowerTableModel (Impacts 3rd party plugins like Throughput Shaping Timer)
> - Bug 64475 - Menu Generate HTML Report: When report generation fails due to timeout, error message is not explicit. Contributed by Ubik Load Pack (https://ubikloadpack.com)
> - Bug 64627 - Programmatic manipulation of the control flow via API methods of JMeterContext is not working as it used to before 5.0. Contributed by Till Neunast
> - Bug 64647 - groovy-dateutil is missing in distribution
> - Bug 64640 - Darklaf: NPE at com.github.weisj.darklaf.ui.DarkPopupFactory.getPopupType(DarkPopupFactory.java:96)
> - Bug 64641 - Darklaf: NPE at com.github.weisj.darklaf.ui.tree.DarkTreeUI.isChildOfSelectionPath(DarkTreeUI.java:603) ~[darklaf-core-2.4.2-SNAPSHOT.jar:2.4.2-SNAPSHOT]
> - Bug 64453 - Darklaf: Save Test Plan as New Folder failure
> - Bug 64625 - Darklaf: trying to select a folder in Browse leads to an error popup and stacktrace
> - Bug 64711 - Textarea Colors are not good in dark modes. Contributed by Jannis Weis
> - Bug 64935 - A broken plugin class should not prevent JMeter from starting

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Michael Weidmann (https://github.com/michaelweidmann)
> - Deng Liming (liming.d.pro at gmail.com)
> - jmetertea (https://github.com/jmetertea)
> - Ubik Load Pack
> - Jannis Weis
> - Daniel van den Ouden
> - Till Neunast (https://github.com/tilln)
> - Pooja Chandak (poojachandak002 at gmail.com)
> - Vincent Daburon (vdaburon at gmail.com)
> - Woonsan Ko (woonsan at apache.org)
> - Timo (ASF.Software.Timo at Leefers.eu)
> - Graham Russell (graham at ham1.co.uk)

> We also thank bug reporters who helped us improve JMeter.

> - Hiroyoshi Mitsumori (mitsumori at mis.dev)

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> - With Java 15 the JavaScript implementation Nashorn has been removed. To add back a JSR-223 compatible JavaScript engine you have two options:
>   Use Mozilla Rhino
>     Copy rhino-engine-1.7.13.jar into `$JMETER_HOME/lib/ext`.
>   Use OpenJDK Nashorn
>     The OpenJDK Nashorn implementation comes as a module. To use it, you will have to download it and add it to the module path. A hacky way to download the version 15.0 and its dependencies and set the module path is outlined below:

>         mkdir lib/modules
>         pushd lib/modules
>         wget https://repo1.maven.org/maven2/org/openjdk/nashorn/nashorn-core/15.0/nashorn-core-15.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm/9.0/asm-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-commons/9.0/asm-commons-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-util/9.0/asm-util-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-tree/9.0/asm-tree-9.0.jar
>         wget https://repo1.maven.org/maven2/org/ow2/asm/asm-analysis/9.0/asm-analysis-9.0.jar
>         popd
>         export JVM_ARGS="--modulepath $PWD/lib/modules"
>         ./bin/jmeter

> # Version 5.3

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> UX improvements

> Darklaf

> Tree indentation level is easier to follow:

> JMeter tree with Darklaf Darcula theme

> JMeter tree with Darklaf IntelliJ theme

> New look and feel themes. Light: IntellJ, Solarized Light, HighContrast Light. Dark: OneDark, Solarized Dark, HighContrast Dark.

> When an element in tree is disabled, all its descendants are shown in gray. For instance, `While Contoller` is disabled in the following tree, so its children are gray. It is purely a UI change, and the behavior is not altered.

> While controller is disabled, so its children are gray

> Tree context menu is shown even in case the node selection is changed. Previously the popup did disappear and it was required to select a node first and only then launch popup.

> Look and feel can now be updated without a restart

> Use CTRL + ALT + wheel for zooming fonts. Previous shortcut was CTRL + SHIFT + wheel, however, it conflicted with horizontal scrolling.

> In-app zoom is more consistent (e.g. sometimes not all the labels or even panels were scaled). For instance: log viewer, JSR223 code editor were not previously scaled with zoom-in/out feature

> Tree context menu is shown for the full row, not for the label only

> Undo and redo support for editable fields. Keystrokes are CTRL + Z / CTRL + SHIFT + Z, or CMD + Z/ CMD + SHIFT + Z depending on the operating system. Undo is implemented on a field level basis (each fields has its own history), and the history is invalidated when tree selection changes.

> Mark the currently selected language in the options menu.

> Mark the currently selected log level in the options menu.

> Rework of many Test Element UI (JUnit Request, ForEach Controller, If Controller, Throughput Controller, WhileController, Counter Config, XPath2 Extractor, Function Helper Dialog, Search popup, JMS Elements)

> Incompatible changes

> - Default value of `httpclient4.time_to_live` has been modified from `2000` to `60000`, this means HTTP connections will live longer than before. This has impact on connection creation and SSL handshake, see Bug 64289
> - The update to Groovy 3 (Pull request #590 - ) might break some old Groovy code of your tests. Have a look at the update notes for Groovy 3

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 64160 - Test HTTP/S Test Script Recorder: Name transaction controller/ simple controller using prefix without "`-XXXX`" suffix
> - Bug 64289 - Make `httpclient4.time_to_live` to `60000` to be closer to typical browser behavior

> ### Other samplers

> - Bug 64288 - JUnit Request: Improve UX
> - Bug 64407 - Improve JMS Publisher UX. Contributed by Ubik Load Pack (https://ubikloadpack.com)
> - Bug 64408 - Improve JMS Subscriber UX. Contributed by Ubik Load Pack (https://ubikloadpack.com)

> ### Controllers

> - Bug 64277 - ForEach Controller: Improve UX
> - Bug 64280 - If Controller: Improve UX
> - Bug 64282 - Throughput Controller: Improve UX
> - Bug 64287 - WhileController: Improve UX

> ### Listeners

> - Bug 64150 - View Results Tree: Allow editing of response data in testers
> - Bug 63822 - View Results Tree: Keep position of split pane while switching renderer mode

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 64091 - Precise Throughput Timer schedule generation is improved significantly (e.g. 2 seconds for 10M samples)
> - Bug 64281 - Counter Config: Improve UX
> - Bug 64283 - XPath2 Extractor: Improve UX

> ### Functions

> - Bug 64070 - `_timeshift` function does not work with offset formatters
> - Bug 64275 - Function Helper Dialog: Improve UX

> ### I18N

> - Bug 64102 - Add Chinese translation for Tools menu. Contributed by Liu XP (liu_xp2003 at sina.com)

> ### Report / Dashboard

> - Bug 64380 - Add a '`Median`' field to the dashboard and make the response time percentile fields support floating-point numbers. Contributed by Keith Mo(https://github.com/keithmork)
> - Bug 64378 - HTML report generation should not fail if a plugin has registered a graph and is not more present in classpath, issue a warning instead

> ### General

> - Bug 63458 - Pull request #551 - Add new template "Functional Testing Test Plan [01]". Contributed by Sebastian Boga (sebastian.boga at endava.com)
> - Bug 64119 - Use first renderer from `view.results.tree.renderers_order` property as default in View Results Tree
> - Bug 64148 - Use gray icons for disabled elements in the tree, display subtree as gray
> - Bug 64198 - Allow spaces in `${...}` expressions around functions.
> - Bug 64276 - Search popup: Improve UX
> - Pull request #573 - Improve the startup time: skip test plan UI initialization
> - Pull request #585 - Added JEXL3 as a syntax alias for JSyntaxTextArea. Contributed by drivera-armedia (https://github.com/drivera-armedia)
> - Pull request #590 - Update Groovy to 3.0.3.

> Non-functional changes

> - Build system upgraded from Gradle to 6.3 (from 6.1), Java 14 can be used now for the build
> - Bug 63963 - Pull request #546 - Updated jackson to 2.10.3 (from 2.9.10)
> - Bug 64120 - Updated jsoup to 1.13.1 (from 1.12.1)
> - Bug 63809 - Updated commons-dbcp2 to 2.7.0 (from 2.5.0)
> - Updated Apache ActiveMQ to 5.15.11 (from 5.15.8)
> - Updated bouncycastle to 1.64 (from 1.60)
> - Updated asm to 7.3.1 (from 7.1)
> - Updated Apache commons-codec to 1.14 (from 1.13)
> - Updated Apache commons-pool to 2.8.0 (from 2.7.0)
> - Updated equalsverifier to 3.1.9 (from 3.1.12)
> - Updated Apache Groovy to 2.4.18 (from 2.4.16)
> - Updated hsqldb to 2.5.0 (from 2.4.1)
> - Updated hamcrest to 2.2 (from 2.1)
> - Updated Apache httpclient and httpmime to 4.5.12 (from 4.5.10)
> - Updated Apache httpcore and httpcore-nio to 4.4.13 (from 4.4.12)
> - Updated Apache Tika to 1.24.1 (from 1.22)
> - Updated jmespath to 0.5.0 (from 0.3.0)
> - Updated Apache log4j to 2.13.1 (from 2.12.1)
> - Updated junit4 to 4.13 (from 4.12)
> - Updated junit5 to 5.6.0 (from 5.5.1)
> - Updated slf4j to 1.7.30 (from 1.7.28)
> - Updated ph-commons to 9.4.1 (from 9.3.7)
> - Updated ph-css to 6.2.2 (from 6.2.0)
> - Updated rsyntaxtextarea to 3.1.0 (from 3.0.4)
> - Updated rhino to 1.7.12 (from 1.7.11)
> - Updated SaxonHE to 9.9.1-7 (from 9.9.1-5)
> - Updated cglib to 3.2.12 (from 3.2.9)
> - Updated commons-lang3 to 3.10 (from 3.9)
> - Updated freemarker to 2.3.30 (from 2.3.29)
> - Updated hamcrest-date to 2.0.7 (from 2.0.4)
> - Updated equalsverifier to 3.1.13 (from 3.1.12)
> - Updated xstream to 1.4.11.1 (from 1.4.11)
> - Pull request #559 - Add a note to the source of TrustAllSSLSocketFactory, that it is not secure to trust everyone. Based on a PR from YYTVicky (yytvicky at github)
> - Pull request #588 - Add documentation on usage of InfluxDB v2 for real-time results. Based on PR from Jakub Bednář (jakub.bednar at gmail.com)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 64400 - Make sorting recorded samples into transaction controllers more predictable
> - Bug 64267 - When preemptive auth is disabled HTTP Sampler does not automatically respond to Basic Auth challenge

> ### Other Samplers

> ### Controllers

> ### Listeners

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 64091 - Precise Throughput Timer might produce less samples when low test duration is used
> - Bug 64142 - Presence of DebugPostProcessor in Test plan breaks ActiveThread Over time in report due to missing information
> - Bug 64196 - Recurse into sub samplers more deeply when checking assertions
> - Bug 64196 - Recurse into sampleResults for `AbstractScopedTestElement#getSampleList`
> - Bug 64381 - PreciseThroughputTimer: On termination, log message contains negative value

> ### Functions

> ### I18N

> ### Report / Dashboard

> - Bug 64059 - Response Time Percentiles Over Time, unable to change the percentiles

> ### Documentation

> - Pull request #547 - Correct Log level documentation. Contributed by jmetertea
> - Pull request #548 - Correct typos in documentation. Contributed by jmetertea
> - Bug 64022 - Correct Chinese translation for "Ignore Sub-Controller blocks". Provided by yangxiaofei77 (yangxiaofei77 at gmail.com)
> - Pull request #552 - Fix `client.rmi.localport` port allocation description. Contributed by anant-93
> - Pull request #543 - Clarify documentation of `__StringToFile` function regarding default value of `Append to file?` parameter. Contributed by Ori Marko
> - Bug 64302 - Correct links to JMeter API in printable docs and BeanShell best practices and to JavaFX implementation website in all docs. Reported by 2477441814 (2477441814 at qq.com)

> ### General

> - Bug 63945 - NPE when opening a file after file system change
> - Bug 64034 - Shell scripts fail if space in `JAVA_HOME` path. Contributed by ray7219 (ray7219 at hotmail.com)
> - Bug 63856 - Set `connectTime` on parent samples when using a transaction controller
> - Bug 64227 - Error when loading Templates on Windows
> - TestPlan UI: skip adding the entry to the classpath if the user clicks cancel

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Jannis Weis
> - Stefan Seide (stefan at trilobyte-se.de)
> - jmetertea
> - ray7219
> - Sebastian Boga (sebastian.boga at endava.com)
> - Liu XP (liu_xp2003 at sina.com)
> - anant-93 (https://github.com/anant-93)
> - Ori Marko (orimarko at gmail.com)
> - Keith Mo(https://github.com/keithmork)
> - drivera-armedia (https://github.com/drivera-armedia)
> - Ubik Load Pack
> - Jakub Bednář (jakub.bednar at gmail.com)

> We also thank bug reporters who helped us improve JMeter.

> - Michael McDermott (mcdermott.michaelj at gmail.com)
> - yangxiaofei77 (yangxiaofei77 at gmail.com)
> - Markus Wolf (wolfm at t-systems.com)
> - Pierre Astruc (pierre.astruc at evertest.com)
> - YYTVicky (yytvicky at github)
> - 2477441814 at qq.com

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> # Version 5.2.1

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> This release is a minor bugfix release. Please see the Changes history page to view the last release notes of version 5.2.

> Incompatible changes

> Improvements

> ### HTTP Samplers and Test Script Recorder

> ### Other samplers

> - Bug 63926 - JDBC Connection Configuration: Add ability to set connection properties

> ### Controllers

> ### Listeners

> ### Timers, Assertions, Config, Pre- & Post-Processors

> ### Functions

> ### I18N

> ### Report / Dashboard

> ### General

> Non-functional changes

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> ### Other Samplers

> ### Controllers

> ### Listeners

> - Bug 63906 - NPE for InfluxDB backend listener during failover testing

> ### Timers, Assertions, Config, Pre- & Post-Processors

> ### Functions

> ### I18N

> ### Report / Dashboard

> ### Documentation

> ### General

> - Bug 63910 - Broken maven poms in released 5.2 version
> - Bug 63911 - ApacheJMeter_config.jar content has changed (bin moved to run and missing files)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Vincent Lee

> We also thank bug reporters who helped us improve JMeter.

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> # Version 5.2

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> This release is a major release. Please see the Changes history page to view the last release notes of version 5.1.1.

> Incompatible changes

> - HTTP(S) Test Script Recorder now appends number at end of names, while previously it added it at beginning. See Bug 63450
> - When using XPath Assertion with an XPath expression returning a boolean, `True if nothing matches` had no effect and always returned true, see Bug 63455
> - XML parsing now refuses unsecure XML, this has impacts on the following features:
>   - XMLAssertion
>   - XMLSchemAssertion
>   - XPath function
>   - XPath 1 & 2 Extractors
>   - XPath 1 & 2 Assertions

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 63450 - HTTP(S) Test Script Recorder: Put number at end instead of beginning
> - Bug 63790 - Embedded Resources download: Optimize CSS parsing by removing source location

> ### Other samplers

> - Bug 63406 - JDBC connection configuration: new option for pre-initialize to initialize the connection pool. Contributed by Franz Schwab (franz.schwab at exasol.com)
> - Bug 63561 - JDBC Request: Allow to only fetch a certain number of rows. Contributed by Franz Schwab (franz.schwab at exasol.com)
> - Bug 63801 - Add Bolt protocol support for Neo4j database. Contributed by GraphAware (www.graphaware.com)

> ### Controllers

> - Bug 63565 - If Controller: GC issue with JMeter during the endurance run when using with "Interpret Condition as Variable Expression?" unchecked => Improve documentation

> ### Listeners

> - Bug 63720 - BackendListener: InfluxDBBackendListenerClient Add support for InfluxDB 2. Contributed by Jakub Bednář (https://github.com/bednar)
> - Bug 63770 - View Results Tree: Add JMESPath Tester. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 62863 - Enable PKCS11 keystores for usage with KeyStore Manager. Based on patch by Clifford Harms (clifford.harms at gmail.com).
> - Pull request #457 - Slight performance improvement in PoissonRandomTimer by using ThreadLocalRandom. Based on a patch by Xia Li.
> - Bug 62787 - New `XPath2 Assertion` supporting XPath2 with better performances than `XPath Assertion`. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63643 - Skip BOM on files opened through `FileServer` and use the BOM to detect the character encoding, if none is given explicitly. Reported by Havlicek Honza (havlicek.honza at gmail.com)
> - Bug 63727 - New `JMESPath Extractor` element to ease extraction from JSON using JMESPath technology. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63763 - New `JMESPath Assertion` element to ease assertion on JSON using JMESPath technology. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63775 - Allow Boundary Extractor to accept empty boundaries

> ### Functions

> - Bug 63219 - New function `__StringToFile` to save/append a string into a file. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Use `AtomicInteger` for `__counter` instead of synchronization on our own

> ### I18N

> ### Report / Dashboard

> - Bug 63471 - `StringConverter`s used for report generation should ignore white space around numbers.

> ### General

> - Bug 63396 - JSR223 Test Elements: Description of Parameters is misleading, same for Script
> - Bug 63480 - XPathAssertion and XPathAssertion2: Improve test coverage for input coming from variable. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63452 - Tools / Import from cURL: Complete coverage of all command line options that are valid in JMeter use case. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63419 - Tools / Import from cURL: Add ability to import a set of cURL commands from a file. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63760 - JOrphanUtils: add random alphanumeric password generator
> - Bug 63355 - View Results Tree: Browser view option is not Available since Java 11, document how to make it available, see this
> - Bug 62861 - Thread Group: Provide ability to configure whether a new iteration is a new user or same user (Would be applied on Cookie Manager, Cache Manager and httpclient.reset_state_on_thread_group_iteration). Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63616 - Fix Javadoc:

>       JMeterContext#getThreadNum()

>   starts at 0 and not 1. Contributed by Ori Marko (orimarko at gmail.com)
> - Updated to httpclient/httpmime 4.5.10 (from 4.5.7)
> - Updated to dnsjava 2.1.9 (from 2.1.8)
> - Updated to jsoup 1.12.1 (from 1.11.3)
> - Updated to rsyntaxtextarea 3.0.4 (from 3.0.2)
> - Updated to caffeine 2.8.0 (from 2.6.2)
> - Updated to commons-codec 1.13 (from 1.11)
> - Updated to commons-lang3 3.9 (from 3.8.1)
> - Updated to commons-pool 2.7 (from 2.6)
> - Updated to commons-text 1.8 (from 1.6)
> - Updated to freemarker 2.3.29 (from 2.3.28)
> - Updated to httpcore/httpcore-nio 4.12 (from 4.11)
> - Updated to jodd 5.0.13 (from 5.0.6)
> - Updated to log4j 2.12.1 (from 2.11.1)
> - Updated to ph-commons 9.3.7 (from 9.2.1)
> - Updated to ph-css 6.2.0 (from 6.1.1)
> - Updated to Mozilla Rhino 1.7.11 (from 1.7.10)
> - Updated to Saxon-HE 9.9.1-5 (from 9.9.1-1)
> - Updated to slf4j 1.7.28 (from 1.7.25)
> - Updated to tika-core and tika-parsers 1.22 (from 1.21)
> - Updated jackson-annotations, jackson-core and jackson-databind to 2.9.10 (from 2.9.8)

> Non-functional changes

> - Migrated from subversion to Git
> - Bug 63630 - Switch build from Apache Ant to Gradle
> - Bug 63529 - Add more unit tests for org.apache.jorphan.util.JOrphanUtils. Contributed by John Bergqvist(John.Bergqvist at diffblue.com)
> - Updated to latest checkstyle (version 8.22)
> - Clean-up of code in `CompareAssertion` and other locations. Based on patch by Graham Russell (graham at ham1.co.uk)
> - Pull request #491 - Increase Graphite metrics coverage. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #520 - Replace anonymous classes with lambda expressions. Contributed by Graham Russell (graham at ham1.co.uk).
> - Pull request #524 - Migration from JUnit 4 to JUnit 5. Contributed by Graham Russell (graham at ham1.co.uk).

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 63298 - HTTP Requests with encoded URLs are being sent in decoded format
> - Bug 63364 - When setting `subresults.disable_renaming=true`, sub results are still renamed using their parent SampleLabel while they shouldn't. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63129 - JMeter can not identify encoding during first time page submission. Based partly on analysis and PR made by Naveen Nandwani (naveen.nandwani at india.nec.com)
> - Bug 62672 - HTTP Request sends double requests when using proxy with authentication. Based on patch by Artem Fedorov (artem.fedorov at blazemeter.com) and contributed by BlazeMeter.
> - Bug 63574 - HTTP Cache Manager does not cache resource if `Cache-Control` header is missing.

> ### Other Samplers

> - Bug 63442 - Reduce scanning for `LogParser` implementations in AccessLogSamplerBeanInfo.
> - Bug 63563 - LdapExtSampler: When sampler fails with exception differing from NamingException, no SampleResult is generated
> - Bug 63469 - JMSPublisher: Race condition in jms.client.ClientPool#clearClient

> ### Controllers

> ### Listeners

> - Bug 63319 - `ArrayIndexOutOfBoundsException` in Aggregate Graph when selecting 90 % or 95 % columns
> - Bug 63423 - Selection of table rows in Aggregate Graph gets lost too often
> - Bug 63347 - View result tree: The search field is so small that even a single character is not visible on Windows 7
> - Bug 63433 - ListenerNotifier: Detected problem in Listener NullPointerException if filename is null. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63674 - Strip results with subresults deeper in their hierarchy when DataStripping is enabled

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 63455 - XPath Assertion: `True if nothing matches` does not work if XPath expression returns a boolean. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Functions

> ### I18N

> ### Report / Dashboard

> ### Documentation

> - Bug 63513 - Add MariaDB examples to JDBC documentation. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 63484 - Add notes to use Apache Velocity as JSR223 script language. Based on a patch by Ori Marko (orimarko at gmail.com)
> - Bug 63519 - Pull request #471 - Use correct method `getLabelResource()` in JMeter tutorial. Contributed by Sun Tao (buzzerrookie at hotmail.com>)

> ### General

> - Bug 63394 - JMeter should fail with non-zero when test execution fails (due to missing test plan or other reason). Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63464 - image/svg+xml is wrongly considered as binary
> - Bug 63490 - At end of scheduler duration lots of Samplers gets executed at the same time
> - Pull request #480 - Pull request #482 - Fix a few typos in comments and log messages. Based on patch by Anass Benomar (anassbenomar at gmail.com)
> - Bug 63751 - Correct a typo in Chinese translations. Reported by Jinliang Wang (wjl31802 at 126.com)
> - Bug 63723 - Distributed testing: JMeter controller node ends distributed test though some threads still are active
> - Bug 63614 - Distributed testing: Unable to generate Dashboard report at end of load test
> - Bug 63862 - Search Dialog / Search in View Results Tree: Uncaught exception if regex is checked and regex is invalid
> - Bug 63793 - Fix unsecure XML Parsing

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Clifford Harms (clifford.harms at gmail.com)
> - Ubik Load Pack
> - Xia Li
> - Naveen Nandwani (naveen.nandwani at india.nec.com)
> - Artem Fedorov (artem.fedorov at blazemeter.com)
> - Ori Marko (orimarko at gmail.com)
> - Sun Tao (buzzerrookie at hotmail.com)
> - John Bergqvist (John.Bergqvist at diffblue.com)
> - Franz Schwab (franz.schwab at exasol.com)
> - Graham Russell (graham at ham1.co.uk)
> - Anass Benomar (anassbenomar at gmail.com)
> - Jakub Bednář
> - Pascal Schumacher (pascalschumacher at apache.org)
> - GraphAware

> We also thank bug reporters who helped us improve JMeter.

> - Sergiy Iampol (sergiy.iampol at playtech.com)
> - Brian Tully (brian.tully at acquia.com)
> - Amer Ghazal (amerghazal at gmail.com)
> - Stefan Seide (stefan at trilobyte-se.de)
> - Havlicek Honza (havlicek.honza at gmail.com)
> - Pierre Astruc (pierre.astruc at evertest.com)
> - Jinliang Wang (wjl31802 at 126.com)

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.
> - Since Java 11 the JavaScript implementation Nashorn has been deprecated. Java will emit the following deprecation warnings, if you are using JavaScript based on Nashorn.

>       Warning: Nashorn engine is planned to be removed from a future JDK release

>   To silence these warnings, add `-Dnashorn.args=--no-deprecation-warning` to your Java arguments. That can be achieved by setting the enviroment variable `JVM_ARGS`

>       export JVM_ARGS="-Dnashorn.args=--no-deprecation-warning"

> # Version 5.1.1

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> This release is mainly a bugfix release. Please see the Changes history page to view the last major behaviors with the version 5.1.

> Live Reporting and Web Report

> A new menu entry has been added to the Tools menu. It's allow to generate a results report from a previous CSV/JTL file.

> Incompatible changes

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 62977 - Allow sending HTTP requests without a default User-Agent header

> ### Other samplers

> - Bug 63185 - LDAP related elements: Add option to implicitly trust SSL/TLS connections/Disable hostname verification. Based on contribution by Brian Wolfe (wolfebrian2120 at gmail.com)

> ### Controllers

> ### Listeners

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 63178 - CSS Selector Extractor: Improve performance of JODD (JoddExtractor) based implementation

> ### Functions

> ### I18N

> ### Report / Dashboard

> - Bug 59896 - Report / Dashboard: Add a menu entry to generate a report on demand from a CSV file. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### General

> - Pull request #444 - Update to latest Spock v1.2 (was 1.0). Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #446 - Improve Unit tests readability and use of Spock. Contributed by Graham Russell (graham at ham1.co.uk)

> Non-functional changes

> - Bug 63203 - Unit Tests: Replace use of `@Deprecated` by `@VisibleForTesting` for methods/constructors/classes made public for Unit Testing only
> - Pull request #449 - Refactor and Test ResponseTimePercentilesOverTimeGraphConsumer. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #450 - Abstract graph consumer improvements. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #451 - Improve a few unit tests and classes. Contributed by Graham Russell (graham at ham1.co.uk)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> ### Other Samplers

> - Bug 63202 - JMS Publisher: ObjectMessageRenderer creates XStream instance with uninitialized security

> ### Controllers

> ### Listeners

> - Bug 63204 - `RenderAsJSON#prettyJSON`: `JSONParser#parse` cannot return JSONValue

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 62446 - Counter documentation is wrong in required fieds. Contributed by orimarko at gmail.com
> - Bug 62327 - TestPlan: In library table if path is modified and plan saved, the modification is lost on file reload

> ### Functions

> - Bug 63241 - `__threadGroupName` causes a NullPointerException if called from non Test threads

> ### I18N

> ### Report / Dashboard

> - Bug 63198 - Response Time Vs Request and Latency Vs Request graphs don't line up with throughput. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Documentation

> ### General

> - Bug 63201 - SearchTreeDialog disappears behind master JFrame. Contributed by Benoit Vatan (benoit.vatan at gmail.com)
> - Bug 63220 - `Function Helper Dialog`, `Export transactions for report` and `Import from cURL` disappear being master JFrame. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63207 - java.lang.NullPointerException: null when run JMeter 5.1 with proxy options
> - Bug 58183 - Rampup may not be respected if thread take time to start leading to threads continuing to start post ramp up time

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Ubik Load Pack
> - Benoit Vatan (benoit.vatan at gmail.com)
> - Graham Russell (graham at ham1.co.uk)
> - Brian Wolfe (wolfebrian2120 at gmail.com)
> - orimarko at gmail.com

> We also thank bug reporters who helped us improve JMeter.

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 5.1

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> Core improvements

> JDBC testing has been improved with ability to set init SQL statements and add compatibility with JDBC drivers that do not support QueryTimeout

> - Various bug fixes have been implemented, like gathering the correct headers when recording requests through the HTTP(S) Test Script Recorder using HTTPS
> - In version 5.0, JMeter was changed to rename Sub results using a custom Naming Policy (Bug 62550 ). This change could be annoying for Functional Testing, a new property `subresults.disable_renaming=true` has been introduced to revert if needed to previous behaviour. An alternative is to check `Functional Test Mode` in Test Plan, see Bug 63055

> UX improvements

> Templates can provide parameters that are filled in on test plan generation, `Recording` template uses this feature

> A new `Tools` menu has been introduced to collect those entries, that are used for general usage around JMeter, like:

> - `Function Helper Dialog`
> - `Export transactions for report`
> - `Generate Schematic View` which provides an overview as HTML of the Test plan
> - `Import from cURL` which allows you to create or update your test plan by importing a cURL command
> - `Compile JSR223 Test Elements`
> - `Create a heap dump`
> - `Create a thread dump`

> Test Plan

> Ability to create a Test plan from a cURL command.

> Scripting / Debugging enhancements

> - A menu item to compile all JSR223 Elements is now available in `Tools` menu

> Live Reporting and Web Report

> - A JSON file containing summary of a load test statistics is now generated when using `-e` or `-g` options.
> - Percentiles computing graphed over time algorithm has been modified to restart for each time slot
> - More user-friendly behaviour when reporting folder does not exist or is not empty through `-f` command line option

> Incompatible changes

> - In `Response Time Percentiles Over Time (successful responses)` graph of the HTML report, before this version, percentile computation of each time slot used the percentile data of previous time slot as a base. Starting with this version, each time slot is independant. See Bug 62883
> - `ClientJMeterEngine#rsetProperties` signature has been changed to use `HashMap<String,String>` instead of Properties, see Bug 63034
> - A new Menu item `Tools` has been introduced, some menu items that were in `Help` menu are now under this new menu item. See Bug 63094
> - `slf4j-ext` has been removed from libraries (lib folder) and JMeter pom. It was not used by default and due to CVE-2018-8088 and unavailability of a stable version containing a fix to this issue, we decided to remove it. If you still needed, you can add it in lib folder.

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 62840 - HTTP Request: Add option `httpclient4.gzip_relax_mode` to avoid error when unzipping what seems to be invalid streams
> - Bug 63025 - Enhance Search & Replace functionality for HTTP Request to include port and protocol field. Initial code fix by Mohamed Ibrahim (rollno748 at gmail.com)

> ### Other samplers

> - Bug 62934 - Add compatibility for JDBC drivers that do not support QueryTimeout
> - Bug 62935 - Pass custom `mail.*` properties to Mail Reader Sampler. Implemented by Artem Fedorov (artem.fedorov at blazemeter.com) and contributed by BlazeMeter.
> - Bug 63055 - Don't rename SampleResult Label when test is running in Functional mode or property `subresults.disable_renaming=true`. Implemented by Artem Fedorov (artem.fedorov at blazemeter.com) and contributed by BlazeMeter.

> ### Controllers

> ### Listeners

> - Bug 62822 - Pull request #407 - Render uninitialized min and max values in Summary Report as `#N/A`

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 62766 - Keystore Config: We should load all aliases by default. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62832 - JDBC Connection Configuration: Be able to set init SQL statements. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Functions

> - Bug 63037 - When using `CSVRead` search the script base path for files, too.

> ### I18N

> ### Report / Dashboard

> - Bug 62883 - Report / Dashboard: Change the way percentiles are computed for Response Time Percentiles Over Time (successful responses) graph
> - Bug 63060 - Report Generator: A generator should only check for folder/files it generates and only delete those ones
> - Bug 63059 - Create a new JsonExporter that exports as JSON the content of data computed for HTML Dashboard Statistics table. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63081 - Command line Option `-f` does not delete report folder when using generation only through command line option `-g`. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### General

> - Bug 62959 - Ability to create a Test plan from a cURL command. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Pull request #394 - Allow `null` values in `FieldStringEditor`. Based on patch by Mingun (alexander_sergey at mail.ru)
> - Bug 62826 - When changing LAF, make JMeter restart if user clicks yes to popup
> - Bug 62257 - Pull request #401 - Expand/Collapse short key - (minus sign) on numpad doesn't work. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 62752 - Add to Documentation: `ctx.getThreadNum()` is zero-based while `${__threadNum}` is one-based
> - Pull request #411 - Use `SHA-1` instead of `SHA1` in `org.apache.jmeter.save.SaveService`. Contributed by Paco (paco.xu at daocloud.io)
> - Bug 62914 - Add a hint in Thread Group UI about duration of test
> - Bug 62925 - Add support for ThreadDump to the JMeter non-GUI
> - Bug 62870 - Templates: Add ability to provide parameters. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62829 - Allow specifying Proxy server scheme for HTTP request sampler, Advanced tab and command line option. Contributed by Hitesh Patel (hitesh.h.patel at gmail.com)
> - Bug 59633 - Menus `Save Test Plan as`, `Save as Test Fragment` and `Save Selection as ...` should use a new file name in File Dialog
> - Bug 61486 - Make jmeter-server and non GUI mode run headless
> - Bug 63093 - Add `Compile JSR223 Test Elements` menu item. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63094 - Introduce a new Tools menu
> - Bug 63101 - Propose a menu item to generate readable overview of Test Plan
> - Bug 63144 - View listener tree take a long time to open response that has huge text. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> Non-functional changes

> - Pull request #408 - Log an informational message instead of an stack trace, when JavaFX is not found for the `RenderInBrowser` component.
> - Pull request #412 - Update Chinese translation. Contributed by 刘士 (liushilive at outlook.com).
> - Pull request #406 - Add a short paragraph on how to use a security manager with JMeter.
> - Bug 62893 - Use StringEscapeUtils from commons-text (version 1.6) instead of the deprecated ones from commons-lang3.
> - Bug 62972 - Pull request #435 - Replace calls to deprecated method `Class#newInstance`.
> - Bug 63034 - ClientJMeterEngine: Make rsetProperties use `HashMap<String,String>` instead of Properties
> - Updated to httpclient/httpmime 4.5.7 (from 4.5.6)
> - Updated to httpcore 4.4.11 (from 4.4.10)
> - Updated to httpcore-nio 4.4.11 (from 4.4.10)
> - Updated to tika-core and tika-parsers 1.20 (from 1.18)
> - Updated to commons-dbcp2-2.5.0 (from commons-dbcp2-2.4.0)
> - Updated to commons-lang3-3.8.1 (from commons-lang3-3.8)
> - Updated to groovy-all-2.4.16 (from groovy-all-2.4.15)
> - Updated to httpasyncclient-4.1.4.jar (from 4.1.3)
> - Updated to jsoup-1.11.3 (from 1.11.2)
> - Updated to cglib-nodep-3.2.9 (from cglib-nodep-3.2.7)
> - Updated to ph-commons-9.2.1 (from ph-commons-9.1.2)
> - Updated to log4j-2.11.1 (from log4j-2.11.0)
> - Updated to xmlgraphics-commons 2.3 (from 2.2)
> - Bug 63033 - Updated to Saxon-HE 9.9.1-1 (from 9.8.0-12). Thanks at Saxonica
> - Updated to xstream 1.4.11 (from 1.4.10)
> - Updated to jodd 5.0.6 (from 4.1.4)
> - Updated to asm-7.0 (from 6.1)
> - Update to ActiveMQ 5.15.8 (from 5.5.16)
> - Updated to rsyntaxtextarea-3.0.2 (from 2.6.1)
> - Updated to apache-rat-0.13 (from 0.12)
> - Updated to jacocoant-0.8.3 (from 0.8.2)
> - Updated to hsqldb-2.4.1 (from 2.4.0)
> - Updated to mina-core-2.0.19 (from 2.0.16)
> - Bug 62818 - Updated to xercesImpl to 2.12.0 (from 2.11.0). Reported by Stefan Seide (stefan at trilobyte-se.de)
> - Bug 62744 - Upgrade jquery to version 3.3.1, jquery-ui to 1.12.1, bootstrap to 3.3.7
> - Bug 62821 - Pull request #405 - Use SHA-512 checksums instead of MD5 to verify jar downloads
> - Bug 63053 - Remove referrals to never implemented internals from user documentation. Reported by U. Poblotzki (u.poblotzki at thalia.de)
> - Bug 63082 - Pull request #437 - Use utf-8 for properties files in source
> - Bug 63177 - Rename NON GUI mode into CLI Mode in documentation

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 62785 - Pull request #400 - Incomplete search path applied to the filenames used in the upload functionality of the HTTP sampler. Implemented by Artem Fedorov (artem.fedorov at blazemeter.com) and contributed by BlazeMeter.
> - Bug 62842 - HTTP(S) Test Script Recorder: Brotli compression is not supported leading to "`Content Encoding Error`"
> - Bug 60424 - Hessian Burlap application: JMeter inserts `0x0D` before `0x0A` automatically (http binary post data)
> - Bug 62940 - Use different `cn` and type of SAN extension when we are generating certificates based on IP addresses.
> - Bug 62916 - HTTP Test Script Recorder fails with UnsupportedOperationException if recording is started after a distributed test has been run
> - Bug 62987 - A TestBean element under HTTP(S) Test Script recorder does not work. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63015 - Abnormal NoHttpResponseException when running request through proxy HTTP(S) Test Script Recorder after a first failing request. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62852 - HTTP Request Header missing information when using a proxy. Thanks to Oleg Kalnichevski (olegk at apache.org)
> - Bug 63048 - JMeter does not retrieve link resources of type "shortcut icon" or "icon". Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Other Samplers

> - Bug 62775 - If many jars are in a folder referenced by `user.classpath`, startup can be extremely slow due to JUnit
> - Bug 63031 - Incorrect JDBC driver class: `org.firebirdsql.jdbc.FBDrivery`. Contributed by Sonali (arora.sonali99 at gmail.com)

> ### Controllers

> - Bug 62806 - ModuleController cloning by Run behaves differently whether in GUI or Non GUI mode. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62847 - If Controller cannot use variable for index exposed by LoopController/WhileController/ForEachController
> - Bug 63064 - Ignore spaces at the end and beginning of expressions used in IfController

> ### Listeners

> - Bug 62770 - Aggregate Graph throws `ArrayIndexOutOfBoundsException`
> - Bug 63069 - ResultCollector does not write end of XML file if user exits while a Recording or a test is running. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 63138 - InfluxDB BackendListenerClient: In case of error, log is in debug, it should be in error

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 62774 - XPath2Extractor: Scope variable is broken. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62860 - JSON Extractor: Avoid NPE and noisy error message "`Error processing JSON content in`" when variable is not found

> ### Functions

> ### I18N

> ### Report / Dashboard

> - Bug 62777 - Web Report / Dashboard: Hide All in `Response Time Percentiles Over Time (successful responses)` fails.
> - Bug 62780 - Web Report / Dashboard: Display All in `Response Time Vs Request` fails.
> - Bug 62781 - Web Report / Dashboard: Display All in `Response Time Overview` fails.
> - Bug 62782 - Web Report / Dashboard: Remove duplicate/unused dependencies
> - Bug 62894 - Report / Dashboard: Throughput is in wrong column which is confusing as unit is millisecond
> - Bug 63016 - Empty HTML report if source csv contains labels with quotes. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Documentation

> - Change `Test Action` (old name) to `Flow Control Action` in Component Reference documentation. Contributed by Ori Marko (orimarko at gmail.com)

> ### General

> - Bug 62745 - Fix undefined disabled icon. Contributed by Till Neunast (https://github.com/tilln)
> - Bug 62743 - Client auth must be enabled on distributed testing
> - Bug 62767 - NPE when searching under certain conditions. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62790 - `ArrayIndexOutOfBoundsException` when calling replace without selecting the first match
> - Bug 62795 - JMeter controller node sometimes ends distributed test even though some of the worker nodes have not finished
> - Bug 62336 - Pull request #396 - Some shortcuts are not working correctly on windows. Contributed by Michael Pavlov (michael.paulau at gmail.com)
> - Bug 62889 - Format JSON Arrays when displayed with JSON Path Tester.
> - Bug 62900 - ObjectProperty#getStringValue() can throw NullPointerException
> - Bug 63099 - Escape commata in function helper dialog only outside of variable replacement structures.
> - Bug 63105 - Export Transactions for Report: fix 2 bugs
> - Bug 63106 - Apply naming policy does not refresh UI
> - Bug 63180 - Apply Naming Policy allows multi selection but only considers first node
> - Bug 63090 - Remove slf4j-ext due to CVE-2018-8088

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Oleg Kalnichevski (olegk at apache.org)
> - Till Neunast (https://github.com/tilln)
> - Mingun (alexander_sergey at mail.ru)
> - Ubik Load Pack
> - Artem Fedorov (artem.fedorov at blazemeter.com)
> - Stefan Seide (stefan at trilobyte-se.de)
> - 刘士 (liushilive at outlook.com)
> - Michael Pavlov (michael.paulau at gmail.com)
> - Ori Marko (orimarko at gmail.com)
> - Paco (paco.xu at daocloud.io)
> - Hitesh Patel (hitesh.h.patel at gmail.com)
> - Sonali (arora.sonali99 at gmail.com)
> - Mohamed Ibrahim (rollno748 at gmail.com)
> - U. Poblotzki (u.poblotzki at thalia.de)
> - Saxonica

> We also thank bug reporters who helped us improve JMeter.

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 5.0

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> Core improvements

> Rest support has been improved in many fields

> - Multipart/form-data requests now work for `PUT`, `DELETE` …
> - It is now also possible to send a JSON Body with attached file
> - Parameters entered in Parameters Tab are now used in body instead of being ignored

> In distributed testing, JMeter now automatically prefixes thread names with engine host and port, this makes the counting of threads correct in the HTML report without any other configuration as it was required before

> XPath 2.0 is supported in a new element called `XPath2 extractor` providing easier XML namespaces handling, up to date XPath syntax and better performances

> Upgrade to HTTP Components 4.6 last APIs has been completed and JMeter does not rely anymore on deprecated APIs of this library

> It is now possible to control in an easier way Loop breaking and Loop switching to next iteration. This is available in `Flow Control Action` and `Result Status Action Handler` elements

> While Controller now exports a variable containing its current index named `__jm__<Name of your element>__idx`. So for example, if your While Controller is named WC, then you can access the looping index through `${__jm__WC__idx}`

> Scripting / Debugging enhancements

> Search feature has been improved to allow you to iterate in the tree over search results and do necessary replacements through `Next`/`Previous`/`Replace`/`Replace/Find` buttons

> In View Results Tree, the request and response headers/body are clearly separated to allow you to better inspect requests and responses. You can also search in all those tabs for a particular value

> Recording feature has been improved to provide a popup that is always on top when you navigate in browser allowing you to name transactions while you navigate in your application.

> You can now restart JMeter from menu File → Restart

> Live Reporting and Web Report

> A new Graph Total Transactions per second has been added to the HTML Web Report

> It is now possible to graph over time custom metrics available as JMeter Variables through `sample_variables`. Those custom metrics graphs will be available in the HTML Report in `Custom Graphs section`

> Hits per second graph now takes into account the embedded resources

> In Live reporting, the sent and received bytes are now sent to Backends (InfluxDB or Graphite)

> Functions

> A New function `__threadGroupName` has been introduced to obtain ThreadGroup name.

> Incompatible changes

> - Since JMeter 5.0, when using default HC4 Implementation, JMeter will reset HTTP state (SSL State + Connections) on each thread group iteration. If you don't want this behaviour, set `httpclient.reset_state_on_thread_group_iteration=false`
> - Since JMeter 5.0, in relation to above remark, `https.use.cached.ssl.context` is deprecated and not used anymore.
> - Since JMeter 5.0, when using CSV output, sub results will now be also output to CSV file. To revert to previous behaviour set `jmeter.save.saveservice.subresults=false`, see Bug 62470 , Bug 60917 , Bug 62550 .
> - Since JMeter 5.0, `CSS/JQuery Extractor` has been renamed to `CSS Selector Extractor`
> - Since JMeter 5.0, `Test Action` has been renamed to `Flow Control Action`
> - Since JMeter 5.0, JMeter renames subResults to `parentName-N` where N is a number to ensure that Hits Per Second graph includes resources downloads, see Bug 62550 , Bug 62470 and Bug 60917

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 62260 - Improve Rest support. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 58757 - HTTP Request : Updated deprecated methods of HttpComponents to last APIs of httpclient-4.5.X. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62212 - Recorder : Improve UX by providing a popup above all windows to be able to change Transaction names and pauses while using Browser. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62248 - HTTP Request : Parameters entered in Parameters Tab should be used in body instead of being ignored. Partly based on a patch by Artem Fedorov contributed by Blazemeter.
> - Bug 60015 - Multipart/form-data works only for `POST` using HTTPClient4 while it should for `PUT`, `DELETE`, … Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62317 - HTTP(S) Test Script Recorder: allow to add ResultSaver to created sampler

> ### Other samplers

> - Pull request #376 - JUnitSampler logs exceptions except assertion-failures from test cases as warnings. Contributed by Davide Angelocola (davide.angelocola at fisglobal.com)
> - Bug 62244 - Rename `Test Action` to `Flow Control Action`
> - Bug 62302 - Move JSR223 Sampler up the menu. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 62595 - SMTPSampler does not allow configuring the SSL/TLS protocols to be used on handshake. Contributed by Felipe Cuozzo (felipe.cuozzo at gmail.com)

> ### Controllers

> - Bug 62237 - While Controller : Export variable containing current index of iteration. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Listeners

> - Bug 62195 - Save Responses to a file : Improve component and UI. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62209 - InfluxBackendListenerClient: First Assertion Failure Message must be sent if error code and response code are empty or OK
> - Bug 62269 - Bug 62269 - View Results Tree : Response and Request Tabs should contains Header and Body tabs. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62270 - View Results Tree : Allow searching in Request headers, Response Headers, and Request body. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62276 - InfluxDBBackendListenerClient / GraphiteBackendListenerClient : Add sent and received bytes to metrics. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 62320 - Counter : Reference Name property is not clear
> - Bug 60991 - XPath Extractor : Implement XPath 2.0. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62593 - Rename CSS/JQuery Extractor to CSS Selector Extractor. Contributed by Ori Marko (orimarko at gmail.com)

> ### Functions

> - Bug 62178 - Add default value to `__V` function. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 62178 - Add function `__threadGroupName` function to obtain ThreadGroup name. Mainly contributed by Ori Marko (orimarko at gmail.com)
> - Bug 62533 - Allow use epoch time as Date String value in function `__dateTimeConvert`
> - Bug 62541 - Allow `__jexl3`, `__jexl2` functions to support new syntax as `var x;`. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 61834 - Function Helper Dialog : Improve tests by showing variables and keeping them available between evaluations

> ### I18N

> ### Report / Dashboard

> - Bug 62243 - Dashboard : make option "`--forceDeleteResultFile`"/"`-f`" option delete folder referenced by "`-o`" option
> - Bug 62367 - HTML Report Generator: Add Graph Total Transactions per Second. Contributed mainly by Martha Laks (laks.martha at gmail.com)
> - Bug 62166 - Report/Dashboard: Provide ability to register custom graphs and metrics in the JMeter Dashboard. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62542 - Report/Dashboard : Display more information on filters when graph is empty. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62426 - Optimize performance of report generation. Based on feedback by Allen (444104595 at qq.com)
> - Bug 62550 - Modify SubResult Naming Policy
> - Bug 60917 - Load Test with embedded resources download : Hits per seconds does not take into account the downloaded resources

> ### General

> - Bug 62684 - Distributed Testing : Add automatically to thread name a prefix to identify engine. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62155 - Search Feature: Make Search text field get focus
> - Bug 62156 - Search Feature : Distinguish between node that matches search and node that contains a child that matches search
> - Bug 62234 - Search/Replace Feature : Enhance UX and add Replace/Next/Previous/Replace & Find features. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62238 - Add ability to Switch to next iteration of Current Loop. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62239 - Add ability to Break Current Loop
> - Bug 61635 - Add a menu to restart JMeter
> - Bug 62470 - CSV Output : Enable logging of sub results when `jmeter.save.saveservice.subresults=true`. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62473 - Setting "`saveservice_properties`" has counter intuitive behaviour
> - Bug 62354 - Correct calculation and usage of units for second per user (reported by jffagot05 at gmail.com)
> - Bug 62700 - Introduce `jsr223.init.file` to allow calling a JSR-223 script on JMeter startup
> - Bug 62128 - Try to guess `JMETER_HOME` correctly, when `jmeter.bat` is called from a batch file in another directory. Contributed by logox01 (logox01 at gmx.at)
> - Pull request #386 - Add parameter support for RMI keystore creation scripts. Contributed by Logan Mauzaize (t524467 at airfrance.fr)
> - Bug 62065 - Use Maven artifact for JAF Module instead of embedded module
> - Bug 61714 - Update Real-time results documentation
> - Pull request #382 - Correct typo in documentation. Reported by Perze Ababa (perze.ababa at gmail.com>)
> - Pull request #392 - Correct typo in documentation. Reported by Aaron Levin
> - Pull request #379 - Improve chinese translations. Contributed by XmeterNet

> Non-functional changes

> - Pull request #358 - Pull request #365 - Pull request #366 - Pull request #375 - Updated to latest checkstyle (v8.8). Expanded Checkstyle to files in `src` and `test`; fixed newly checked files. Based on contribution by Graham Russell (graham at ham1.co.uk)
> - Bug 62095 - Correct description for right boundary parameter in Boundary Extractor. Contributed by Ori Marko (orimarko at gmail.com)
> - Bug 62113 - Updated to latest Bouncycastle (v1.60). Based on contribution by Olaf Flebbe (oflebbe at apache.org)
> - Bug 62171 - Remove `.md5` checksums and keep only `.sha512` checksums for source and binary archives
> - Updated to groovy-all-2.4.15 (from groovy-all-2.4.13)
> - Updated to asm-6.1 (from 6.0)
> - Updated to tika-core and tika-parsers 1.18 (from 1.17)
> - Bug 62482 - Sync documentation to the implementation of the ForEachController. Based on contribution by Ori Marko (orimarko at gmail.com)
> - Bug 62529 - Updated to httpclient-4.5.6 (from httpclient 4.5.5) and updated to freemarker-2.3.28 (from freemarker-2.3.23). Based on patch by Ori Marko (orimarko at gmail.com)
> - Updated to httpmime-4.5.6 (from httpmime-4.5.5)
> - Updated to caffeine-2.6.2 (from caffeine-2.6.1)
> - Updated to cglib-nodep-3.2.7 (from cglib-nodep-3.2.6)
> - Updated to commons-dbcp2-2.4.0 (from commons-dbcp2-2.2.0)
> - Updated to commons-pool2-2.6.0 (from commons-pool2-2.5.0)
> - Updated to httpcore-4.4.10 (from httpcore-4.4.9)
> - Updated to httpcore-nio-4.4.10 (from httpcore-nio-4.4.9)
> - Updated to log4j-2.11.0 (from log4j-2.10.0)
> - Updated to ph-css-6.1.1 (from ph-css-6.0.0)
> - Updated to ph-commons-9.1.2 (from ph-commons-9.0.0)
> - Updated to rhino-1.7.10 (from +rhino-1.7.7.2)
> - Updated to commons-lang3-3.8 (from commons-lang3-3.7)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 62114 - HTTP(S) Test Script Recorder : Client certificate authentication uses the first SSLManager created. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61058 - HTTP Request : Add option `httpclient4.deflate_relax_mode` to avoid "Unexpected end of ZLIB input stream" when deflating what seems to be invalid streams. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 43612 - HTTP PUT does not honor request parameters. Implemented by Artem Fedorov (artem.fedorov at blazemeter.com) and contributed by BlazeMeter Ltd.
> - Bug 60190 - Content-Type is added for `POST` unconditionally. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62462 - Pull request #387 - Make delegation of credentials in SPNEGO possible again.
> - Bug 58807 - `Reset SSL State on Thread Group iteration only (was https.use.cached.ssl.context=false` is broken)
> - Bug 62716 - When Recording, JMeter removes Authorization from generated Header Manager when using Bearer Token

> ### Other Samplers

> - Bug 62235 - Java 9 - illegal reflective access by org.apache.jmeter.util.HostNameSetter
> - Bug 62464 - Set start- and end-time on JMS publisher sampler, even if initialization fails.
> - Bug 62616 - FTPSampler: Upload file-size is not counted in sentBytes

> ### Controllers

> - Bug 62265 - ModuleController behaves strangely

> ### Listeners

> - Bug 62097 - Update JTable in Aggregate Report only when new data has arrived. That way selections of rows will be kept longer around.
> - Bug 62203 - Influxdb BackendListener client: store user tags to annotation and internal transaction. Contributed by Sergey Batalin (sergey_batalin at mail.ru)
> - Bug 62251 - TextGraphiteMetricsSender does not invalidate lost connections in case of network errors
> - Bug 60705 - Fix headers of Aggregate Reports and friends when columns are moved around.
> - Bug 62463 - Distributed client/server setup: use different RMI ports for the remote objects when using SSL

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 61664 - HTTP Authorization Manager : Digest works only with legacy , is not implemented. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62252 - HTTP header merging logic does not correspond to the documentation
> - Bug 62554 - BoundaryExtractor : Field to check is not reset
> - Bug 62553 - Random element might return same value even if property "Per thread user (User)" is set to TRUE
> - Bug 62637 - Take scheduler into account when calcuting delay for Synchronizing Timer

> ### Functions

> ### I18N

> - Bug 62310 - French translation of Precise Throughput Timer label

> ### Report / Dashboard

> - Bug 62333 - Report Dashboard - When one series contains no value, the graph colors logic is wrong. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62283 - Report Dashboard - Date is not correctly displayed on chart when granularity is ≤ 1 day
> - Bug 62520 - The tool-tip text when we hover on the point in 'Latency Vs Request' graph should be 'Median Latency'

> ### Documentation

> - Bug 62211 - Fix HTTP Request Server Documentation. Contributed by Ori Marko (orimarko at gmail.com)
> - Pull request #388 - Fix a typo. Contributed by Giancarlo Romeo (giancarloromeo at gmail.com)

> ### General

> - Bug 62107 - JMeter fails to start under Windows when `JM_LAUNCH` contains spaces
> - Bug 62110 - A broken JUnit class (due to missing dependency) breaks JMeter menus. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Pull request #377 - Small fix of the docs. Contributed by Peter Doornbosch (peter.doornbosch at luminis.eu)
> - Bug 62124 - Recording templates : Add more exclusions and use Transaction Name by default
> - Bug 62127 - Store filename as String instead of File in FileEditor. This will prevent conversion of filenames from Unix style path separators to Windows style when used for example in CSV Data Set Config.
> - Bug 56150 - Keep the index right, when scrolling through the menu items.
> - Bug 62240 - If SampleMonitor implementation is a TestBean if will not be initialized correctly
> - Bug 62295 - Correct order of elements when duplicating a selection of multiple elements.
> - Bug 62397 - Don't break lines at commata when using JSON Path Tester
> - Bug 62281 - Prevent NPE in MapProperty. Patch by belugabehr (dam6923 at gmail.com)
> - Bug 62457 - In usermanual, the UUID Function's example is wrong. Contributed by helppass (onegaicimasu at hotmail.com)
> - Bug 62478 - Escape commata in parameters when constructing function strings in the GUI function helper. Reported by blue414 (blue414 at 163.com)
> - Bug 62463 - Fix usage of ports, when `client.rmi.localport` is set for distributed runs.
> - Bug 62545 - Don't use a colon as part of the "tab" string when indenting JSON in RenderAsJSON.
> - Part of Bug 62637 - Avoid Integer overrun when dealing with very large values in `TimerService#adjustDelay`
> - Bug 62683 - Error dialog has no text when user opens completely invalid test plan.

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Graham Russell (graham at ham1.co.uk)
> - Ori Marko (orimarko at gmail.com)
> - Davide Angelocola (davide.angelocola at fisglobal.com)
> - Ubik Load Pack
> - Olaf Flebbe (oflebbe at apache.org)
> - Peter Doornbosch (peter.doornbosch at luminis.eu)
> - logox01 (logox01 at gmx.at)
> - Sergey Batalin (sergey_batalin at mail.ru)
> - XMeter
> - Imane Ankhila (iankhila at ahlane.net)
> - jffagot05 (jffagot05 at gmail.com)
> - Perze Ababa (perze.ababa at gmail.com)
> - Martha Laks (laks.martha at gmail.com)
> - Logan Mauzaize (t524467 at airfrance.fr)
> - belugabehr (dam6923 at gmail.com)
> - Giancarlo Romeo (giancarloromeo at gmail.com)
> - helppass (onegaicimasu at hotmail.com)
> - blue414 (blue414 at 163.com)
> - Aaron Levin
> - Allen (444104595 at qq.com)
> - Felipe Cuozzo (felipe.cuozzo at gmail.com)
> - bangnab (ambrosetti.nicola at gmail.com)

> We also thank bug reporters who helped us improve JMeter.

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - View Results Tree may freeze rendering large response particularly if this response has no spaces, see Bug 60816 . This is due to an identified Java Bug UI stuck when calling `JEditorPane.setText()` or `JTextArea.setText()` with long text without space.
> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 4.0

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> Core improvements

> JMeter now supports JAVA 9.

> New `Boundary Extractor` element available which provides easy extraction with better performances

> New `JSON Assertion` element available to assert on JSON responses.

> New `Precise Throughput Timer` element available which produces Poisson arrivals with given constant throughput.

> JMS Point-to-Point sampler has been enhanced with `read`, `browse`, `clear` options.

> Best property values are now selected on many Test Elements to ensure best practices are the defaults:

> - Newly added `If Controller` now uses by default Expression which is the most performing option.

> - Newly added JSR223 Test Element now cache compiled script by default if language used provides this feature.

> `Loop controller` and `ForEach Controller` now expose their current iteration as a variable named `__jm__<Name of your element>__idx` that you can use like this for example for a Loop Controller named `MyLoopController`:

>     ${__jm__MyLoopController__idx}

> . See Bug 61802

> Cookies are now shown in View Results Tree during recording. They were previously always shown as empty.

> `Response Assertion` now allows you to customize assertion message and assert on Request Data.

> UX improvements

> JMeter now uses Darcula LAF by default

> Workbench has been dropped from UI, you can now use Non Test Elements as immediate children of Test Plan.

> Menu UX have been improved to make most used elements available more rapidly.

> HTTP(S) Test Script Recorder now allows you to name your transactions while recording in a more human readable way.

> UX improvements made on, among the most notable :

> - Module Controller informs user at least one Controller is required
> - Function Helper Dialog (The wizard that helps using and testing functions) has been improved in many fields.

> - Switch Controller trims text to avoid issues when a space is introduced before/after name
> - Test Plan is now saved before running the test plan

> Functions

> New Function `__digest` provides easy computing of SHA-XXX, MDX hashes:

>     ${__digest(MD5,Apache JMeter 4.0 rocks !,,,)}

> will return `0e16c3ce9b6c9971c69ad685fd875d2b`

> New Function `__dateTimeConvert` provides easy conversion between date formats:

>     ${__dateTimeConvert(01 Jan 2017,dd MMM yyyy,dd/MM/yyyy,)}

> will return `01/01/2017`

> New Function `__changeCase` provides ability to switch to Upper / Lower / Capitalized cases

>     ${__changeCase(Avaro omnia desunt\, inopi pauca\, sapienti nihil,UPPER,)}

> will return `AVARO OMNIA DESUNT, INOPI PAUCA, SAPIENTI NIHIL`

> New Functions `__isVarDefined` and `__isPropDefined` provide testing of properties and variables availability

>     ${__isPropDefined(START.HMS)}

> will return `true`

>     ${__isVarDefined(JMeterThread.last_sample_ok)}

> will return `true`

> Scripting and Plugin Development

> You can now call `SampleResult#setIgnore()` if you don't want your sampler to be visible in results

> `JavaSamplerContext` used by `AbstractJavaSamplerClient` has been enhanced with new methods to easy plugin development.

> JMeter now distributes additional Maven sources and javadoc artifacts into Maven repository

> Plugins can now register listeners to be notified when a Test Plan is opened/closed

> Live Reporting and Web Report

> InfluxDB backend listener now allows you to add custom tags by adding them with prefix `TAG_`, see Bug 61794

> In Web Report responseTime distribution graph is more precise

> Some bugfixes have been made on report generation, see Bug 61900 , Bug 61900 61956, Bug 61899 . Graphs Latency Vs Request and Response Time Vs Request did not exceed 1000 RPS due to Bug 61962

> Configuration of JMeter environment

> JVM settings for the JMeter start scripts can be placed in a separate file (`bin/setenv.sh` on Unix and `bin\setenv.bat` on Windows), that gets called on startup. The startup script itself does not have to be edited anymore.

> Incompatible changes

> - `Start time` and `End date` of Thread Group have been removed, see Bug 61549
> - In distributed testing, mode `Hold` has been removed. Use alternative and more efficient modes
> - For 3rd party plugins, the following method in `org.apache.jmeter.gui.tree.JMeterTreeNode` has been dropped for migration to Java 9 (Bug 61529 )

>       public Enumeration<JMeterTreeNode> children()

> - `tearDown Thread Group` will now run on stop and shutdown of a test by default. If you don't want this behaviour, uncheck `Run tearDown Thread Groups after shutdown of main threads` on `Test Plan` element, see Bug 61656
> - Properties `sampleresult.getbytes.headers_size` and `sampleresult.getbytes.body_real_size` have been dropped, see Bug 61587
> - JMeter will now save your test plan whenever you run it. This behaviour can be controlled by property `save_automatically_before_run`, see Bug 61731
> - Workbench element has been dropped, you now directly add `Non Test Element` as children of Test Plan. When loading a Test Plan that contains the element JMeter will move the `Mirror Server`, `Property Display` and HTTP(s) `Test Script Recorder` elements as direct children of Test Plan. For any other element, it will create a `Test Fragment` element called `Workbench Test Fragment and move the elements in it`.
> - Following classes have been dropped (`org.apache.jmeter.functions.util.ArgumentEncoder`, `org.apache.jmeter.functions.util.ArgumentDecoder`), see Pull request #335 -
> - In JMS Point-to-Point sampler, setting timeout to 0 will now mean infinite timeout while previously it would be switched to 2000 ms, see Bug 61829
> - When Assertions are at different scopes, they are executed starting with the most OUTER one to the most INNER one. See Bug 61846
> - JMeter now starts by default using English locale. This change is due to missing translations in many supported languages. You can change locale by modifying in jmeter and jmeter.bat (or preferably setenv.sh/setenv.bat) the `JVM_ARGS` system property values. We'd also be very grateful if you can contribute translations in supported languages.
> - SwitchController now trims by default the content of switch to avoid issue related to unwanted spaces. See Bug 61771
> - JMeter JVM heap settings have changed from `-Xms512m -Xmx512m` to `-Xms1g -Xmx1g`
> - Beanshell version has been upgraded to bsh-2.0b6 which introduces breaking changes and more strict parsing rules

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Pull request #316 - Warn about empty truststore loading. Contributed by Vincent Herilier (https://github.com/vherilier)
> - Bug 61639 - HTTP(S) Test Script Recorder: In request filtering tab, uncheck by default "Notify Child Listeners of filtered samplers"
> - Bug 61672 - HTTP(S) Test Script Recorder: Have the ability to choose the sampler name while keeping the ability to just add a prefix
> - Bug 53957 - HTTP Request: In Parameters tab, allow pasting of content coming from Firefox and Chrome (unparsed)
> - Bug 61587 - Drop properties `sampleresult.getbytes.headers_size` and `sampleresult.getbytes.body_real_size`
> - Bug 61843 - HTTP(S) Test Script Recorder: Add SAN to JMeter generated CA Certificate. Contributed by Matthew Buckett
> - Bug 61901 - Support for `https.cipherSuites` System property. Contributed by Jeremy Arnold (jeremy at arnoldzoo.org)

> ### Other samplers

> - Bug 61544 - JMS Point-to-Point Sampler: Enhance communication styles with read, browse, clear. Based on a contribution by Benny van Wijngaarden (benny at smaragd-it.nl)
> - Bug 61829 - JMS Point-to-Point: If Receive Queue is empty and a timeout is set, it is not taken into account. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61739 - Java Request / JavaSamplerClient: Improve `org.apache.jmeter.protocol.java.sampler.JavaSamplerContext`
> - Bug 61762 - Start Next Thread Loop should be used everywhere

> ### Controllers

> - Bug 61675 - If Controller: Use expression by default and add a warning when the other mode is used. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61770 - Module Controller: Inform user in UI that he needs to have at least one Controller in his plan. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61771 - SwitchController: Switch field should be trimmed by safety

> ### Listeners

> - Bug 57760 - View Results Tree: Cookie Header is wrongly shown as empty (no cookies) when viewing a recorder Sample Result. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61769 - View Results Tree: Use syntax highlighter in XPath Tester, JSON Path Tester and CSS/JQuery Tester. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61776 - View Results Tree: Expansion of `Add expand/collapse all` menu in render XML view. Contributed by Maxime Chassagneux and Graham Russell
> - Bug 61852 - View Results Tree: Add a Boundary Extractor Tester
> - Bug 61794 - Influxdb backend: Add as many custom tags as wanted by just create new lines and prefix theirs name by "`TAG_`" on the GUI backend listener

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 60213 - New component: Boundary based extractor
> - Bug 61845 - New Component JSON Assertion based on AtlanBH JSON Path Assertion donated to JMeter-Plugins and migrated into JMeter core by Artem Fedorov (artem at blazemeter.com)
> - Bug 61931 - New Component: Precise Throughput Timer, timer that produces Poisson arrivals with given constant throughput. Contributed by Vladimir Sitnikov (sitnikov.vladimir at gmail.com)
> - Bug 61644 - HTTP Cache Manager: "Use Cache-Control/Expires header when processing GET requests" should be checked by default
> - Bug 61645 - Response Assertion: Add ability to assert on Request Data
> - Bug 51140 - Response Assertion: add ability to set a specific error/failure message that is later shown in the Assertion Result. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61534 - Convert AssertionError to a failed assertion, allowing users to use assert in their code. Fixing a regression introduced in 3.2
> - Bug 61756 - Extractors: Improve label name "Reference name" to make it clear what it makes
> - Bug 61758 - `Apply to:` field in Extractors, Assertions: When entering a value in `JMeter Variable Name`, the radio box `JMeter Variable Name` should be selected by default. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61846 - Scoped Assertion should follow same order of evaluation as Post Processors

> ### Functions

> - Bug 61724 - Add `__digest` function to provide computing of Hashes (SHA-XXX, MDX). Based on a contribution by orimarko at gmail.com
> - Bug 61735 - Add `__dateTimeConvert` function to provide date formats conversions. Based on a contribution by orimarko at gmail.com
> - Bug 61760 - Add `__isPropDefined` and `__isVarDefined` functions to know if property or variable exist. Contributed by orimarko at gmail.com
> - Bug 61759 - Add `__changeCase` function to change different cases of a string. Based on a contribution by orimarko at gmail.com
> - Bug 61561 - Function helper dialog should display exception in result
> - Bug 61738 - Function Helper Dialog: Add Copy in Generate and clarify labels. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 62027 - Help: Introduce property `help.local` to allow choosing between local (offline) documentation and online documentation
> - Bug 61593 - Remove Detail, Add, Add from Clipboard, Delete buttons in Function Helper GUI

> ### I18N

> - Bug 61606 - Translate button `Browse…` in some elements (which use FileEditor class)
> - Bug 61747 - HTTP(S) Test Script Recorder: add the missing doc to "Create transaction after request (ms)"

> ### Report / Dashboard

> - Bug 61871 - Reduce jmeter.reportgenerator.graph.responseTimeDistribution.property.set_granularity default value from 500ms to 100ms
> - Bug 61879 - Remove useless files in HTML report template

> ### General

> - Bug 61591 - Drop Workbench from test tree. Implemented by Artem Fedorov (artem at blazemeter.com) and contributed by BlazeMeter Ltd.
> - Bug 61549 - Thread Group: Remove start and end date
> - Bug 61529 - Migration to Java 9. Partly contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61709 - SampleResult: Add a method `setIgnore()` to make JMeter ignore the SampleResult and not send it to listeners
> - Bug 61806 - Allow to use `SampleResult#setIgnore()` in post-processors and assertions script (JSR223 elements)
> - Bug 61607 - Add browse button in all BeanShell elements to select BeanShell script
> - Bug 61627 - Don't clear LogView anymore when clicking on Warning/Errors Indicator
> - Bug 61629 - Add Think Times to Children menu should not consider disabled elements
> - Bug 61655 - SampleSender: Drop HoldSampleSender implementation
> - Bug 61656 - `tearDown Thread Group` should run by default at stop or shutdown of test
> - Bug 61659 - `JMeterVariables#get()` should apply `toString()` on non string objects
> - Bug 61555 - Metaspace should be restricted as default
> - Bug 61693 - JMeter aware of Docker (`-XX:+UnlockExperimentalVMOptions` `-XX:+UseCGroupMemoryLimitForHeap`)
> - Bug 61694 - Add `-server` option in `jmeter.bat`
> - Bug 61697 - Introduce Darcula Look And Feel to make JMeter UI more attractive
> - Bug 61704 - Toolbar: Improve a bit the right part
> - Bug 61731 - Enhance Test plan Backup with option to save before run. Based on a contribution by orimarko at gmail.com
> - Bug 61640 - JSR223 Test Elements: Enable by default caching. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61785 - Add Help → Useful links to create issues and download nightly build
> - Bug 61808 - Fix main frame position. Implemented by Artem Fedorov (artem at blazemeter.com) and contributed by BlazeMeter Ltd.
> - Bug 61802 - Loop / ForEach Controller should expose a variable for current iteration. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Pull request #349 - Add i18n resources(zh_CN). Contributed by Helly Guo (https://github.com/hellyguo)
> - Pull request #351 - Fixed about dialog position on first view. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #352 - Menu bar - added mnemonics to more menu items. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #353 - Re-wrote some existing tests in Spock. Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 61919 - UX: Reorder Menus. Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 61920 - Plugins: Add ability to listen to Test Plan loading/closing. Contributed by Peter Doornbosch (https://bitbucket.org/pjtr/)
> - Bug 61935 - Plugins: Let GUI component (dynamically) decide whether it can be added via the menu or not. Contributed by Peter Doornbosch (https://bitbucket.org/pjtr/)
> - Bug 61969 - When changing LAF through GUI, user should be informed that it is better to restart
> - Bug 61970 - JMeter now uses English as default locale to avoid missing translations in some locales make UI look weird
> - Bug 56368 - Create and Deploy source artifacts to Maven central
> - Bug 61973 - Create and Deploy javadoc artifacts to Maven central
> - Pull request #371 - Fix example in documentation for XPath Assertion. Contributed by Konstantin Kalinin (kkalinin at hotmail.com)
> - Bug 62039 - Distributed testing: Provide ability to use SSL

> Non-functional changes

> - Updated to bsh-2.0b6 (from bsh-2.0b5)
> - Updated to groovy-all-2.4.13 (from groovy-all-2.4.12)
> - Updated to rhino-1.7.7.2 (from rhino-1.7.7.1)
> - Updated to tika-core and tika-parsers 1.17 (from 1.16)
> - Updated to commons-dbcp2-2.2.0 (from 2.1.1)
> - Updated to caffeine 2.6.1 (from 2.5.5)
> - Updated to commons-codec-1.11 (from 1.10)
> - Updated to commons-io-2.6 (from 2.5)
> - Updated to commons-lang3-3.7 (from 3.6)
> - Updated to commons-pool2-2.5.0 (from 2.4.2)
> - Updated to asm-6.0 (from 5.2)
> - Updated to jsoup-1.11.2 (from 1.10.3)
> - Updated to cglib-nodep-3.2.6 (from 3.2.5)
> - Updated to ph-css 6.0.0 (from 5.0.4)
> - Updated to ph-commons 9.0.0 (from 8.6.6)
> - Updated to log4j2 2.10.0 (from 2.8.2)
> - Updated to httpcore 4.4.9 (from 4.4.7)
> - Updated to httpclient 4.5.5 (from 4.5.3)
> - Updated to jodd 4.1.4 (from 3.8.6)
> - Bug 61642 - Improve FTP test coverage
> - Bug 61641 - Improve JMS test coverage
> - Bug 61651 - Improve TCP test coverage
> - Bug 61651 - Improve OS test coverage. Partly contributed by Aleksei Balan (abalanonline at gmail.com)
> - Pull request #319 - Removed commented out code. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #322 - General JavaDoc cleanup. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #323 - Extracted method and used streams to improve readability. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #324 - Save backup refactor. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #327 - Utilising more modern Java, simplifying code and formatting code and comments. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #332 - Add the spock framework for groovy unit tests. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #334 - Enable running of JUnit tests from within IntelliJ with default config. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #335 - Removed `functions.util.*` as they don't seem to be used (for many years). Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 61867 - Pull request #345 - Updated to latest checkstyle (v8.5), Added many more rules to checkstyle, Included checking of test files and more file types. Contributed by Graham Russell (graham at ham1.co.uk)
> - Pull request #350 - Parallelised unit tests. Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 61966 - Setup Test Results Analyzer in jenkins
> - Pull request #343 - Reduce the size of some images in the documentation. Contributed by Graham Russell (graham at ham1.co.uk)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 61569 - JMS Point-to-Point Test Plan: Synchronization issue when putting reply. Contributed by Igor Panainte (panainte.i at gmail.com)

> ### Other Samplers

> - Bug 61698 - Test Action: It stop is selected, samplers following Test Action can run
> - Bug 61707 - Test Action: Target is ignored when pause is selected, so it should be disabled
> - Bug 61827 - JMSPublisher: Don't add new line at the end of the file. Contributed by Graham Russell (graham at ham1.co.uk)

> ### Controllers

> - Bug 61556 - Clarify in documentation performance impacts of `${}` var usage in IfController and groovy. Contributed by Justin McCartney (be_strew at yahoo.co.uk)
> - Bug 61713 - Test Fragment has option to Change Controller and Insert Parent. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61965 - Module and Include Controller should not allow to add meaningless elements in their context.
> - Bug 62062 - ThroughputController: StackOverFlowError triggered when throughput=0 (Total Executions or Percentage Executions) Partly implemented by Artem Fedorov (artem.fedorov at blazemeter.com) and contributed by BlazeMeter Ltd.

> ### Listeners

> - Bug 61742 - BackendListener: fix default value for `backend_graphite.send_interval`
> - Bug 61878 - BackendListener: NPE if BackendListenerClient#getDefaultParameters returns null
> - Bug 61950 - View Results Tree: Content-Type `audio/mpegurl` is wrongly considered as binary

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 61716 - Header Manager: When pasting Headers from Firefox or Chrome spaces are introduced as first character of value

> ### Functions

> - Bug 61588 - Better log message for __RandomDate() function
> - Bug 61619 - In Function Helper Dialog, the 1st function doesn't display default parameters
> - Bug 61628 - If split string has empty separator default separator is not used
> - Bug 61752 - `__RandomDate`: Function does not allow missing last parameter used for variable name

> ### I18N

> ### Report / Dashboard

> - Bug 61807 - Web Report: fix error in `getTop5ErrorMetrics`. Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 61900 - Report Generator: Report generation fails if separator is a regex reserved char like `|`
> - Bug 61925 - CsvSampleReader does not increment row in nextSample(). Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 61956 - Report Generation: `-f` of `-forceDeleteResultFile` option does not work. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61899 - Report Generation: When `jmeter.save.saveservice.print_field_names` is false and `sample_variables` are set report generation fails. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61962 - Latency Vs Request and Response Time Vs Request graphs do not exceed 1000 RPS. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### General

> - Bug 61661 - Avoid startup/shutdown problems due to 3rd party Thread Listener plugins throwing RuntimeException
> - Bug 61625 - File Editor used in BeanInfo behaves strangely under all LAFs with impact on CSVDataSet, JSR223, BSF, Beanshell Element
> - Bug 61844 - Maven pom.xml: Libraries used in testing should have scope test
> - Bug 61842 - Saving with no changes causes a save and duplicate, identical backup file

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Igor Panainte (panainte.i at gmail.com)
> - Emilian Bold (emi at apache.org)
> - Ubik Load Pack
> - Justin McCartney (be_strew at yahoo.co.uk)
> - Vincent Herilier (https://github.com/vherilier)
> - Aleksei Balan (abalanonline at gmail.com)
> - Graham Russell (graham at ham1.co.uk)
> - orimarko at gmail.com
> - Artem Fedorov (artem at blazemeter.com)
> - BlazeMeter Ltd
> - Benny van Wijngaarden (benny at smaragd-it.nl)
> - Matthew Buckett (https://github.com/buckett)
> - Helly Guo (https://github.com/hellyguo)
> - Peter Doornbosch (https://bitbucket.org/pjtr/)
> - Jeremy Arnold (jeremy at arnoldzoo.org)
> - Vladimir Sitnikov (sitnikov.vladimir at gmail.com)
> - Konstantin Kalinin (kkalinin at hotmail.com)

> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:

> - user7294900 on Stackoverflow (orimarko at gmail.com)

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - View Results Tree may freeze rendering large response particularly if this response has no spaces, see Bug 60816 . This is due to an identified Java Bug UI stuck when calling `JEditorPane.setText()` or `JTextArea.setText()` with long text without space.
> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 3.3

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> JMeter does not yet support JAVA 9, next JMeter version will support it, you can help and follow progress on this item in Bug 61529 .

> Using last minor version of JAVA 8 is advised to avoid facing any JDK bug.

> Core improvements

> HTTP Sampler now supports Brotli decompression.

> CacheManager now completely supports Vary header.

> InfluxDB BackendListener now supports sending results to InfluxDB through UDP protocol.

> It has also been enhanced to send number of errors by response code and message for each transaction

> TCP Sampler now computes latency, see Bug 60156

> Upgraded dependencies to last available versions bringing performance improvements and bug fixes

> Continued to improve the quality of our code and tests coverage. See Quality report

> UX improvements

> More work has been done to better support HiDPI.

> Some bugs, that crept in with the work on lowering the memory usage of View Results Tree, were fixed.

> The constant `DEFAULT_IMPLEMENTATION` was removed from CookieManager, as it lost it purpose with the removal of the alternate HTTP Client implementation in the last release

> JDBC Sampler UX has been improved by adding select boxes for drivers and validation queries.

> If Controller and While Controller UX have been improved

> Report/Dashboard improvements

> Documentation improvements

> Functions

> Function Helper Dialog: a new field that shows execution result has been added.

> New functions:

> - `__timeShift` - return a date in various formats with the specified amount of seconds/minutes/hours/days added.

> - `__RandomDate` - generate random date within a specific date range.

> Incompatible changes

> - In InfluxDbBackendListenerClient, `statut` property has been renamed to `status`
> - In CookieManager, `DEFAULT_POLICY` and `DEFAULT_IMPLEMENTATION` constants are now private.

>   If you're using `ignorecookies` with HC3CookieHandler (< JMeter 3.1) configuration will be reset, ensure you put it back.

> - JMeter will not truncate anymore by default responses exceeding 10 MB. If you want to enable this truncation, see property `httpsampler.max_bytes_to_store_per_request`
> - `org.apache.jmeter.protocol.tcp.sampler.TCPClient.read(InputStream)` has been deprecated in favor or org.apache.jmeter.protocol.tcp.sampler.TCPClient.read(InputStream, SampleResult), ensure you update your implementation to be able to compute latency, see Bug 60156

> ### Removed elements or functions

> - `_StringFromFile` function has been dropped, use `__StringFromFile` instead

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 61056 - HTTP : Support brotli decoding
> - Bug 61135 - CookieManager : Drop Implementation select box and cleanup class
> - Bug 61492 - HTTP(S) Test Script Recorder : Add the possibility to change the value of proxy.pause in the GUI

> ### Other samplers

> - Bug 61320 - Test Action : Set duration to `0` by default
> - Bug 61504 - JDBC Connection Configuration : Set Max Number of Connections to `0` by default
> - Bug 61505 - JDBC Connection Configuration : Set "Validation Query" to `empty` by default to use `isValid` method of JDBC driver
> - Bug 61506 - JDBC Connection Configuration : Add a list for main databases validation queries for "Validation Query" attribute
> - Bug 61507 - JDBC Connection Configuration : Add a list for main databases JDBC driver class name for "JDBC Driver class" attribute
> - Bug 61525 - OS Process Sampler : Add browser button to Command and Working directory fields
> - Bug 60156 - TCPSampler : Latency is not measured for TCP Sampler. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61039 - CSV data set config : Add browser button to Filename field
> - Bug 61527 - CSV data set config : Add a list for main file encoding values for File encoding attribute

> ### Controllers

> - Bug 61131 - IfController and WhileController : Improve UX

> ### Listeners

> - Bug 61167 - InfluxdbBackendListener : add number of errors by response code and message for each transaction
> - Bug 61068 - Introduce property `resultcollector.action_if_file_exists` to control the popup "File already exists" when starting a test
> - Bug 61457 - InfluxDB backend listener client : Support sending result to InfluxDB through UDP protocol. Partly based on Pull request #302 - by Junlong Wu (github id mybreeze77)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 61176 - Pull request #298 - Cache responses that have `vary` header in the `CacheManager`.

> ### Functions

> - Bug 61040 - Add a time shifting function
> - Bug 61126 - Function Helper Dialog : Add a field that shows execution result
> - Bug 61508 - Add a random date within a specific date range function

> ### I18N

> - Bug 61509 - Better label/translation/documentation for labels start and max for Counter element

> ### Report / Dashboard

> - Bug 61481 - Help Menu Item to export transaction for Web report

> ### General

> - When looking for classes in `ActionRouter`, fall back to location of the jar, where `ActionRouter` is loaded from. Provided by Emilian Bold (emi at apache.org)
> - Bug 61510 - Set 'Max Number of Connections' to `0` into 'JDBC Connection Configuration' for the 'JDBC Load Test template'
> - Bug 61399 - Make some bin and extras scripts Shellcheck compatible. Contributed by Wolfgang Wagner (internetwolf2000 at hotmail.com)

> Non-functional changes

> - Updated to groovy 2.4.12 (from 2.4.10)
> - Updated to caffeine 2.5.5 (from 2.4.0)
> - Updated to commons-jexl3 3.1 (from 3.0)
> - Updated to ph-css 5.0.4 (from 5.0.3)
> - Updated to ph-commons 8.6.6 (from 8.6.0)
> - Updated to log4j2 2.8.2 (from 2.8.1)
> - Updated to xmlgraphics-commons 2.2 (from 2.1)
> - Updated to jodd 3.8.6 (from 3.8.1)
> - Updated to xstream 1.4.10 (from 1.4.9)
> - Updated to Apache Tika 1.16 (from 1.14)
> - Updated to jsoup-1.10.3 (from 1.10.2)
> - Updated to commons-lang3 3.6 (from 3.5)
> - Updated to json-path 2.4.0 (from 2.2.0)
> - Updated to httpcore 4.4.7 (from 4.4.6)
> - Bug 61438 - Change the cryptographic signature of packages from sha-1 to sha-512

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 61384 - Don't set the charset on enclosing `multipart/form-data` header. It irritates some servers.
>   The charset was added sometime back while refactoring to use a newer API of http client. See Bug 56141 - for more info.
> - Bug 61456 - `java.lang.ArrayIndexOutOfBoundsException` when recording with JMeter and weird Basic Auth Authorization header
> - Bug 61395 - Large server response truncation can impact recording

> ### Other Samplers

> - Bug 60889 - JMeter JDBC sample calls `SELECT USER()` when testing with MySQL JDBC due to `Connection#toString` call for response headers.
> - Bug 61259 - JDBC Request : since JMeter 3.0, when JDBC auto-commit is `false`, a rollback statement happens each time a Request is executed. Partly contributed by Liu XP (liu_xp2003 at sina.com)
> - Bug 61319 - Fix regression: SMTP Sampler could not send mails, when no attachments were specified.

> ### Controllers

> - Bug 61375 - Use system DNS resolver as last resort, when resolving entries in the static host table.

> ### Listeners

> - Bug 61005 - View Results Tree - Browser Response Data is not clearing
> - Bug 61121 - InfluxdbBackendListenerClient: Only all percentiles are sent, not `KO` and `OK`
> - Bug 60961 - Try to keep status of selected and expanded elements in View Results Tree when new elements are added.
> - Bug 61198 - Backend Listener does not work properly in main script when included scripts also contain Backend Listener
> - Bug 61493 - Max/Min threads are interchanged in Graphite and InfluxDB backend listener

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 58743 - Pull request #293 - TableEditor can't be saved, when using two or more instances. Bugfix provided by Emilian Bold (emi at apache.org)
> - Bug 61314 - HTTP URL Re-writing Modifier doesn't replace existing `jsessionid` in http sampler, but adds it to the end
> - Bug 61336 - BeanShell Assertion : mistake in Chinese translation

> ### Functions

> - Bug 61258 - StringFromFile function is mentioned twice in the Function helper dialog
> - Bug 61260 - `__XPath` function returns null despite XPath checker founds matches
> - Bug 58876 - TestPlanName function returns `null` for a newly saved Test Plan and uses previously opened one for a new one

> ### I18N

> ### Report / Dashboard

> - Bug 61129 - Report/Dashboard : If response code is empty but a `failureMessage` is present, Errors and Top 5 Errors are not accurate. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 61151 - Report/Dashboard : Top 5 Errors by Sampler and Errors : If assertion contains html code, the html part is hidden

> ### General

> - Bug 60743 - Stopping / Shutting down Test might create a deadlock due to HTTPCORE-446, fixed by HttpCore upgrade to 4.4.7
> - Bug 60994 - Fix some typo in comments or log messages. Pull request #289 - and Pull request #290 -
> - Bug 61011 - Replace occurrences count is not correct (Path and Host replacement are counted twice)
> - Bug 61026 - Cannot run program "keytool": CreateProcess error=2 when starting JMeter 3.2 in GUI mode
> - Bug 61054 - Endless loop in `JOrphanUtils#replaceAllWithRegex` when regex is contained in replacement
> - Bug 60995 - HTTP Test Script Recorder: Port field is very small under some L&F
> - Bug 61073 - HTTP(S) Test Script Recorder panel have some fields with bad size on HiDPI screen or GTK+ L&F on Linux/XWayland
> - Bug 57958 - Fix transaction sample not generated if thread stops/restarts. Implemented by Artem Fedorov (artem at blazemeter.com) and contributed by BlazeMeter Ltd.
> - Bug 61050 - Handle uninitialized RessourceBundle more gracefully, when calling `JMeterUtils#getResString`.
> - Bug 61100 - Invalid GC Log Filename on Windows
> - Bug 57962 - Allow to use variables (from User Defined Variables only) in all listeners in worker node mode
> - Bug 61270 - Fixed width fonts too small in text areas to read under HiDPI (user manual bug)
> - Bug 61292 - Make processing of samples in reporter more robust.
> - Bug 61359 - When cutting an element from Tree, Test plan is not marked as dirty
> - Bug 61380 - JMeter shutdown using timers releases thundering herd of interrupted samplers
> - Bug 57055 - CheckDirty.doAction should clear previousGuiItems for `SUB_TREE_SAVED`

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Anass Benomar (abenomar at umanis.com, Mithrandir0407 at github)
> - Anthony Kearns (anthony.kearns atrightside.co)
> - Emilian Bold (emi at apache.org)
> - Liu XP (liu_xp2003 at sina.com)
> - Ubik Load Pack
> - Wolfgang Wagner (internetwolf2000 at hotmail.com)
> - Junlong Wu (github id mybreeze77)

> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:

> - Liu XP (liu_xp2003 at sina.com)
> - Alexander Podelko (apodelko at yahoo.com)

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - View Results Tree may freeze rendering large response particularly if this response has no spaces, see Bug 60816 . This is due to an identified Java Bug UI stuck when calling `JEditorPane.setText()` or `JTextArea.setText()` with long text without space.
> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like `md2WithRSAEncryption`) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with Java 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 3.2

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> IMPORTANT CHANGES

> JMeter now requires Java 8. Ensure you use the most up to date version.

> JMeter logging has been migrated to SLF4J and Log4j 2. This affects configuration and 3rd party plugins, see below "Logging changes".

> Starting with JMeter version 3.2 the number of results in View Results Tree is limited by default to 500 entries. If you want more entries, you have to set the property `view.results.tree.max_results` to a higher value, or to `0`, if you don't want to impose any limit. You can set the property in bin/user.properties. More info might be found here.

> Core improvements

> - JMeter now provides a new BackendListener implementation that interfaces InfluxDB.

>   This implementation sends data using Asynchronous HTTP calls to InfluxDB through its HTTP API and give you the following graphs with annotations:

> - DNS Cache Manager now has a table to allow static host resolution.

> - JMS Publisher and Subscriber now allow reconnection on error with pause.

> - Variables in JMS Publisher are now supported for all types of messages. Add the encoding type of the file to parse its content

> - XPath Extractor now allows extraction randomly, by index or for all matches.

> - Response Assertion now allows to work on Request Header, provides a "OR" combination and has a better cell renderer

> - JMeter now uses Oracle Nashorn Javascript engine instead of Rhino. This provides a faster execution of Javascript.
> - HTTP HC4 Implementation now provides preemptive Basic Auth enabled by default
> - Embedded resources download in CSS has been improved to avoid useless repetitive parsing to find the resources
> - An important work on code quality and code coverage with tests has been done since Sonar has been setup on the project. You can see Sonar report here.

> UX improvements

> - When running a Test, GUI is now more responsive and less impacting on memory usage thanks to a limitation on the number of Sample Results listeners hold and a rework of the way GUI is updated
> - HTTP Request GUI has been simplified and provides more place for parameters and body.

> - HTTP(S) Test Script Recorder has been simplified and clarified.

> - A `replace` feature has been added to Search feature to allow replacement in some elements.

>   ReplaceAll does not do replacement on all elements, it does it on: - HeaderManager: Replacement in values - Http Request: Replacement in Arguments, Path and Host

> - View Results Tree now provides a more up to date Browser renderer which requires JavaFX.
> - You can now add through a contextual menu think times, this will add think times between samplers and Transaction Controllers of selected node.

> - You can now apply a naming policy to children of a Transaction Controller. A default policy exists but you can implement your own through `org.apache.jmeter.gui.action.TreeNodeNamingPolicy` and configuring property `naming_policy.impl`

> - Sorting per column has been added to View Results in Table, Summary Report, Aggregate Report and Aggregate Graph elements.

> Report/Dashboard improvements

> - Statistics have been reorganized to clarify report:

> - It is now possible to customize APDEX thresholds per transaction based on regular expression or sample name. The below example will apply different thresholds for samples sample(\\d+), sampleA and scenarioB than default ones (500 and 1500 for satisfied and tolerated thresholds) declared:

>       jmeter.reportgenerator.apdex_satisfied_threshold=500
>       jmeter.reportgenerator.apdex_tolerated_threshold=1500
>       jmeter.reportgenerator.apdex_per_transaction=sample(\\d+):1000|2000;\
>           sampleA:3000|4000;\
>           scenarioB:5000|6000

> Documentation improvements

> - PDF Documentations have been migrated and updated to HTML user manual

> Incompatible changes

> - JMeter requires now at least a Java 8 version to run.
> - JMeter logging has been migrated to SLF4J and Log4j 2, this involves changes in the way configuration is done. JMeter now relies on standard Log4j 2 configuration in file `log4j2.xml` See `Logging changes` section below for further details.
> - The following jars have been removed after migration from LogKit to SLF4J (see Bug 60589 ):
>   - ApacheJMeter_slf4j_logkit.jar
>   - avalon-framework-4.1.4.jar
>   - commons-logging-1.2.jar
>   - excalibur-logger-1.1.jar
>   - logkit-2.0.jar
> - The `commons-httpclient-3.1.jar` has been removed after drop of HC3.1 support(see Bug 60727 )
> - JMeter now sets through `-Djava.security.egd=file:/dev/urandom` the algorithm for secure random
> - Process Sampler now returns error code 500 when an error occurs. It previously returned an empty value.
> - In `org.apache.jmeter.protocol.http.sampler.HTTPHCAbstractImpl` two protected static fields (`localhost` and `nonProxyHostSuffixSize`) have been renamed to (`LOCALHOST` and `NON_PROXY_HOST_SUFFIX_SIZE`) to follow static fields naming convention
> - JMeter now uses by default Oracle Nashorn engine instead of Mozilla Rhino for better performances. This should not have an impact unless you use some advanced features. You can revert back to Rhino by settings property `javascript.use_rhino=true`. You can read this migration guide for more details on Nashorn. See Bug 60672
> - Bug 60729 - The Random Variable Config Element now allows minimum==maximum. Previous versions logged an error when minimum==maximum and did not set the configured variable.
> - Bug 60730 - The JSON PostProcessor now sets the `_ALL` variable (assuming `Compute concatenation var` was checked) even if the JSON path matches only once. Previous versions did not set the `_ALL` variable in this case.

> ### Removed elements or functions

> - SOAP/XML-RPC Request has been removed as part of Bug 60727 . Use HTTP Request element as a replacement. See Building a WebService Test Plan
> - Bug 60423 - Drop Monitor Results listener
> - Drop deprecated class `org.apache.jmeter.protocol.system.NativeCommand`
> - Drop deprecated class `org.apache.jmeter.protocol.http.config.gui.MultipartUrlConfigGui`
> - Drop deprecated class `org.apache.jmeter.testelement.TestListener`
> - Drop deprecated class `org.apache.jmeter.reporters.FileReporter`
> - Drop deprecated class `org.apache.jmeter.protocol.http.modifier.UserSequence`
> - Drop deprecated class `org.apache.jmeter.protocol.http.parser.HTMLParseError`
> - Drop unused methods `org.apache.jmeter.protocol.http.control.HeaderManager#getSOAPHeader` and `org.apache.jmeter.protocol.http.control.HeaderManager#setSOAPHeader(Object)`
> - `org.apache.jmeter.protocol.http.util.Base64Encode` has been deprecated, you can use `java.util.Base64` as a replacement

> ### Logging changes

> JMeter logging has been migrated to SLF4J and Log4j 2. This affects logging configuration and 3rd party plugins (if they use JMeter logging). The following sections describe what changes need to be made.

> #### Setting the logging level and log file

> The default logging level can be changed on the command-line using the `-L` parameter. Likewise the `-l` parameter can be used to change the name of the log file. However the `log_level` properties no longer work.

> The default logging levels and file name are defined in the `log4j2.xml` configuration file in the launch directory (usually `JMETER_HOME/bin`)

> If you need to change the level programmatically from Groovy code or Beanshell, you need to do the following:

>         import org.apache.logging.log4j.core.config.Configurator;
>         ⋮
>         final String loggerName = te.getClass().getName(); // te being a JMeter class
>         Configurator.setAllLevels(loggerName, Level.DEBUG);

> #### Changes to 3rd party plugin logging

> 3rd party plugins should migrate their logging code from logkit to slf4j. This is fairly easy and can be done by replacing:

>             import org.apache.jorphan.logging.LoggingManager;
>             import org.apache.log.Logger;
>             ⋮
>             private static final Logger log = LoggingManager.getLoggerForClass();

> By:

>             import org.slf4j.Logger;
>             import org.slf4j.LoggerFactory;
>             ⋮
>             private static final Logger log = LoggerFactory.getLogger(YourClassName.class);

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 59934 - Fix race-conditions in CssParser. Based on a patch by Jerome Loisel (loisel.jerome at gmail.com)
> - Bug 60543 - HTTP Request / Http Request Defaults UX: Move to advanced panel Timeouts, Implementation, Proxy. Implemented by Philippe Mouawad (p.mouawad at ubik-ingenierie.com) and contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60548 - HTTP Request : Allow Upper Panel to be collapsed
> - Bug 57242 - HTTP Authorization is not pre-emptively set with HttpClient4
> - Bug 60727 - Drop commons-httpclient-3.1 and related elements. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60790 - HTTP(S) Test Script Recorder : Improve information on certificate expiration and have better UX for Start/Stop
> - Bug 60888 - HttpRequest : Add option to allow retrial of all requests including NON Idempotent HTTP methods
> - Bug 60896 - HTTP(S) Test Script Recorder : Improve UX by reducing number of properties on screen

> ### Other samplers

> - Bug 60740 - Support variable for all JMS messages (bytes, object, …) and sources (file, folder), based on Pull request #241 - . Contributed by Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60585 - JMS Publisher and JMS Subscriber : Allow reconnection on error and pause between errors. Based on Pull request #240 - from by Logan Mauzaize (logan.mauzaize at gmail.com) and Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Pull request #259 - - Refactored and reformatted SmtpSampler. Contributed by Graham Russell (graham at ham1.co.uk)

> ### Controllers

> - Bug 60672 - JavaScript function / IfController : use Nashorn engine by default

> ### Listeners

> - Bug 60144 - View Results Tree : Add a more up to date Browser Renderer to replace old Render
> - Bug 60542 - View Results Tree : Allow Upper Panel to be collapsed. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 52962 - Allow sorting by columns for View Results in Table, Summary Report, Aggregate Report and Aggregate Graph. Based on a Pull request #245 - by Logan Mauzaize (logan.mauzaize at gmail.com) and Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60590 - BackendListener : Add Influxdb BackendListenerClient implementation to JMeter. Partly based on Pull request #246 - by Logan Mauzaize (logan.mauzaize at gmail.com) and Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60591 - BackendListener : Add a time boxed sampling. Based on a Pull request #237 - by Logan Mauzaize (logan.mauzaize at gmail.com) and Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60678 - View Results Tree : Text renderer, search should not popup "Text Not Found"
> - Bug 60691 - View Results Tree : In Renderers (XPath, JSON Path Tester, RegExp Tester and CSS/JQuery Tester) lower panel is sometimes not visible as upper panel is too big and cannot be resized
> - Bug 60687 - Make GUI more responsive when it gets a lot of events.
> - Bug 60791 - View Results Tree: Trigger search on Enter key in Search Feature and display red background if no match
> - Bug 60822 - ResultCollector does not ensure unique file name entries in files HashMap

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 60154 - User Parameters GUI: allow rows to be moved up & down in the list. Contributed by Murdecai777 (https://github.com/Murdecai777).
> - Bug 60507 - Added '`Or`' Function into ResponseAssertion. Based on a contribution from 忻隆 (298015902 at qq.com)
> - Bug 58943 - Create a Better Think Time experience. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60602 - XPath Extractor : Add Match No. to allow extraction randomly, by index or all matches
> - Bug 60710 - XPath Extractor : When content on which assertion applies is not XML, in View Results Tree the extractor is marked in Red and named SAXParseException. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60712 - Response Assertion : Improve Renderer of Patterns
> - Bug 59174 - Add a table with static hosts to the DNS Cache Manager. This enables better virtual hosts testing with HttpClient4.

> ### Functions

> - Bug 60883 - Pull request #288 - - Add `${__escapeXml()}` function. Contributed by Michael Osipov (michaelo at apache.org)

> ### I18N

> - Improve translation "`save_as`" in French. Based on a Pull request #252 - by Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60785 - Improvement of Japanese translation. Patch by Kimono (kimono.outfit.am at gmail.com).

> ### Report / Dashboard

> - Bug 60637 - Improve Statistics table design

> - Bug 60112 - Report / Dashboard : Add ability to customize APDEX thresholds per Transaction name. Contributed by Stephane Leplus (s.leplus at ubik-ingenierie.com)

> ### General

> - Bug 58164 - Check if file already exists on ResultCollector listener before starting the loadtest
> - Bug 54525 - Search Feature : Enhance it with ability to replace
> - Bug 60530 - Add API to create JMeter threads while test is running. Based on a contribution by Logan Mauzaize (logan.mauzaize at gmail.com) and Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60514 - Ability to apply a naming convention on Children of a Transaction Controller. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60711 - Improve Delete button behaviour for Assertions / Header Manager / User Parameters GUIs / Exclude, Include in HTTP(S) Test Script Recorder
> - Bug 60593 - Switch to G1 GC algorithm
> - Bug 60595 - Add a SplashScreen at the start of JMeter GUI. Contributed by Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 55258 - Drop "Close" icon from toolbar and add "New" to menu. Partly based on contribution from Sanduni Kanishka (https://github.com/SanduniKanishka)
> - Bug 59995 - Allow user to change font size with two new menu items and use `jmeter.hidpi.scale.factor` for scaling fonts. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60654 - Validation Feature : Be able to ignore BackendListener. Contributed by Maxime Chassagneux (maxime.chassagneux at gmail.com).
> - Bug 60646 - Workbench : Save it by default
> - Bug 60684 - Thread Group: Validate ended prematurely by Scheduler with 0 or very short duration. Contributed by Andrew Burton (andrewburtonatwh at gmail.com).
> - Bug 60589 - Migrate LogKit to SLF4J - Drop Avalon, LogKit and Excalibur with backward compatibility for 3rd party modules. Contributed by Woonsan Ko (woonsan at apache.org)
> - Bug 60565 - Migrate LogKit to SLF4J - Optimize logging statements. e.g, message format args, throwable args, unnecessary if-enabled-logging in simple ones, etc. Contributed by Woonsan Ko (woonsan at apache.org)
> - Bug 60564 - Migrate LogKit to SLF4J - Replace LogKit loggers with SLF4J ones and keep the current LogKit binding solution for backward compatibility with plugins. Contributed by Woonsan Ko (woonsan at apache.org)
> - Bug 60664 - Add a UI menu to set log level. Contributed by Woonsan Ko (woonsan at apache.org)
> - Pull request #276 - - Added some translations for polish locale. Contributed by Bartosz Siewniak (barteksiewniak at gmail.com)
> - Bug 60792 - Create a new Help menu item to create a thread dump
> - Bug 60813 - JSR223 Test element : Take into account JMeterStopTestNowException, JMeterStopTestException and JMeterStopThreadException
> - Bug 60814 - Menu : Add `Open Recent` menu item to make recent files loading more obvious
> - Bug 60815 - Drop "Reset GUI" from menu
> - Bug 60886 - Build improvements to better enable builds in environments that are behind a proxy. Partly contributed by Michael Osipov (michaelo at apache.org)

> Non-functional changes

> - Bug 60415 - Drop support for Java 7.
> - Updated to dnsjava-2.1.8.jar (from 2.1.7)
> - Updated to groovy 2.4.10 (from 2.4.7)
> - Updated to httpcore 4.4.6 (from 4.4.5)
> - Updated to httpclient 4.5.3 (from 4.5.2)
> - Updated to jodd 3.8.1 (from 3.7.1.jar)
> - Updated to jsoup-1.10.2 (from 1.10.1)
> - Updated to ph-css 5.0.3 (from 4.1.6)
> - Updated to ph-commons 8.6.0 (from 6.2.4)
> - Updated to slf4j-api 1.7.25 (from 1.7.21)
> - Updated to asm 5.2 (from 5.1)
> - Updated to rsyntaxtextarea-2.6.1 (from 2.6.0)
> - Updated to commons-net-3.6 (from 3.5)
> - Updated to json-smart-2.3 (from 2.2.1)
> - Updated to accessors-smart-1.2 (from 1.1)
> - Converted the old pdf tutorials to xml.
> - Pull request #255 - - Utilised Java 8 (and 7) features to tidy up code. Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 59435 - JMeterTestCase no longer supports JUnit3

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 60531 - HTTP Cookie Manager : changing Implementation does not update Cookie Policy
> - Bug 60575 - HTTP GET Requests could have a content-type header without a body.
> - Bug 60682 - HTTP Request : Get method may fail on redirect due to Content-Length header being set
> - Bug 60643 - HTTP(S) Test Script Recorder doesn't correctly handle restart or start after stop. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60652 - HTTP PUT Requests might leak file descriptors.
> - Bug 60689 - `httpclient4.validate_after_inactivity` has no impact leading to usage of potentially stale/closed connections
> - Bug 60690 - Default values for "httpclient4.validate_after_inactivity" and "httpclient4.time_to_live" which are equal to each other makes validation useless
> - Bug 60758 - HTTP(s) Test Script Recorder : Number request may generate duplicate numbers. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 56939 - Parameters are not passed with OPTIONS HTTP Request
> - Bug 60778 - Http Java Impl does not show Authorization header in SampleResult even if it is sent
> - Bug 60837 - GET with body, PUT are not retried even if `httpclient4.retrycount` is higher than 0
> - Bug 60842 - Trim extracted URLs when loading embedded resources using the Lagarto based HTML Parser.
> - Bug 60928 - Http Request : Connection Leak when keepalive is used with Embedded Resources

> ### Other Samplers

> - Bug 603982 - Guard Exception handler of the `JDBCSampler` against null messages
> - Bug 55652 - JavaSampler silently resets classname if class can not be found

> ### Controllers

> ### Listeners

> - Bug 60648 - GraphiteBackendListener can lose some metrics at end of test if test is very short
> - Bug 60650 - AbstractBackendListenerClient does not reset UserMetric between runs
> - Bug 60759 - View Results Tree : Search feature does not search in URL. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60859 - Save Responses to a file : 2 elements with different configuration will overlap

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 60438 - Pull request #235 - - Clear old variables before extracting new ones in JSON Extractor. Based on a patch by Qi Chen (qi.chensh at ele.me)
> - Bug 60607 - DNS Cache Manager configuration is ignored
> - Bug 60729 - The Random Variable Config Element should allow minimum==maximum
> - Bug 60730 - The JSON PostProcessor should set the `_ALL` variable even if the JSON path matches only once.
> - Bug 60747 - Response Assertion : Add Request Headers to `Field to Test`
> - Bug 60763 - XMLAssertion should not leak errors to console
> - Bug 60797 - TestAction in pause mode can last beyond configured duration of test

> ### Functions

> - Bug 60819 - Function __fileToString does not honor the documentation contract when file is not found

> ### I18N

> ### Report / Dashboard

> - Bug 60726 - Report / Dashboard : Top 5 errors by samplers must not take into account the series filtering
> - Bug 60919 - Report / Dashboard : Latency Vs Request and Response Time Vs Request are wrong if granularity is different from 1000 (1 second)

> ### General

> - Bug 60775 - NamePanel ctor calls overrideable method
> - Bug 60428 - JMeter Graphite Backend Listener throws exception when test ends and `useRegexpForSamplersList` is set to `true`. Based on patch by Liu XP (liu_xp2003 at sina.com)
> - Bug 60442 - Fix a typo in `build.xml` (gavin at 16degrees.com.au)
> - Bug 60449 - JMeter Tree : Annoying behaviour when node name is empty
> - Bug 60494 - Add sonar analysis task to build
> - Bug 60501 - Search Feature : Performance issue when regexp is checked
> - Bug 60444 - Intermittent failure of `TestHTTPMirrorThread#testSleep()`. Contributed by Thomas Schapitz (ts-nospam12 at online.de)
> - Bug 60621 - The "`report-template`" folder is missing from `ApacheJMeter_config-3.1.jar` in maven central
> - Bug 60744 - GUI elements are not cleaned up when reused during load of Test Plan which can lead them to be partially initialized with a previous state for a new Test Element
> - Bug 60812 - JMeterThread does not honor contract of JMeterStopTestNowException
> - Bug 60857 - SaveService omits XML header if _file_encoding is not defined in saveservice.properties
> - Bug 60830 - Timestamps in CSV file could be corrupted due to sharing a SimpleDateFormatter across threads

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Jerome Loisel (loisel.jerome at gmail.com)
> - Liu XP (liu_xp2003 at sina.com)
> - Qi Chen (qi.chensh at ele.me)
> - (gavin at 16degrees.com.au)
> - Thomas Schapitz (ts-nospam12 at online.de)
> - Murdecai777 (https://github.com/Murdecai777)
> - Logan Mauzaize (logan.mauzaize at gmail.com)
> - Maxime Chassagneux (maxime.chassagneux at gmail.com)
> - 忻隆 (298015902 at qq.com)
> - Ubik Load Pack
> - Graham Russell (graham at ham1.co.uk)
> - Sanduni Kanishka (https://github.com/SanduniKanishka)
> - Andrew Burton (andrewburtonatwh at gmail.com)
> - Woonsan Ko (woonsan at apache.org)
> - Bartosz Siewniak (barteksiewniak at gmail.com)
> - Kimono (kimono.outfit.am at gmail.com)
> - Michael Osipov (michaelo at apache.org)
> - Stephane Leplus (s.leplus at ubik-ingenierie.com)

> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:

> - Tuukka Mustonen (tuukka.mustonen at gmail.com) who gave us a lot of useful feedback which helped resolve Bug 60689 and Bug 60690
> - Amar Darisa (amar.darisa at gmail.com) who helped us with his feedback on Bug 60682

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - View Results Tree may freeze rendering large response particularly if this response has no spaces, see Bug 60816 . This is due to an identified Java Bug UI stuck when calling JEditorPane.setText() or JTextArea.setText() with long text without space.
> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like md2WithRSAEncryption) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 8+.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later (but be aware that Java 9 is not certified yet for JMeter).
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with JAVA 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 3.1

> Summary

> - New and Noteworthy
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Known problems and workarounds
> - Thanks

> New and Noteworthy

> Improve Report/Dashboard

> The Dashboard has been improved with 3 new graphs and 1 summary table:

> - Connect Time over Time graph :

> - Response Time Percentiles Over Time (successful responses) graph :

> - Response Time Overview graph :

> - Top 5 errors by Sampler table :

> - More details on errors in Errors table
> - Average response time added to Statistics table :

> - Active Threads table now stacks threads :

> New Metrics

> A new `sent_bytes` metric has been introduced which reports the bytes sent to server.
> Another metric `connect_time` has been enabled by default in this version

> Handling Big responses

> JMeter is now able to handle in terms of metrics responses bigger than 2GB, limit has been increased to 9223372 TB.
> To handle such big responses, it can also now truncate part of the response to avoid overflooding memory. See `httpsampler.max_bytes_to_store_per_request` property.

> New function

> Introduce a new function `__groovy` that enables Groovy functions. This can be handy, as JavaScript can be quite slow (same for BeanShell), when used in highly concurrent test plans.

> Use Groovy as default for JSR-223 elements

> Groovy is now set as the default language for JSR-223 elements. If you want to use another of the supported language, you have to make an explicit choice.

> By default `Cache compiled script if available` is not checked by default although we advise you to check it and ensure you don't use `${varName}` syntax to access JMeter variables but `vars.get("varName")` instead.

> Formatted HTML source view in Results Tree View

> The HTML source code in the Results Tree View can now be viewed formatted. This is extremely useful, if the code of the webpage has been stripped of all superfluous whitespace.

> New formatted HTML source view

> Ability to update all timers in Test plan with a new property

> A new property `timer.factor=1.0f` has been introduced which allows you to multiply pause times computed by Gaussian, Uniform and Poisson Timers by it. This allows you to update Think Times from one place and let you gain productivity.

> Core improvements

> - Various GUI and UX fixes
> - Memory usage improvements
> - JDBC Request is now able to return Blob/Clob and computes latency and connect time
> - CSS Parsing introduced in 3.0 has been optimized by introduction of a parsing cache
> - HTTP Request is now able to handle body in GET request, this is useful for Elastic Search requests for example.

> Documentation improvements

> - Documentation review and improvements for easier startup
> - New properties reference documentation section

> Incompatible changes

> - A cache for CSS Parsing of URLs has been introduced in this version, it is enabled by default. It is controlled by property `css.parser.cache.size`. It can be disabled by setting its value to `0`. See Bug 59885
> - ThroughputController defaults have changed. Now defaults are Percent Executions which is global and no more per user. See Bug 60023
> - Since version 3.1, HTML report ignores empty `Transaction Controller` (possibly generated by `If Controller` or `Throughput Controller`) when computing metrics. This provides more accurate metrics
> - Since version 3.1, Summariser ignores SampleResults generated by `Transaction Controller` when computing the live statistics, see Bug 60109
> - Since version 3.1, when using Stripped modes (by default `StrippedBatch` is used), response will be stripped also for failing SampleResults, you can revert this to previous behaviour by setting `sample_sender_strip_also_on_error=false` in `user.properties`, see Bug 60137
> - Since version 3.1, `jmeter.save.saveservice.connect_time` property value is `true`, meaning CSV file for results will contain an additional column containing connection time, see Bug 60106
> - Since version 3.1, Random Timer subclasses (Gaussian Random Timer, Uniform Random Timer and Poisson Random Timer) implement interface `org.apache.jmeter.timers.ModifiableTimer`
> - Since version 3.1, if you don't select any language in JSR223 Test Elements, Apache Groovy language will be used. See Bug 59945
> - Since version 3.1, CSV DataSet now trims variable names to avoid issues due to spaces between variables names when configuring CSV DataSet. This should not have any impact for you unless you use space at the beginning or end of your variable names. See Bug 60221
> - Since version 3.1, HTTP Request is able when using HttpClient4 (default) implementation to handle responses bigger than `2147483647` Bytes, that is 2GB. To allow this two properties have been introduced:
>   - `httpsampler.max_bytes_to_store_per_request` (defaults to 10MB) will control what is held in memory. By default JMeter will only keep in memory the first 10MB of a response. If you have responses larger than this value and use assertions that are after the first 10MB, then you must increase this value
>   - `httpsampler.max_buffer_size` will control the buffer used to read the data. Previously JMeter used a buffer equal to Content-Length header which could lead to failures and make JMeter less resistant to faulty applications, but note this may impact response times and give slightly different results than previous versions if your application returned a Content-Length header higher than current default value (65KB)
>   See Bug 53039

> ### Deprecated and removed elements or functions

> These elements do not appear anymore in the menu, if you need them modify `not_in_menu` property. The JMeter team advises not to use them anymore and migrate to their replacement.

> - Bug 60222 - Remove deprecated elements Distribution Graph, Spline Visualizer
> - Bug 60224 - Deprecate `Monitor Results` listener. It will be dropped in next version.
> - Bug 60323 - Deprecate BSF Elements (Use JSR223 Elements instead). They will probably be dropped in N+2 version. The following elements are deprecated:
>   - `BSF Sampler`
>   - `BSF Listener`
>   - `BSF Assertion`
>   - `BSF Timer`
>   - `BSF PreProcessor`
>   - `BSF PostProcessor`
> - Bug 60225 - Drop deprecated `__jexl` function, jexl support in BSF and dependency on `commons-jexl-1.1.jar`. This function can be easily replaced with `__jexl3` function
> - Bug 60268 - Drop org.apache.jmeter.gui.action.Analyze and deprecate org.apache.jmeter.reporters.FileReporter (will be removed in next version)

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 59882 - Reduce memory allocations for better throughput. Contributed by Benoit Wiart (b.wiart at ubik-ingenierie.com) through Pull request #217 - and Pull request #228 -
> - Bug 59885 - Optimize css parsing for embedded resources download by introducing a cache. Contributed by Benoit Wiart (b.wiart at ubik-ingenierie.com) through Pull request #219 -
> - Bug 60092 - View Result Tree: Add shortened version of the PUT body to sampler result.
> - Bug 60229 - Add a new metric : sent_bytes. Implemented by Philippe Mouawad (p.mouawad at ubik-ingenierie.com) and contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 53039 - HTTP Request : Be able to handle responses which size exceeds `2147483647` bytes (that is 2GB)
> - Bug 60265 - HTTP Request : In Files Upload Tab you cannot resize columns
> - Bug 60318 - Ignore CSS warnings when parsing with ph-css library.
> - Bug 60358 - Http Request : Allow sending Body Data for HTTP GET request

> ### Other samplers

> - Pull request #211 - Differentiate the timing for JDBC Sampler. Use latency and connect time. Contributed by Thomas Peyrard (thomas.peyrard at murex.com)
> - Bug 59620 - Fix button action in "JMS Publisher → Random File from folder specified below" to allow to select a directory
> - Bug 60066 - Handle CLOBs and BLOBs and limit them if necessary when storing them in result sampler.

> ### Controllers

> - Bug 59351 - Improve log/error/message for IncludeController. Partly contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 60023 - ThroughputController : Make "Percent Executions" and global the default values. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60082 - Validation mode : Be able to force Throughput Controller to run as if it was set to 100%
> - Bug 59349 - Trim spaces in input filename in IncludeController.
> - Bug 60081 - Interleave Controller : Add an option to alternate across threads

> ### Listeners

> - Bug 59953 - GraphiteBackendListener : Add Average metric. Partly contributed by Maxime Chassagneux (maxime.chassagneux at gmail.com)
> - Bug 59975 - View Results Tree : Text renderer annoyingly scrolls down when content is bulky. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60109 - Summariser : Make it ignore TC generated SampleResult in its summary computations
> - Bug 59948 - Add a formatted and sane HTML source code render to View Results Tree
> - Bug 60252 - Add sent kbytes/s to Aggregate Report and Summary report
> - Bug 60267 - UX : In View Results Tree it should be possible to close the Configure popup by typing escape. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 59845 - Log messages about JSON Path mismatches at `debug` level instead of `error`.
> - Pull request #212 - Allow multiple selection and delete in HTTP Authorization Manager. Based on a patch by Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Bug 59816 - Pull request #213 - Allow multiple selection and delete in HTTP Header Manager. Based on a patch by Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Bug 59967 - CSS/JQuery Extractor : Allow empty default value. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 59974 - Response Assertion : Add button "`Add from clipboard`". Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60050 - CSV Data Set : Make it clear in the logs when a thread will exit due to this configuration
> - Bug 59962 - Cache Manager does not update expires date when response code is `304`.
> - Bug 60018 - Timer : Add a factor to apply on pauses. Partly based on a patch by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60203 - Use more available space for textarea in XPath Assertion.
> - Bug 60220 - Rename JSON Path Post Processor to JSON Extractor
> - Bug 60221 - CSV DataSet : trim variable names
> - Bug 59329 - Trim spaces in input filename in CSVDataSet.

> ### Functions

> - Bug 59963 - New function `__RandomFromMultipleVars`: Ability to compute a random value from values of one or more variables. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 59991 - New function `__groovy` to evaluate Groovy Script. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### I18N

> - Pull request #214 - Add spanish translation for delayed starting of threads. Contributed by Asier Lostalé (asier.lostale at openbravo.com).
> - Bug 60348 - Change chinese translation for `Save as`. Contributed by XMeter (support at xmeter.net).

> ### Report / Dashboard

> - Bug 59954 - Web Report/Dashboard : Add average metric
> - Bug 59956 - Web Report / Dashboard : Add ability to generate a graph for a range of data
> - Bug 60065 - Report / Dashboard : Improve Dashboard Error Summary by adding response message to "Type of error". Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60079 - Report / Dashboard : Add a new "Response Time Overview" graph
> - Bug 60080 - Report / Dashboard : Add a new "Connect Time Over Time " graph. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60091 - Report / Dashboard : Have a new report containing min/max and percentiles graphs.
> - Bug 60108 - Report / Dashboard : In Requests Summary rounding is too aggressive
> - Bug 60098 - Report / Dashboard : Reduce default value for "`jmeter.reportgenerator.statistic_window`" to reduce memory impact
> - Bug 60115 - Add date format property for start/end date filter into Report generator
> - Bug 60171 - Report / Dashboard : Active Threads Over Time should stack lines to give the total amount of threads running
> - Bug 60250 - Report / Dashboard : Need to Add Sent KB/s in Statistics Report of HTML Dashboard
> - Bug 60287 - Report / Dashboard : Have a new Top5 Errors by sampler table in Dashboard. Implemented by Philippe Mouawad (p.mouawad at ubik-ingenierie.com) and contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### General

> - Bug 59803 - Use `isValid()` method from JDBC driver, if no `validationQuery` is given in JDBC Connection Configuration.
> - Bug 57493 - Create a documentation page for properties
> - Bug 59924 - The log level of XXX package is set to `DEBUG` if `log_level.XXXX` property value contains spaces, same for `__log` function
> - Bug 59777 - Extract SLF4J binding into its own jar and make it a JMeter lib.

>   If you get a warning about multiple SLF4J bindings on startup. Remove either the Apache JMeter provided binding `lib/ApacheJMeter_slf4j_logkit.jar`, or all of the other reported bindings. For more information you can have a look at SLF4Js own info page.

> - Bug 60085 - Remove cache for prepared statements, as it didn't work with the current JDBC pool implementation and current JDBC drivers should support caching of prepared statements themselves.
> - Bug 60137 - In Distributed testing when using StrippedXXXX modes strip response also on error
> - Bug 60106 - Settings defaults : Switch "`jmeter.save.saveservice.connect_time`" to true (after 3.0)
> - Pull request #229 - tiny memory allocation improvements. Contributed by Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Bug 59945 - For all JSR223 elements, if script language has not been chosen on the UI, the script will be interpreted as a groovy script.
> - Bug 60266 - Usability/ UX : It should not be possible to close/exit/Revert/Load/Load a recent project or create from template a JMeter plan or open a new one if a test is running
> - Bug 57305 - Remove dependency of `ProxyControl` on `GuiPackage`. Based on patches by jarek102 (jarek102 at gmail.com) and Wyatt Epp (wyatt.epp at gmail.com)

> Non-functional changes

> - Updated to jsoup-1.10.1 (from 1.8.3)
> - Updated to ph-css 4.1.6 (from 4.1.4)
> - Updated to tika-core and tika-parsers 1.14 (from 1.12)
> - Updated to commons-io 2.5 (from 2.4)
> - Updated to commons-lang3 3.5 (from 3.4)
> - Updated to commons-net 3.5 (from 3.4)
> - Updated to groovy 2.4.7 (from 2.4.6)
> - Updated to httpcore 4.4.5 (from 4.4.4)
> - Updated to slf4j-api 1.7.21 (from 1.7.13)
> - Updated to rsyntaxtextarea-2.6.0 (from 2.5.8)
> - Updated to xstream 1.4.9 (from 1.4.8)
> - Updated to jodd 3.7.1 (from 3.6.7.jar)
> - Updated to xmlgraphics-commons 2.1 (from 2.0.1)
> - Pull request #215 - Reduce duplicated code by using the newly added method `GuiUtils#cancelEditing`. Contributed by Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Pull request #218 - Misc cleanup. Contributed by Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Pull request #216 - Re-use pattern when possible. Contributed by Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Bug 60364 - Document Test Coverage. Contributed by Thomas Schapitz (ts-nospam12 at online.de)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 58888 - HTTP(S) Test Script Recorder (ProxyControl) does not add TestElement's returned by `SamplerCreator#createChildren()`
> - Bug 59902 - Https handshake failure when setting `httpclient.socket.https.cps` property
> - Bug 60084 - JMeter 3.0 embedded resource URL is silently encoded
> - Bug 60376 - Http Test Script Recorder : If deflate is used by server then recording may break application

> ### Other Samplers

> - Bug 59113 - JDBC Connection Configuration : Transaction Isolation level not correctly set if constant used instead of numerical

> ### Controllers

> - Bug 60361 - ModuleController : If a Test plan contains a Module Controller which references an unexistant Controller, JMeter in GUI mode will not stop

> ### Listeners

> - Bug 59712 - Display original query in RequestView when decoding fails. Based on a patch by Teemu Vesala (teemu.vesala at qentinel.com)
> - Bug 60278 - Since 2.13 (and Bug 57514 ), Aggregate Graph, Summary Report and Aggregate Report lost precision in the Error, Rate and Bandwidth values saved in the saved file csv
> - Bug 60360 - View Result Tree : Request Tab does not show body of a DELETE request

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 59964 - JSR223 Test Element : Cache compiled script if available is not correctly reset. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 59609 - Format extracted JSON Objects in JSON Post Processor correctly as JSON.
> - Bug 60332 - View Results Tree : With Windows LAF, JSON Extractor does not show JSON Path Expression and Result panel

> ### Functions

> ### I18N

> ### General

> - Bug 59400 - Get rid of UnmarshalException on stopping when `-X` option is used.
> - Bug 59607 - JMeter crashes when reading large test plan (greater than 2GB). Based on fix by Felix Draxler (felix.draxler at sap.com)
> - Bug 59621 - Error count in report dashboard is one off.
> - Bug 59657 - Only set font in JSyntaxTextArea, when property `jsyntaxtextarea.font.family` is set.
> - Bug 59720 - Batch test file comparisons fail on Windows as XML files are generated as EOL=LF
> - Code cleanups. Patches by Graham Russell (graham at ham1.co.uk)
> - Bug 59722 - Use StandardCharsets to reduce the possibility of misspelling Charset names.
> - Bug 59723 - Use `jmeter.properties` for testing whenever possible
> - Bug 59726 - Unit test to check that CSV header text and sample format don't change unexpectedly
> - Bug 59889 - Change encoding to UTF-8 in reports for dashboard.
> - Bug 60053 - In Non GUI mode, a Stacktrace is shown at end of test while report is being generated
> - Bug 60049 - When using Timers with high delays or Constant Throughput Timer with low throughput, Scheduler may take a lot of time to exit, same for Shutdown test
> - Bug 60089 - Report / Dashboard : Bytes throughput Over Time has reversed Sent and Received bytes. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 60090 - Report / Dashboard : Empty Transaction Controller should not count in metrics
> - Bug 60103 - Report / Dashboard : Requests summary includes Transaction Controller leading to wrong percentage
> - Bug 60105 - Report / Dashboard : Report requires Transaction Controller "`generate parent sample`" option to be checked, fix related issues
> - Bug 60107 - Report / Dashboard : In StatisticSummary, TransactionController SampleResult makes Total line wrong
> - Bug 60110 - Report / Dashboard : In Response Time Percentiles, slider is useless
> - Bug 60135 - Report / Dashboard : Active Threads Over Time should be in OverTime section
> - Bug 60125 - Report / Dashboard : Dashboard cannot be generated if the default delimiter is `\t`. Based on a report from Tamas Szabadi (tamas.szabadi at rightside.co)
> - Bug 59439 - Report / Dashboard : AbstractOverTimeGraphConsumer.createGroupInfos() should be abstract
> - Bug 59918 - Ant generated HTML report is broken (extras folder)
> - Bug 60295 - JSON Extractor doesn't index array elements when only one element is found. Based on a patch by Roberto Braga (roberto.braga at sociale.it)
> - Bug 60299 - Thread Group with Scheduler : Weird behaviour when End-Time is in the past

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Felix Draxler (felix.draxler at sap.com)
> - Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Graham Russell (graham at ham1.co.uk)
> - Teemu Vesala (teemu.vesala at qentinel.com)
> - Asier Lostalé (asier.lostale at openbravo.com)
> - Thomas Peyrard (thomas.peyrard at murex.com)
> - Benoit Wiart (b.wiart at ubik-ingenierie.com)
> - Maxime Chassagneux (maxime.chassagneux at gmail.com)
> - Ubik Load Pack
> - Tamas Szabadi (tamas.szabadi at rightside.co)
> - Roberto Braga (roberto.braga at soziale.it)
> - jarek102 at gmail.com
> - Wyatt Epp (wyatt.epp at gmail.com)
> - Thomas Schapitz (ts-nospam12 at online.de)

> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629. A workaround is to use a Java 7 update 40 runtime which fixes this issue.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like md2WithRSAEncryption) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 7 version u16 (MD2) and version u40 (Certificate size lower than 1024 bits), and Java 8 too.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK7_u79, JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with JAVA 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 3.0

> Summary

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> Test plan creation and debugging improvements

> New Search Feature in View Results Tree to allow searching for text / regexp in Request/Responses/Headers/Cookies/… This will ease correlation and Test plans creation

> New JSON Post Processor to better extract data from JSON content using user friendly JSON-PATH syntax

> JSON is now a first class citizen in JMeter with the introduction of a new JSONPath post processor. This post processor is very similar to Regular Expression Post Processor but is well suited for JSON code. It is based on Jayway JSON Path library

> New validation feature, in one click run a selection of Thread Groups with user, no pause and iteration

> JSR223 Test Elements do not require a Cache Compilation Key anymore

> Just check `Cache compiled script if available` checkbox and the elements (Pre-Processor, Post-Processor, Assertions, Listeners, …) will pre-compile the script and cache the compiled code if the underlying language supports it

> Nashorn can now be used as Javascript engine providing better performance and easier usage

> To enable Nashorn, you need to set in `user.properties`:

>     javascript.use_rhino=false

> Nashorn can be used with Java 8 in the following elements:

> - IfController
> - JSR223 Test elements with `javascript` language selected
> - `__javaScript` function

> Jexl3 has been integrated. It provides new scripting features and much better documentation

> JEXL3 can now be used thanks to a new function `__jexl3`. JEXL is a language very similar to JSTL.

> Simplified HTTP Request UI

> A new "`Advanced`" tab has been added to HTTP Request to simplify configuration. The file upload feature has been moved into a dedicated tab. This increases the space available for parameters in UI and simplifies the UX.

> HTTP Request Defaults improvements

> You can now configure Source Address (IP Spoofing like feature) and "`Save response as MD5 hash`" in Advanced Tab

> Reporting improvements

> New Reporting Feature generating dynamic Graphs in HTML pages (APDEX, Summary report and Graphs)

> A dynamic HTML report can now be generated either at the end of a load test or from a result file whenever you want. See Generating dashboard for more details. This report provides the following metrics:

> - APDEX (Application Performance Index) table that computes the APDEX based on configurable values for tolerated and satisfied thresholds
> - A request summary graph showing the Success and failed transaction percentage:

> - A Statistics table providing in one table a summary of all metrics per transaction including 3 configurable percentiles :

> - An error table providing a summary of all errors and their proportion in the total requests :

> - Zoomable chart where you can check/uncheck every transaction to show/hide it for:
>   - Response times Over Time :

>   - Bytes throughput Over Time :

>   - Latencies Over Time :

>   - Hits per second :

>   - Response codes per second :

>   - Transactions per second :

>   - Response Time vs Request per second :

>   - Latency vs Request per second :

>   - Response times percentiles :

>   - Active Threads Over Time :

>   - Times vs Threads :

>   - Response Time Distribution :

> GraphiteBackendListener has a new Server Hits metric

> Summariser displays a more readable duration

> Now duration are display in the format `hours:minutes:seconds`

>     Generate Summary Results +      1 in 00:00:01 =    1.7/s Avg:     1 Min:     1 Max:     1 Err:     0 (0.00%) Active: 1 Started: 1 Finished: 0
>     Generate Summary Results +    138 in 00:00:09 =   16.2/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%) Active: 9 Started: 9 Finished: 0
>     Generate Summary Results =    139 in 00:00:09 =   15.3/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%)
>     Generate Summary Results +    467 in 00:00:10 =   47.0/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%) Active: 19 Started: 19 Finished: 0
>     Generate Summary Results =    606 in 00:00:19 =   31.9/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%)
>     ⋮
>     Generate Summary Results +   1662 in 00:00:10 =  166.1/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%) Active: 50 Started: 50 Finished: 0
>     Generate Summary Results =  28932 in 00:03:19 =  145.4/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%)
>     Generate Summary Results +   1664 in 00:00:10 =  166.4/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%) Active: 50 Started: 50 Finished: 0
>     Generate Summary Results =  30596 in 00:03:29 =  146.4/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%)
>     Generate Summary Results +   1661 in 00:00:10 =  166.1/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%) Active: 50 Started: 50 Finished: 0
>     Generate Summary Results =  32257 in 00:03:39 =  147.3/s Avg:     0 Min:     0 Max:     1 Err:     0 (0.00%)

> BackendListener now allows you to define sampler list as a regular expression

> You can now use a regular expression to select the samplers you want to filter. Use parameter: `useRegexpForSamplersList=true` and put a regex in parameter `samplersList`

> Protocols and Load Testing improvements

> Migration to HttpClient 4.5.2 has been started. Although not completely finished, it improves many areas in JMeter

> Migration to HttpClient 4.5.2 improves the following fields of JMeter:

> - Support of recent RFC like HTTP State Management Mechanism RFC-6265 for Cookies, you should use now `HC4CookieHandler` in HTTP Cookie Manager component and select `standard` Cookie policy
> - Server Name Indication (SNI) support for HttpClient4 implementation
> - Improved and better performing validation mechanism for Stale connections and Keep-Alive management, see properties `httpclient4.validate_after_inactivity` and `httpclient4.time_to_live`
> - Many bug fixes since previous version 4.2.6 used in JMeter 2.13, see HttpClient 4.5.X release notes
> - Better support of HTTP RFC 2616 / RFC 7230 and fixes to issues with `deflate` compression management

> Parallel Downloads is now realistic and scales much better:

> - Parsing of CSS imported files (through `@import`) or embedded resources (background, images, …)
> - Lazy initialization of SSL context: For 15 Threads 138% more sampling in 5 minutes for HTTP only tests. Gain increases as number of threads increases
> - Rework of Connection management for Parallel Download: This better simulates current browser behaviour and improves throughput. For 15 Threads 135% extra samples in 5 minutes.
> - Reuse of Threads used for Parallel downloads through a ThreadPool: This improves throughput and increases JMeter scalability for such tests
> - Total of 750% more throughput found on test with 15 threads, the more threads you have the more the gain
> - You can now compute and store just the MD5 of embedded resources instead of storing the entire response, this can be done by setting the property `httpsampler.embedded_resources_use_md5=true`

> Introduction of Sample Timeout feature

> This new Sample Timeout Pre-Processor allows you to apply a Timeout on the elements that are in its scope. In the screenshot below the 10 second timeout applies to the `Debug Sampler` and `HTTP Request` elements.

> JDBC request now uses DBCP2 pool

> JDBC Request and JDBC Connection Configuration have been updated to replace old Excalibur Pool by Apache Commons DBCP2 pool. As a consequence properties have been migrated to equivalent when available and UI has been updated. Note that unlike Excalibur, Commons DBCP uses the validation query when creating the pool. So make sure the query is valid. The default query suits many databases, but not all - for example Oracle requires '`SELECT 1 FROM DUAL`' or similar.

> UX Improvements:

> Better display in HiDPI screens

> See JMeter with a HiDPI screen on Linux or Windows in Hints and Tips section in user manual

> New Icon look and Logo

> JMeter has a new Logo created by Felix Schumacher.
> Icons have also been refreshed to give a more modern style and make them more meaningful

> Lots of fixes of annoying little bugs

> Around 40 UI fixes have been made to either fix buggy, confusing behaviour or simplify usage by not allowing incompatible options to be selected

> Improved Thread Group UI and related actions (, , )

> Creating and testing a Test Plan before Load Test has been much simplified by allowing you to only start a selection of Thread Group, start them without applying Timers (thus gaining time) or start them using a new Validation mode. This validation mode allows you to start a Thread Group (without modifying it) with 1 thread, 1 iteration and without applying timers. This validation mode can be customized.

> New shortcuts

> - Add most used elements (Ctrl + 0 … Ctrl + 9), configurable through `gui.quick_XXX` properties
> - Shortcuts to expand nodes

> Core improvements

> Configuration simplification with better defaults

> Default values for many properties have been modified to make JMeter configuration optimal Out of the box. Read "Incompatible changes" section for more details.

> Apache Groovy bundled with JMeter

> Apache Groovy, the well-known JVM scripting language, is now bundled with Apache JMeter in lib folder. This allows you to use it immediately through JSR223 Elements by selecting the Groovy language.

> Superfluous and old properties removed

> Old properties that existed to maintain backward compatibility or to offer some superfluous customization have been removed. Read "Incompatible changes" section to see which properties have been removed.

> Code and documentation improvements

> - Migration to Java7 source code and use of its syntactic sugar
> - Major code cleanups
> - Full review of documentation and improvement both in content and presentation

> Improvements to unit tests

> - Migration of many tests to JUnit 4
> - Better management of Headless tests
> - More Unit Tests

> Dependencies refresh

> Deprecated Libraries dropped or replaced by up to date ones:

> - Excalibur replaced by commons-dbcp
> - htmllexer, htmlparser removed
> - soap removed
> - jdom removed

> Slf4j can now be used within Plugins and core code

> You can now use SLF4J logging wrapper in your custom plugins or `org.apache.jmeter.protocol.java.sampler.AbstractJavaSamplerClient` subclasses.

> Incompatible changes

> - Since version 3.0, Groovy-2.4.6 is bundled with JMeter (`lib` folder), ensure you remove old version or referenced versions through properties `search_paths` or `user.classpath`
> - Since version 3.0, `jmeter.save.saveservice.assertion_results_failure_message` property value is true, meaning CSV file for results will contain an additional column containing assertion result response message, see Bug 58978
> - Since version 3.0, `jmeter.save.saveservice.print_field_names` property value is true, meaning CSV file for results will contain field names as first line in CSV, see Bug 58991
> - Since version 3.0, `jmeter.save.saveservice.idle_time` property value is true, meaning CSV/XML result files will contain an additional column containing idle time between samplers, see Bug 57182
> - In RandomTimer class, protected instance `timer` field has been replaced by `getTimer()` protected method, this is related to Bug 58100 . This may impact 3rd party plugins.
> - Since version 3.0, you can use Nashorn Engine (default javascript engine is Rhino) under Java8 for Elements that use Javascript Engine (`__javaScript`, `IfController`). If you want to use it, use property `javascript.use_rhino=false`, see Bug 58406 .

>   Note: in a future version, we will switch to Nashorn by default. Users are encouraged to report any issue related to using Nashorn instead of Rhino.

> - Since version 3.0, JMS Publisher will reload contents of file if Message source is "`From File`" and the "`Filename`" field changes (e.g. if it uses a variable that has changed)
> - `org.apache.jmeter.gui.util.ButtonPanel` has been removed, if you use it in your 3rd party plugin or custom development ensure you update your code. See Bug 58687
> - Property `jmeterthread.startearlier` has been removed. See Bug 58726
> - Property `jmeterengine.startlistenerslater` has been removed. See Bug 58728
> - Property `jmeterthread.reversePostProcessors` has been removed. See Bug 58728
> - Property `jmeter.toolbar.display` has been removed, the toolbar is now always displayed. See Bug 59236
> - Property `jmeter.errorscounter.display` has been removed, the errors/warnings counter is now always displayed. See Bug 59236
> - Property `xml.parser` has been removed, it is not used anymore as `org.apache.jmeter.util.JMeterUtils#getXMLParser` has been deprecated and is not used either. See Bug 59236
> - Summariser listener now shows the duration in the format `HH:mm:ss` (Hour:Minute:Second), it previously showed the duration in seconds. See Bug 58776
> - `org.apache.jmeter.protocol.http.visualizers.RequestViewHTTP.getQueryMap` signature has changed, if you use it ensure you update your code. See Bug 58845
> - JMS Subscriber will consider a sample to be an error if the number of received messages is not equal to expected number of messages. It previously considered a sample OK if at least 1 message was received. See Bug 58980
> - Since version 3.0, HTTP(S) Test Script recorder defaults to using port `8888` (as configured when using Recording Template). See Bug 59006
> - Since version 3.0, the parser for embedded resources (replaced since 2.10 by Lagarto based implementation) which relied on the htmlparser library (HtmlParserHTMLParser) has been dropped along with its dependencies.
> - Since version 3.0, support for reading old Avalon format JTL (result) files has been removed, see Bug 59064
> - Since version 3.0, the default property value for `http.java.sampler.retries` has been changed to `0` (no retry by default) to align it with the behaviour of HttpClient4.

>   Note also that its meaning has changed: before 3.0, `http.java.sampler.retries=1` meant `No Retry` (i.e. total tries = 1), since 3.0 `http.java.sampler.retries=1` means `1` retry. (Note: this only applies to the Java HTTP Sampler)

>   See Bug 59103
> - Since 3.0, the following deprecated classes have been dropped
>   - org.apache.jmeter.protocol.http.modifier.UserParameterXMLContentHandler
>   - org.apache.jmeter.protocol.http.modifier.UserParameterXMLErrorHandler
>   - org.apache.jmeter.protocol.http.modifier.UserParameterXMLParser
> - `httpsampler.await_termination_timeout` has been replaced by `httpsampler.parallel_download_thread_keepalive_inseconds` which is now the keep alive time for the parallel download threads (in seconds).
> - JDBC Request has been updated to use commons-dbcp2, since then the behaviour is slightly different, ensure you have a correct "Validation Query" for your database. See Bug 58786
> - The following jars have been removed:
>   - excalibur-datasource-2.1.jar (see Bug 59156 )
>   - excalibur-instrument-1.0.jar (see Bug 58786 )
>   - excalibur-pool-api-2.1.jar (see Bug 58786 )
>   - excalibur-pool-impl-2.1.jar (see Bug 58786 )
>   - excalibur-pool-instrumented-2.1.jar (see Bug 58786 )
>   - htmllexer-2.1.jar (see Bug 59037 )
>   - htmlparser-2.1.jar (see Bug 59037 )
>   - soap-2.3.1.jar
>   - jdom-1.1.3.jar (see Bug 59156 )
> - Maximum number of redirects allowed by JMeter is now 20, it was previously 5. This can be changed with the property `httpsampler.max_redirects`. See Bug 59382

> ### Deprecated and removed elements

> - MongoDB elements (MongoDB Source Config, MongoDB Script) have been deprecated and will be removed in the next version of JMeter. They do not appear anymore in the menu, if you need them modify `not_in_menu` property. The JMeter team advises not to use them anymore. See Bug 58772
> - WebService(SOAP) Request and HTML Parameter Mask which were deprecated in 2.13 version, have now been removed following our deprecation strategy. Classes and properties which were only used by those elements have been dropped:
>   - `org.apache.jmeter.protocol.http.util.DOMPool`
>   - `org.apache.jmeter.protocol.http.util.WSDLException`
>   - `org.apache.jmeter.protocol.http.util.WSDLHelper`
>   - Property `soap.document_cache`
>   - JAR soap-2.3.1 has been also removed
> - `__jexl` function (i.e. JEXL 1) has been deprecated and will be removed in next version. See Bug 58903
> - Spline Visualizer listener and Distribution Graph listener have been deprecated and will be removed in the next version of JMeter. They do not appear anymore in the menu, if you need them modify `not_in_menu` property. JMeter team advises not to use them anymore. See Bug 58791

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 57696 - HTTP Request : Improve responseMessage when resource download fails. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57995 - Use FileServer for HTTP Request files. Implemented by Andrey Pokhilko (andrey at blazemeter.com) and contributed by BlazeMeter Ltd.
> - Bug 58843 - Improve the usable space in the HTTP sampler GUI. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58852 - Use less memory for `PUT` requests. The uploaded data will no longer be stored in the Sampler. This is the same behaviour as with `POST` requests.
> - Bug 58860 - HTTP Request : Add automatic variable generation in HTTP parameters table by right click. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58923 - normalize URIs when downloading embedded resources.
> - Bug 59005 - HTTP Sampler : Added WebDAV verb (`SEARCH`).
> - Bug 59006 - Change Default proxy recording port to `8888` to align it with Recording Template. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 58099 - Performance : Lazily initialize HttpClient SSL Context to avoid its initialization even for HTTP only scenarios
> - Bug 57577 - HttpSampler : Retrieve All Embedded Resources, add property "`httpsampler.embedded_resources_use_md5`" to only compute md5 and not keep response data. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59023 - HttpSampler UI : rework the embedded resources labels and change default number of parallel downloads to `6`. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59028 - Use `SystemDefaultDnsResolver` singleton. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59036 - FormCharSetFinder : Use JSoup instead of deprecated HTMLParser
> - Bug 59034 - Parallel downloads connection management is not realistic. Contributed by Benoit Wiart (benoit dot wiart at gmail.com) and Philippe Mouawad
> - Bug 59060 - HTTP Request GUI : Move File Upload to a new Tab to have more space for parameters and prevent incompatible configuration. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59103 - HTTP Request Java Implementation: Change default "`http.java.sampler.retries`" to align it on HttpClient behaviour and make the name meaningful
> - Bug 59083 - HTTP Request : Make Method field editable so that additional methods (WebDAV) can be added easily
> - Bug 59118 - Add comment in recorded think time by proxy recorder. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 59116 - Add the possibility to setup a prefix to sampler name recorded by proxy. Partly based on a patch by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 59129 - HTTP Request : Simplify GUI with simple/advanced Tabs
> - Bug 59033 - Parallel Download : Rework Parser classes hierarchy to allow plug-in parsers for different mime types
> - Bug 52073 - Embedded Resources Parallel download : Improve performances by avoiding shutdown of ThreadPoolExecutor at each sample. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59190 - HTTP(S) Test Script Recorder : Suggested excludes should ignore case. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 59140 - Parallel Download : Add CSS Parsing to extract links from CSS files
> - Bug 59249 - Http Request Defaults : Add "`Source address`" and "`Save responses as MD5`"
> - Bug 59382 - More realistic default value for `httpsampler.max_redirects`

> ### Other samplers

> - Bug 57928 - Add ability to define protocol (http/https) to AccessLogSampler GUI. Contributed by Jérémie Lesage (jeremie.lesage at jeci.fr)
> - Bug 58300 - Make existing Java Samplers implement Interruptible
> - Bug 58160 - JMS Publisher : reload file content if file name changes. Based partly on a patch contributed by Maxime Chassagneux (maxime.chassagneux at gmail.com)
> - Bug 58786 - JDBC Sampler : Replace Excalibur DataSource by more up to date library commons-dbcp2
> - Bug 59205 - TCP Sampler: Set connect time in sampler when connection is established.
> - Bug 59381 - JMSPublisher : FileChooserDialog filter does not work for browser buttons. Based partly on a patch contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)

> ### Controllers

> - Bug 58406 - IfController : Allow use of Nashorn Engine if available for JavaScript evaluation
> - Bug 58281 - RandomOrderController : Improve randomization algorithm performance. Contributed by Graham Russell (jmeter at ham1.co.uk)
> - Bug 58675 - Module controller : error message can easily be missed. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58673 - Module controller : when the target element is disabled the default jtree icons are displayed. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58674 - Module controller : it should not be possible to select more than one node in the tree. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58680 - Module Controller : ui enhancement. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58989 - Record controller gui : add a button to clear all the recorded samples. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)

> ### Listeners

> - Bug 58041 - Tree View Listener should show sample data type
> - Bug 58122 - GraphiteBackendListener : Add Server Hits metric. Partly based on a patch from Amol Moye (amol.moye at thomsonreuters.com)
> - Bug 58681 - GraphiteBackendListener : Don't send data if no sampling occurred
> - Bug 58776 - Summariser should display a more readable duration
> - Bug 58791 - Deprecate listeners: Distribution Graph (alpha) and Spline Visualizer
> - Bug 58849 - View Results Tree : Add a search panel to the request http view to be able to search in the parameters table. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58857 - View Results Tree : the request view http does not allow to resize the parameters table first column. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58955 - Request view http does not correctly display http parameters in multipart/form-data. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 55597 - View Results Tree: Add a search feature to search in recorded samplers
> - Bug 59102 - View Results Tree: Better default value for "`view.results.tree.max_size`"
> - Bug 59099 - Backend listener : Add the possibility to consider samplersList as a Regular Expression. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 59424 - Visualizer : Add "Clear" in popup menu

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 58303 - Change usage of bouncycastle api in SMIMEAssertion to get rid of deprecation warnings.
> - Bug 58515 - New JSON related components : JSON-PATH Extractor and JSON-PATH Renderer in View Results Tree. Donated by Ubik Load Pack (support at ubikloadpack.com).
> - Bug 58698 - Correct parsing of auth-files in HTTP Authorization Manager.
> - Bug 58756 - CookieManager : Cookie Policy select box content must depend on Cookie implementation.
> - Bug 56358 - Cookie manager supports cross port cookies and RFC6265. Thanks to Oleg Kalnichevski (olegk at apache.org)
> - Bug 58773 - TestCacheManager : Add tests for CacheManager that use HttpClient 4
> - Bug 58742 - CompareAssertion : Reset data in TableEditor when switching between different CompareAssertions in gui. Based on a patch by Vincent Herilier (vherilier at gmail.com)
> - Bug 59108 - TableEditor: Allow rows to be moved up and down. Contributed by Vincent Herilier (vherilier at gmail.com)
> - Bug 58848 - Argument Panel : when adding an argument (add button or from clipboard) scroll the table to the new line. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58865 - Allow empty default value in the Regular Expression Extractor. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59156 - XMLAssertion : drop jdom dependency by using XMLReader
> - Bug 59328 - Better tooltip for Variable Names in CSVDataSet. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)

> ### Functions

> - Bug 58477 - __javaScript function : Allow use of Nashorn engine for Java8 and later versions
> - Bug 58903 - Provide __jexl3 function that uses commons-jexl3 and deprecated __jexl (1.1) function

> ### I18N

> ### General

> - Bug 58736 - Add Sample Timeout support
> - Bug 57913 - Automated backups of last saved JMX files. Contributed by Benoit Vatan (benoit.vatan at gmail.com)
> - Bug 57988 - Shortcuts (Ctrl + 1 … Ctrl + 9) to quickly add elements into test plan. Implemented by Andrey Pokhilko (andrey at blazemeter.com) and contributed by BlazeMeter Ltd.
> - Bug 58100 - Performance enhancements : Replace Random by ThreadLocalRandom.
> - Bug 58677 - `TestSaveService#testLoadAndSave` use the wrong set of files. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58689 - Add shortcuts to expand / collapse a part of the tree. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58696 - Create Ant task to setup Eclipse project
> - Bug 58653 - New JMeter Dashboard/Report with Dynamic Graphs, Tables to help analyzing load test results. Developed by Ubik-Ingenierie and contributed by Decathlon S.A. and Ubik-Ingenierie / UbikLoadPack
> - Bug 58699 - Workbench changes neither saved nor prompted for saving upon close. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58728 - Drop old behavioural properties
> - Bug 57319 - Upgrade to HttpClient 4.5.2. With the big help from Oleg Kalnichevski (olegk at apache.org) and Gary Gregory (ggregory at apache.org).
> - Bug 58772 - Deprecate MongoDB related elements
> - Bug 58782 - ThreadGroup : Improve ergonomy
> - Bug 58165 - Show the time elapsed since the start of the load test in GUI mode. Partly based on a contribution from Maxime Chassagneux (maxime.chassagneux at gmail.com)
> - Bug 58814 - JVM no longer recognizes option `MaxLiveObjectEvacuationRatio`; remove from comments
> - Bug 58810 - Config Element Counter (and others): Check Boxes Toggle Area Too Big
> - Bug 56554 - JSR223 Test Element : Generate compilation cache key automatically. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58911 - Header Manager : it should be possible to copy/paste between Header Managers. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58864 - Arguments Panel : when moving parameter with up / down, ensure that the selection remains visible. Based on a contribution by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58968 - Add a new template to allow to record script with think time included. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 58978 - Settings defaults : Switch "`jmeter.save.saveservice.assertion_results_failure_message`" to true (after 2.13)
> - Bug 58991 - Settings defaults : Switch "`jmeter.save.saveservice.print_field_names`" to true (after 2.13)
> - Bug 57182 - Settings defaults : Switch "`jmeter.save.saveservice.idle_time`" to true (after 2.13)
> - Bug 58870 - TableEditor: minimum size is too small. Contributed by Vincent Herilier (vherilier at gmail.com)
> - Bug 58933 - JSyntaxTextArea : Ability to set font. Contributed by Denis Kirpichenkov (denis.kirpichenkov at gmail.com)
> - Bug 58793 - Create developers page explaining how to build and contribute
> - Bug 59046 - JMeter Gui Replace controller should keep the name and the selection. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59038 - Deprecate HTTPClient 3.1 related elements
> - Bug 59094 - Drop support of old JMX file format
> - Bug 59082 - Remove the "`TestCompiler.useStaticSet`" parameter. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59093 - Option parsing error message can be 'lost'
> - Bug 58715 - Feature request: Bundle `groovy-all` with JMeter
> - Bug 58426 - Improve display of JMeter on high resolution devices (HiDPI) (part 1 of enhancement)
> - Bug 59105 - TableEditor : Add ability to paste rows from clipboard and delete multiple selection. Contributed by Vincent Herilier (vherilier at gmail.com)
> - Bug 59197 - Thread Group : it should be possible to only run a single threadgroup or a selection of threadgroups with a popup menu. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59207 - Change the font color of `errorsOrFatalsLabel` to red when an error occurs. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 58941 - Create a new Starter that runs thread groups in validation mode (`1` thread only, `1` iteration, no pause all customizable)
> - Bug 59236 - JMeter Properties : Make some cleanup
> - Bug 59240 - Introduce a slf4j adapter for Logkit (this allows using slf4j within plugins and core code)
> - Bug 59153 - Stop test if CSVDataSet is accessing non-existing file. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 59320 - Better tooltip in GUI with GenericTestBeanCustomizer (CSV Data Set Config, JDBC Connection Configuration, Keystore Configuration, …) . Based on a patch by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 59171 - Sample Result SaveConfig Dialog is generated in random order
> - Bug 59425 - Display error about missing help page inside the help pane

> Non-functional changes

> - Updated to httpclient, httpmime 4.5.2 (from 4.2.6)
> - Updated to tika-core and tika-parsers 1.12 (from 1.7)
> - Updated to commons-math3 3.6.1 (from 3.4.1)
> - Updated to commons-pool2 2.4.2 (from 2.3)
> - Updated to commons-lang 3.4 (from 3.3.2)
> - Updated to rhino-1.7.7.1 (from 1.7R5)
> - Updated to jodd-3.6.7.jar (from 3.6.4)
> - Updated to jsoup-1.8.3 (from 1.8.1)
> - Updated to rsyntaxtextarea-2.5.8 (from 2.5.6)
> - Updated to slf4j-1.7.12 (from 1.7.10)
> - Updated to xmlgraphics-commons-2.0.1 (from 1.5)
> - Updated to commons-collections-3.2.2 (from 3.2.1)
> - Updated to commons-net 3.4 (from 3.3)
> - Updated to slf4j 1.7.13 (from 1.7.12)
> - Bug 57981 - Require a minimum of Java 7. Partly contributed by Graham Russell (jmeter at ham1.co.uk)
> - Bug 58684 - JMeterColor does not need to extend `java.awt.Color`. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58687 - ButtonPanel should die. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58705 - Make `org.apache.jmeter.testelement.property.MultiProperty` iterable. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58729 - Cleanup extras folder for maintainability
> - Bug 57110 - Fixed spelling+grammar, formatting, removed commented out code etc. Contributed by Graham Russell (jmeter at ham1.co.uk)
> - Correct instructions on running JMeter in `help.txt`. Contributed by Pascal Schumacher (pascalschumacher at gmx.net)
> - Bug 58704 - Non regression testing : Ant task batchtest fails if tests and run in a non `en_EN` locale and use a JMX file that uses a CSV DataSet
> - Bug 58897 - Improve JUnit Test code. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58949 - Cleanup of LDAP code. Based on a patch by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58897 - Improve JUnit Test code. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58967 - Use JUnit categories to exclude tests that need a gui. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59003 - `ClutilTestCase` `testSingleArg8` and `testSingleArg9` are identical
> - Bug 59064 - Remove OldSaveService which supported very old Avalon format JTL (result) files
> - Bug 59165 - RSyntaxTextArea not compatible with headless testing
> - Bug 59021 - Use `Double#compare` instead of reimplementing it in `NumberProperty#compareTo`
> - Bug 59037 - Drop HtmlParserHTMLParser and dependencies on htmlparser and htmllexer
> - Bug 58465 - JMS Read response field is badly named and documented
> - Bug 58601 - Change check for modification of `saveservice.properties` from `SVN Revision ID` to sha1 sum of the file itself.
> - Bug 58726 - Remove the `jmeterthread.startearlier` parameter. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58784 - Make `JMeterUtils#runSafe` sync/async awt invocation configurable and change the visualizers to use the async version.
> - Bug 58790 - Issue in CheckDirty and its relation to ActionRouter
> - Bug 59095 - Remove UserParameterXMLParser that was deprecated eight years ago. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59262 - Add list of binary jars to LICENSE; use that for unit tests
> - Bug 59353 - Add "Deprecated and removed elements" in "Incompatible changes" part in changes.xml. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 57806 - "`audio/x-mpegurl`" mime type is erroneously considered as binary by ViewResultsTree. Contributed by Ubik Load Pack (support at ubikloadpack.com).
> - Bug 57858 - Don't call `sampleEnd` twice in HTTPHC4Impl when a `RuntimeException` or an `IOException` occurs in the sample method.
> - Bug 57921 - HTTP/1.1 without keep-alive "`Connection`" response header no longer uses infinite keep-alive.
> - Bug 57956 - The `hc.parameters` reference in `jmeter.properties` doesn't work when JMeter is not started in `bin`.
> - Bug 58137 - JMeter fails to download embedded URLs that contain illegal characters in URL (it does not escape them).
> - Bug 58201 - Make usage of port in the host header more consistent across the different http samplers.
> - Bug 58453 - HTTP Test Script Recorder : `NullPointerException` when disabling Capture HTTP Headers
> - Bug 57804 - HTTP Request doesn't reuse cached SSL context when using Client Certificates in HTTPS (only fixed for HttpClient4 implementation)
> - Bug 58800 - `proxy.pause` default value: fix documentation
> - Bug 58844 - Buttons enable / disable is broken in the arguments panel. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58861 - When clicking on up, down or detail while in a cell of the argument panel, newly added content is lost. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 57935 - SSL SNI extension not supported by HttpClient 4.2.6
> - Bug 59044 - Http Sampler : It should not be possible to select the multipart encoding if the method is not `POST`. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59008 - Http Sampler: Infinite recursion SampleResult on frame depth limit reached
> - Bug 58881 - HTTP Request : HTTPHC4Impl shows exception when server uses "`deflate`" compression
> - Bug 58583 - HTTP client fails to close connection if server misbehaves by not sending "`connection: close`", violating HTTP RFC 2616 / RFC 7230
> - Bug 58950 - `NoHttpResponseException` when Pause between samplers exceeds keepalive sent by server
> - Bug 59085 - Http file panel : data lost on browse cancellation. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 56141 - Application does not behave correctly when using HTTP Recorder. With the help of Dan (java.junkee at yahoo.com)
> - Bug 59079 - "`httpsampler.max_redirects`" property is not enforced when "`Redirect Automatically`" is used
> - Bug 58811 - When pasting arguments between http samplers the column "Encode" and "Include Equals" are lost. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)

> ### Other Samplers

> - Bug 58013 - Enable all protocols that are enabled on the default SSLContext for usage with the SMTP Sampler.
> - Bug 58209 - JMeter hang when testing javasampler because `HashMap.put()` is called from multiple threads without sync.
> - Bug 58301 - Use typed methods such as `setInt`, `setDouble`, `setDate`, … for prepared statement #27
> - Bug 58851 - Add a dependency on hamcrest-core to allow JUnit tests with annotations to work
> - Bug 58947 - Connect metric is wrong when `ConnectException` occurs
> - Bug 58980 - JMS Subscriber will return successful as long as 1 message is received. Contributed by Harrison Termotto (harrison dot termotto at stonybrook.edu)
> - Bug 59075 - JMS Publisher: `NumberFormatException` is thrown if priority or expiration field is empty
> - Bug 59345 - SMTPSampler connection leak. Based on a patch by Luca Maragnani (luca dot maragnani at gmail dot com)

> ### Controllers

> - Bug 58600 - Display correct filenames, when they are searched by IncludeController
> - Bug 58678 - Module Controller : limit target element selection. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58714 - Module controller : it should not be possible to add a timer as child. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59067 - JMeter fails to iterate over Controllers that are children of a TransactionController having "`Generate parent sample`" checked after an assertion error occurs on a Thread Group with "`Start Next Thread Loop`". Contributed by Benoit Wiart(benoit dot wiart at gmail.com)
> - Bug 59076 - Test should fail if a module controller cannot find its replacement subtree

> ### Listeners

> - Bug 58033 - SampleResultConverter should note that it cannot record non-TEXT data
> - Bug 58845 - Request http view doesn't display all the parameters. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58413 - ViewResultsTree : Request HTTP Renderer does not show correctly parameters that contain ampersand (&). Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59172 - SampleResult SaveConfig does not allow some fields to be disabled
> - Bug 58329 - Response Time Graph and Aggregate Graph : Save graph to file does not take into account the settings changed since last click on Graph. Contributed by David Coppens (d.l.coppens at gmail.com)

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 58079 - Do not cache HTTP samples that have a `Vary` header when using a HTTP CacheManager.
> - Bug 58912 - Response assertion gui : Deleting more than 1 selected row deletes only one row. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)

> ### Functions

> - Bug 57825 - __Random function fails if `min` value is equal to `max` value (regression related to Bug 54453 )

> ### I18N

> ### General

> - Bug 54826 - Don't fail on long strings in JSON responses when displaying them as JSON in View Results Tree.
> - Bug 57734 - Maven transient dependencies are incorrect for 2.13 (Fixed group ids for Commons Pool and Math)
> - Bug 57731 - `TESTSTART.MS` has always the value of the first Test started in Server mode in NON GUI Distributed testing
> - Bug 58016 - Error type casting using external SSL Provider. Contributed by Kirill Yankov (myworkpostbox at gmail.com)
> - Bug 58293 - SOAP/XML-RPC Sampler file browser generates NullPointerException
> - Bug 58685 - JDatefield : Make the modification of the date with up/down arrow work. Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 58693 - Fix "Cannot nest output folder 'jmeter/build/components' inside output folder 'jmeter/build'" when setting up eclipse
> - Bug 58781 - Command line option "`-?`" shows Unknown option
> - Bug 57821 - Command-line option "`-X --remoteexit`" doesn't work since 2.13 (regression related to Bug 57500 )
> - Bug 58795 - NPE may occur in `GuiPackage#getTestElementCheckSum` with some 3rd party plugins
> - Bug 58913 - When closing JMeter should not interpret cancel as "destroy my test plan". Contributed by Benoit Wiart (benoit dot wiart at gmail.com)
> - Bug 59096 - Search Feature : Case insensitive search is not really case insensitive
> - Bug 59193 - `ant run_gui` fails with `ClassNotFoundException` or `IllegalAccessError` when accessing classes from dependencies not loaded through `Thread.currentThread().getContextClassLoader()`
> - Bug 59225 - Bad display of running indicator icon. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Bug 56927 - Disable language change during a test
> - Bug 59391 - In Distributed mode, the client exits abnormally at the end of test
> - Bug 59397 - `build.xml` does not make dist.executables executable on Unix systems

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Ubik Load Pack
> - Benoit Vatan (benoit.vatan at gmail.com)
> - Jérémie Lesage (jeremie.lesage at jeci.fr)
> - Kirill Yankov (myworkpostbox at gmail.com)
> - Amol Moye (amol.moye at thomsonreuters.com)
> - Samoht-fr (https://github.com/Samoht-fr)
> - Graham Russell (jmeter at ham1.co.uk)
> - Maxime Chassagneux (maxime.chassagneux at gmail.com)
> - Benoit Wiart (benoit.wiart at gmail.com)
> - Decathlon S.A.
> - Ubik-Ingenierie S.A.S.
> - Oleg Kalnichevski (olegk at apache.org)
> - Pascal Schumacher (pascalschumacher at gmx.net)
> - Vincent Herilier (vherilier at gmail.com)
> - Florent Sabbe (f dot sabbe at ubik-ingenierie.com)
> - Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - Harrison Termotto (harrison dot termotto at stonybrook.edu
> - Denis Kirpichenkov (denis.kirpichenkov at gmail.com)
> - Gary Gregory (ggregory at apache.org)
> - David Coppens (d.l.coppens at gmail.com)
> - Luca Maragnani (luca dot maragnani at gmail dot com)
> - Philip Helger (http://www.helger.com) for his CSS Parser and for taking into account our bug reports very rapidly
> - Irek Pastusiak (the.automatic.tester at gmail.com)

> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:

> - purnasatyap at gmail dot com for the tests and reports on nightly build
> - Sergey Batalin (sergey_batalin at mail dot ru) for the tests and reports on nightly build
> - Vincent Daburon (vdaburon at gmail dot com) for the tests and reports on nightly build

> Apologies if we have omitted anyone else.

> Known problems and workarounds

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show `0` (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629. A workaround is to use a Java 7 update 40 runtime which fixes this issue.
> - You may encounter the following error:

>       java.security.cert.CertificateException: Certificates does not conform to algorithm constraints

>   if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like md2WithRSAEncryption) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 7 version u16 (MD2) and version u40 (Certificate size lower than 1024 bits), and Java 8 too.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java `jdk.certpath.disabledAlgorithms` property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.
> - Under Mac OSX Aggregate Graph will show wrong values due to mirroring effect on numbers. This is due to a known Java bug, see Bug JDK-8065373 The fix is to use JDK7_u79, JDK8_u45 or later.
> - View Results Tree may fail to display some HTML code under HTML renderer, see Bug 54586 . This is due to a known Java bug which fails to parse "`px`" units in row/col attributes. See Bug JDK-8031109 The fix is to use JDK9 b65 or later.
> - JTable selection with keyboard (SHIFT + up/down) is totally unusable with JAVA 7 on Mac OSX. This is due to a known Java bug JDK-8025126 The fix is to use JDK 8 b132 or later.

> # Version 2.13

> Summary

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> New Elements

> New Async BackendListener with Graphite implementation

> A new Async BackendListener has been added to allow sending result data to a backend listener. JMeter ships with a GraphiteBackendListenerClient that allows sending results to a Graphite server using Pickle or Plaintext protocols. You can implement your own backend by extending AbstractBackendListenerClient. This backend could be a database (JDBC), a Message Oriented Middleware (JMS), a Webservice or anything you want.

> This is the kind of Live Dashboard you can obtain using Grafana and InfluxDB
> Read this for more details.

> Grafana dashboard

> Core Improvements

> New connect time metric

> Starting with this version a new metric called connectTime has been added. It represents the time to establish connection. By default it is not saved to CSV or XML, to have it saved add to user.properties:
> `jmeter.save.saveservice.connect_time=true`

> Aggregate Graph and Report

> The listeners Aggregate Graph and Aggregate Report previously showed only the 90 percentile (historical behavior), the 95 percentile and the 99 percentile have been added and are customizable. To setup the percentiles value you want, add to user.properties:
> `aggregate_rpt_pct1=90
> aggregate_rpt_pct2=95
> aggregate_rpt_pct3=99`

> HTTP(S) Test Script Recorder

> Now component is able to detect authentication schemes and automatically adds a pre-configured HTTP Authorization Manager with the correct Mechanism.

> HTTP Request

> The CalDAV verbs (Calendar extensions to WebDAV) REPORT and MKCALENDAR have been added in the HTTP Request sampler.

> JDBC Request

> The ResultSet can be get as a object, this allows to handle more easily the results after in BeanShell, JSR223 scripts, …

> Distributed Testing

> To allow better usage of Distributed Testing in the cloud, retry behaviour has been added when starting test on servers. Read this for more details.

> Distributed Testing performance

> Since JMeter 2.13, Stripping modes (StrippingBatch being the default mode) now also strip responses from SubResults improving consumed network bandwidth.

> Documentation refresh

> A new style for website (responsive and more up to date) has been created by Felix Schumacher. Documentations have been refreshed particularly:

> - Building a Webservice Test Plan
> - Best Practices
> - Help! My boss wants me to load test our application!

> GUI Improvements

> Module Controller

> The Module Controller now shows the target controller in a tree view (instead of combo list).

> Toolbar

> JMeter's toolbar has been refreshed for some icons (start, toggle, etc.). Three sizes are now available for the icons: 22x22, 32x32 and 48x48.

> The toolbar with 22x22 pixels icons

> The toolbar with 32x32 pixels icons

> The toolbar with 48x48 pixels icons

> HTTP(S) Test Script Recorder

> If your Test Plan does not contains a Recording Controller, a new warning message will appear if the HTTP(S) Test Script Recorder is configured to send the samples into a Recording Controller.

> Incompatible changes

> - Since 2.13, Aggregate Graph, Summary Report and Aggregate Report now export percentages to %, before they exported the decimal value which differed from what was shown in GUI
> - Third party plugins may be impacted by fix of Bug 57586 , ensure that your subclass of HttpTestSampleGui implements ItemListener if you relied on parent class doing so.
> - Report package has been removed, `ApacheJMeter_report.jar` is not generated anymore as a consequence, see Bug 57269

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 25430 - HTTP(S) Test Script Recorder : Make it populate HTTP Authorization Manager. Partly based on a patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Bug 57381 - HTTP(S) Test Script Recorder should display an error if Target Controller references a Recording Controller and no Recording Controller exists. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57488 - Performance : Improve SSLContext reset for Two-way SSL Authentication
> - Bug 57565 - SamplerCreator : Add method to allow implementations to add children to created sampler
> - Bug 57606 - HTTPSamplerBase#errorResult changes the sample label on exception
> - Bug 57613 - HTTP Sampler : Added CalDAV verbs (REPORT, MKCALENDAR). Contributed by Richard Brigham (richard.brigham at teamaol.com)
> - Bug 48799 - Add time to establish connection to available sample metrics. Implemented by Andrey Pokhilko (andrey at blazemeter.com) and contributed by BlazeMeter Ltd. and Pieter Ennes (apache.org at spam.ennes.nl)
> - Bug 57500 - Introduce retry behavior for distributed testing. Implemented by Andrey Pokhilko and Dzimitry Kashlach and contributed by BlazeMeter Ltd.

> ### Other samplers

> - Bug 57322 - JDBC Test elements: add ResultHandler to deal with ResultSets(cursors) returned by callable statements. Contributed by Yngvi Þór Sigurjónsson (blitzkopf at gmail.com)

> ### Controllers

> - Bug 57561 - Module controller UI : Replace combobox by tree. Contributed by Maciej Franek (maciej.franek at gmail.com)
> - Bug 57648 - TestFragment should be disabled when created. Contributed by Ubik Load Pack (support at ubikloadpack.com)

> ### Listeners

> - Bug 55932 - Create a Async BackendListener to allow easy plug of new listener (Graphite, JDBC, Console, …)
> - Bug 57246 - BackendListener : Create a Graphite implementation
> - Bug 57217 - Aggregate graph and Aggregate report improvements (3 configurable percentiles, same data in both, factor out code). Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57537 - BackendListener : Allow implementations to drop samples

> ### Timers, Assertions, Config, Pre- & Post-Processors

> ### Functions

> - Bug 54453 - Performance enhancements : Replace Random by ThreadLocalRandom in __Random function

> ### I18N

> ### General

> - Bug 57518 - Icons for toolbar with several sizes
> - Bug 57605 - When there is an error loading Test Plan, `SaveService.loadTree` returns `null` leading to NPE in callers
> - Bug 57269 - Drop `org.apache.jmeter.reports` package
> - Bug 53764 - Website : Create a new style for website

> Non-functional changes

> - Updated to jsoup-1.8.1.jar (from 1.7.3)
> - Updated to tika-core and tika-parsers 1.7 (from 1.6)
> - Updated to commons-codec-1.10.jar (from 1.9)
> - Updated to dnsjava-2.1.7.jar (from 2.1.6)
> - Updated to jodd-3.6.4.jar (from 3.6.1)
> - Updated to junit-4.12.jar (from 4.11)
> - Updated to rhino-1.7R5 (from 1.7R4)
> - Updated to rsyntaxtextarea-2.5.6 (from 2.5.3)
> - Updated to slf4j-1.7.10 (from 1.7.5)
> - Bug 57276 - RMIC no longer needed since Java 5
> - Bug 57310 - Replace `System.getProperty("file.separator")` with `File.separator` throughout (Also "`path.separator"` with `File.pathSeparator`)
> - Bug 57389 - Fix potential NPE in converters
> - Bug 57417 - Remove unused method `isTemporary` from `NullProperty`. This was a leftover from a refactoring done in 2003.
> - Bug 57418 - Remove unused constructor from Workbench
> - Bug 57419 - Remove unused interface ModelListener.
> - Bug 57466 - IncludeController : Remove an unneeded set creation. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Added property `loggerpanel.usejsyntaxtext` to disable the use of JSyntaxTextArea for the Console Logger (in case of memory or other issues)
> - Bug 57586 - HttpTestSampleGui: Remove interface ItemListener implementation

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 57385 - Getting empty thread name in xml result for HTTP requests with "Follow Redirects" set. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57579 - NullPointerException error is raised on main sample if "RETURN_NO_SAMPLE" is used (default) and "Use Cache-Control / Expires header…" is checked in HTTP Cache Manager

> ### Other Samplers

> ### Controllers

> - Bug 57447 - Use only the user listed DNS Servers, when "use custom DNS resolver" option is enabled.

> ### Listeners

> - Bug 57262 - Aggregate Report, Aggregate Graph and Summary Report export : headers use keys instead of labels
> - Bug 57346 - Summariser : The + (difference) reports show wrong elapsed time and throughput
> - Bug 57449 - Distributed Testing: Stripped modes do not strip responses from SubResults (affects load tests that use Download of embedded resources). Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57562 - View Results Tree CSS/JQuery Tester : Nothing happens when there is an error in syntax and an exception occurs in jmeter.log
> - Bug 57514 - Aggregate Graph, Summary Report and Aggregate Report show wrong percentage reporting in saved file

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 57607 - Constant Throughput Timer : Wrong throughput computed in shared modes due to rounding error

> ### General

> - Bug 57365 - Selected LAF is not correctly setup due to call of `UIManager.setLookAndFeel` too late. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57364 - Options < Look And Feel does not update all windows LAF. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57394 - When constructing an instance with ClassTools#construct(String, int) the integer was ignored and the default constructor was used instead.
> - Bug 57440 - OutOfMemoryError after introduction of JSyntaxTextArea in LoggerPanel due to disableUndo not being taken into account.
> - Bug 57569 - FileServer.reserveFile - inconsistent behaviour when hasHeader is true
> - Bug 57555 - Cannot use JMeter 2.12 as a maven dependency. Contributed by Pascal Schumacher (pascal.schumacher at t-systems.com)
> - Bug 57608 - Fix start script compatibility with old Unix shells, e.g. on Solaris

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Ubik Load Pack
> - Yngvi Þór Sigurjónsson (blitzkopf at gmail.com)
> - Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - BlazeMeter Ltd.
> - Benoit Wiart (benoit.wiart at gmail.com)
> - Pascal Schumacher (pascal.schumacher at t-systems.com)
> - Maciej Franek (maciej.franek at gmail.com)
> - Richard Brigham (richard.brigham at teamaol.com)
> - Pieter Ennes (apache.org at spam.ennes.nl)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - Chaitanya Bhatt (bhatt.chaitanya at gmail.com) for his thorough testing of new BackendListener and Graphite Client implementation.
> - Marcelo Jara (marcelojara at hotmail.com) for his clear report on Bug 57607 .
> Apologies if we have omitted anyone else.

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show 0 (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629. A workaround is to use a Java 7 update 40 runtime which fixes this issue.
> - You may encounter the following error: java.security.cert.CertificateException: Certificates does not conform to algorithm constraints if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like md2WithRSAEncryption) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 7 version u16 (MD2) and version u40 (Certificate size lower than 1024 bits), and Java 8 too.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java jdk.certpath.disabledAlgorithms property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.

> # Version 2.12

> Summary

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> Java 8 support

> Now, JMeter 2.12 is compliant with Java 8.

> New Elements

> Critical Section Controller

> The Critical Section Controller allow to serialize the execution of a section in your tree. Only one instance of the section will be executed at the same time during the test.

> DNS Cache Manager

> The new configuration element DNS Cache Manager(see Bug 56841 ) improves the testing of:

> - CDN (Content Delivery Network)
> - DNS load balancing.
> - Load Balancers like Amazon Elastic Load Balancer

> Core Improvements

> Smarter Recording of Http Test Plans

> Test Script Recorder has been improved in many ways

> - Better matching of Variables in Requests, making Test Script Recorder variabilize your sampler during recording more versatile
> - Ability to filter from View Results Tree the Samples that are excluded from recording, this lets you concentrate on recorded Samplers analysis and not bother with useless Sample Results

> - Better defaults for recording, since this version Recorder will number created Samplers letting you find them much easily in View Results Tree. Grouping of Samplers under Transaction Controller will be smarter making all requests emitted by a web page be children as new Transaction Controller

> Support of Webdav requests

> You can now test against WebDav server using HttpClient4 Implementation of Http Request

> Better handling of embedded resources

> When download embedded resources is checked, JMeter now uses User Agent header to download or not resources embedded within conditional comments as per About conditional comments.

> Ability to customize Cache Manager (Browser cache simulation) handling of cached resources

> You can now configure the behaviour of JMeter when a resource is found in Cache, this can be controlled with cache_manager.cached_resource_mode property

> JMS Publisher / JMS Point-to-Point

> Add JMSPriority and JMSExpiration fields for these samplers.

> Mail Reader Sampler

> You can now specify the number of messages that want you retrieve (before all messages were retrieved). In addition, you can fetch only the message header now.

> SMTP Sampler

> Adding the Connection timeout and the Read timeout to the SMTP Sampler.

> Synchronizing Timer

> Adding a timeout to define the maximum time to waiting of the group of virtual users.

> Performance improvements

> A big improvement in performances of Functions has been made by lifting useless synchronization. It concerns all functions except __StringFromFile, __XPath and __BeanShell, see Bug 57114

> __jexl2 performances have been improved to avoid contention point, see Bug 56708

> GUI Improvements

> Undo/Redo support

> Undo / Redo has been introduced and allows user to undo/redo changes made on Test Plan Tree. This feature (ALPHA MODE) is disabled by default, to enable it set property undo.history.size=25

> View Results Tree

> Improve the ergonomics of View Results Tree by changing placement of Renderers and allowing custom ordering (with the property view.results.tree.renderers_order).

> Response Time Graph

> Adding the ability for the Response Time Graph listener to save/restore format its settings in/from the jmx file.

> Log Viewer

> Starting with this version, the last lines of JMeter's log file (jmeter.log) can be viewed directly in GUI by clicking on Warning icon in the upper right corner. This will unfold the Log Viewer panel and show logs.

> File Opening

> Now, "Open File dialog" uses last opened file folder as start folder, see Bug 52707

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show 0 (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - Note that under some windows systems you may have this WARNING:

>       java.util.prefs.WindowsPreferences
>       WARNING: Could not open/create prefs root node Software\JavaSoft\Prefs at root 0
>       x80000002. Windows RegCreateKeyEx(…) returned error code 5.

>   The fix is to run JMeter as Administrator, it will create the registry key for you, then you can restart JMeter as a normal user and you won't have the warning anymore.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629. A workaround is to use a Java 7 update 40 runtime which fixes this issue.
> - You may encounter the following error: java.security.cert.CertificateException: Certificates does not conform to algorithm constraints if you run a HTTPS request on a web site with a SSL certificate (itself or one of SSL certificates in its chain of trust) with a signature algorithm using MD2 (like md2WithRSAEncryption) or with a SSL certificate with a size lower than 1024 bits. This error is related to increased security in Java 7 version u16 (MD2) and version u40 (Certificate size lower than 1024 bits), and Java 8 too.
>   To allow you to perform your HTTPS request, you can downgrade the security of your Java installation by editing the Java jdk.certpath.disabledAlgorithms property. Remove the MD2 value or the constraint on size, depending on your case.
>   This property is in this file:

>       JAVA_HOME/jre/lib/security/java.security

>   See Bug 56357 for details.

> Incompatible changes

> - Since JMeter 2.12, active threads in all thread groups and active threads in current thread group are saved by default to CSV or XML results, see Bug 57025 . This is usually the expected behaviour as you want to have the number of running threads during the test. But if you want to revert to previous behaviour, set property jmeter.save.saveservice.thread_counts=false
> - Since JMeter 2.12, Mail Reader Sampler will show 1 for number of samples instead of number of messages retrieved, see Bug 56539
> - Since JMeter 2.12, when using Cache Manager, if resource is found in cache no SampleResult will be created, in previous version a SampleResult with empty content and 204 return code was returned, see Bug 54778 . You can choose between different ways to handle this case, see `cache_manager.cached_resource_mode` in `jmeter.properties`.
> - Since JMeter 2.12, Log Viewer will no more clear logs when closed and will have logs available even if closed. See Bug 56920 . Read Hints and Tips > Enabling Debug logging for details on configuring this component.

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 55998 - HTTP recording – Replacing port value by user defined variable does not work
> - Bug 56178 - keytool error: Invalid escaped character in AVA: - some characters must be escaped
> - Bug 56222 - NPE if jmeter.httpclient.strict_rfc2616=true and location is not absolute
> - Bug 56263 - DefaultSamplerCreator should set BrowserCompatible Multipart true
> - Bug 56231 - Move redirect location processing from HC3/HC4 samplers to HTTPSamplerBase#followRedirects()
> - Bug 56207 - URLs get encoded on redirects in HC3.1 & HC4 samplers
> - Bug 56303 - The width of target controller's combo list should be set to the current panel size, not on label size of the controllers
> - Bug 54778 - HTTP Sampler should not return 204 when resource is found in Cache, make it configurable with new property cache_manager.cached_resource_mode

> ### Other Samplers

> - Bug 55977 - JDBC pool keepalive flooding
> - Bug 55999 - Scroll bar on jms point-to-point sampler does not work when content exceeds display
> - Bug 56198 - JMSSampler : NullPointerException is thrown when JNDI underlying implementation of JMS provider does not comply with `Context.getEnvironment` contract
> - Bug 56428 - MailReaderSampler - should it use mail.pop3s.* properties?
> - Bug 46932 - Alias given in select statement is not used as column header in response data for a JDBC request. Based on report and analysis of Nicola Ambrosetti
> - Bug 56539 - Mail reader sampler: When Number of messages to retrieve is superior to 1, Number of samples should only show 1 not the number of messages retrieved
> - Bug 56809 - JMSSampler closes InitialContext too early. Contributed by Bradford Hovinen (hovinen at gmail.com)
> - Bug 56761 - JMeter tries to stop already stopped JMS connection and displays "The connection is closed"
> - Bug 57068 - No error thrown when negative duration is entered in Test Action
> - Bug 57078 - LagartoBasedHTMLParser fails to parse page that contains input with no type
> - Bug 57183 - JMSSampler: For input string: "" java.lang.NumberFormatException (for Expiration or Priority fields)

> ### Controllers

> - Bug 56243 - Foreach works incorrectly with indexes on subsequent iterations
> - Bug 56276 - Loop controller becomes broken once loop count evaluates to zero
> - Bug 56160 - StackOverflowError when using WhileController within IfController
> - Bug 56811 - "Start Next Thread Loop" in Result Status Action Handler or on Thread Group and "Go to next Loop iteration" in Test Action behave incorrectly with TransactionController that has "Generate Parent Sampler" checked

> ### Listeners

> - Bug 56706 - SampleResult#getResponseDataAsString() does not use encoding in response body impacting PostProcessors and ViewResultsTree. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57052 - ArithmeticException: / by zero when sampleCount is equal to 0

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 56162 - HTTP Cache Manager should not cache PUT/POST etc.
> - Bug 56227 - AssertionGUI : NPE in assertion on mouse selection
> - Bug 41319 - URLRewritingModifier : Allow Parameter value to be url encoded

> ### Functions

> ### I18N

> - Bug 56111 - "comments" in german translation is not correct

> ### General

> - Bug 56059 - Older TestBeans incompatible with 2.11 when using TextAreaEditor
> - Bug 56080 - Conversion error com.thoughtworks.xstream.converters.ConversionException with Java 8 Early Access Build
> - Bug 56182 - Can't trigger bsh script using bshclient.jar; socket is closed unexpectedly
> - Bug 56360 - HashTree and ListedHashTree fail to compile with Java 8
> - Bug 56419 - JMeter silently fails to save results
> - Bug 56662 - Save as xml in a listener is not remembered
> - Bug 56367 - JMeter 2.11 on maven central triggers a not existing dependency rsyntaxtextarea 2.5.1, upgrade to 2.5.3
> - Bug 56743 - Wrong mailing list archives on mail2.xml. Contributed by Felix Schumacher (felix.schumacher at internetallee.de)
> - Bug 56763 - Removing the Oracle icons, not used by JMeter (and missing license)
> - Bug 54100 - Switching languages fails to preserve toolbar button states (enabled/disabled)
> - Bug 54648 - JMeter GUI on OS X crashes when using CMD+C (keyboard shortcut or UI menu entry) on an element from the tree
> - Bug 56962 - JMS GUIs should disable all fields affected by jndi.properties checkbox
> - Bug 57061 - Save as Test Fragment fails to clone deeply selected node. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57075 - BeanInfoSupport.MULTILINE attribute is not processed
> - Bug 57076 - BooleanPropertyEditor#getAsText() must return a value that is in getTags()
> - Bug 57088 - NPE in ResultCollector.testEnded

> Improvements

> ### HTTP Samplers and Test Script Recorder

> - Bug 55959 - Improve error message when Test Script Recorder fails due to I/O problem
> - Bug 52013 - Test Script Recorder's Child View Results Tree does not take into account Test Script Recorder excluded/included URLs. Based on report and analysis of James Liang
> - Bug 56119 - File uploads fail every other attempt using timers. Enable idle timeouts for servers that don't send Keep-Alive headers.
> - Bug 56272 - MirrorServer should support query parameters for status and redirects
> - Bug 56772 - Handle IE Conditional comments when parsing embedded resources
> - Bug 57026 - HTTP(S) Test Script Recorder : Better default settings. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57107 - Patch proposal: Add DAV verbs to HTTP Sampler. Contributed by Philippe Jung (apache at famille-jung.fr)
> - Bug 56357 - Certificates does not conform to algorithm constraints: Adding a note to indicate how to remove of the Java installation these new security constraints

> ### Other samplers

> - Bug 56033 - Add Connection timeout and Read timeout to SMTP Sampler
> - Bug 56429 - MailReaderSampler - no need to fetch all Messages if not all wanted
> - Bug 56427 - MailReaderSampler enhancement: read message header only
> - Bug 56510 - JMS Publisher/Point to Point: Add JMSPriority and JMSExpiration

> ### Controllers

> - Bug 56728 - New Critical Section Controller to serialize blocks of a Test. Based partly on a patch contributed by Mikhail Epikhin(epihin-m at yandex.ru)
> - Bug 57145 - RandomController : Use ThreadLocalRandom instead of Random for better performances

> ### Listeners

> - Bug 56228 - View Results Tree : Improve ergonomy by changing placement of Renderers and allowing custom ordering
> - Bug 56349 - "summary" is a bad name for a Generate Summary Results component, documentation clarified
> - Bug 56769 - Adds the ability for the Response Time Graph listener to save/restore format settings in/from the jmx file
> - Bug 57025 - SaveService : Better defaults, save thread counts by default

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 56691 - Synchronizing Timer : Add timeout on waiting
> - Bug 56701 - HTTP Authorization Manager/ Kerberos Authentication: add port to SPN when server port is neither 80 nor 443. Based on patches from Dan Haughey (dan.haughey at swinton.co.uk) and Felix Schumacher (felix.schumacher at internetallee.de)
> - Bug 56841 - New configuration element: DNS Cache Manager to improve the testing of CDN. Based on patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com), and contributed by BlazeMeter Ltd.
> - Bug 52061 - Allow access to Request Headers in Regex Extractor. Based on patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com), and contributed by BlazeMeter Ltd.

> ### Functions

> - Bug 56708 - __jexl2 doesn't scale with multiple CPU cores. Based on analysis and patch contributed by Mikhail Epikhin(epihin-m at yandex.ru)
> - Bug 57114 - Performance : Functions that only have values as instance variable should not synchronize execute. Based on analysis by Ubik Load Pack support and Vladimir Sitnikov, patch contributed by Vladimir Sitnikov (sitnikov.vladimir at gmail.com)

> ### I18N

> ### General

> - Bug 21695 - Unix jmeter start script assumes it is on PATH, not a link
> - Bug 56292 - Add the check of the Java's version in startup files and disable some options when is Java v8 engine
> - Bug 56298 - JSR223 language display does not show which engine will be used
> - Bug 56455 - Batch files: drop support for non-NT Windows shell scripts
> - Bug 52707 - Make Open File dialog use last opened file folder as start folder. Based on patch from Dzmitry Kashlach (dzmitrykashlach at gmail.com), and contributed by BlazeMeter Ltd.
> - Bug 56807 - Ability to force flush of ResultCollector file. Contributed by Andrey Pohilko (apc4 at ya.ru)
> - Bug 56921 - Templates : Improve Recording template to ignore embedded resources case and URL parameters. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 42248 - Undo-redo support on Test Plan tree modification. Developed by Andrey Pohilko (apc4 at ya.ru) and contributed by BlazeMeter Ltd. Additional contribution by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 56920 - LogViewer : Make it receive all log events even when it is closed. Contributed by Ubik Load Pack (support at ubikloadpack.com)
> - Bug 57083 - simplified the CachedResourceMode enum. Contributed by Graham Russel (graham at ham1.co.uk)
> - Bug 57082 - ComboStringEditor : Added hashCode to an inner class which overwrote equals. Contributed by Graham Russel (graham at ham1.co.uk)
> - Bug 57081 - Updating checkstyle to only check for tabs in java, xml, xsd, dtd, htm, html and txt files (not images!). Contributed by Graham Russell (graham at ham1.co.uk)
> - Bug 56178 - Really replace backslashes in user name before generating proxy certificate. Contributed by Graham Russel (graham at ham1.co.uk)
> - Bug 57084 - Close socket after usage in BeanShellClient. Contributed by Graham Russel (graham at ham1.co.uk)

> Non-functional changes

> - Bug 57117 - Increase the default cipher for HTTPS Test Script Recorder from SSLv3 to TLS
> - Updated to commons-lang3 3.3.2 (from 3.1)
> - Updated to commons-codec 1.9 (from 1.8)
> - Updated to commons-logging 1.2 (from 1.1.3)
> - Updated to tika 1.6 (from 1.4)
> - Updated to xercesImpl 2.11.0 (from 2.9.1)
> - Updated to xml-apis 1.4.01 (from 1.3.04)
> - Updated to xstream 1.4.8 (from 1.4.4)
> - Updated to jodd 3.6.1 (from 3.4.10)
> - Updated to rsyntaxtextarea 2.5.3 (from 2.5.1)
> - Updated xalan and serializer to 2.7.2 (from 2.7.1)
> - Updated to jsoup-1.8.1.jar (from 1.7.3)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - James Liang (jliang at andera.com)
> - Emmanuel Bourg (ebourg at apache.org)
> - Nicola Ambrosetti (ambrosetti.nicola at gmail.com)
> - Ubik Load Pack
> - Mikhail Epikhin (epihin-m at yandex.ru)
> - Dan Haughey (dan.haughey at swinton.co.uk)
> - Felix Schumacher (felix.schumacher at internetallee.de)
> - Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Andrey Pohilko (apc4 at ya.ru)
> - Bradford Hovinen (hovinen at gmail.com)
> - BlazeMeter Ltd.
> - Graham Russell (graham at ham1.co.uk)
> - Philippe Jung (apache at famille-jung.fr)
> - Vladimir Sitnikov (sitnikov.vladimir at gmail.com)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - Oliver LLoyd (email at oliverlloyd.com) for his help on Bug 56119
> - Vladimir Ryabtsev (greatvovan at gmail.com) for his help on Bug 56243 and Bug 56276
> - Adrian Speteanu (asp.adieu at gmail.com) and Matt Kilbride (matt.kilbride at gmail.com) for their feedback and tests on Bug 54648
> - Shmuel Krakower (shmulikk at gmail.com) for his tests and reports on Undo/Redo feature
> Apologies if we have omitted anyone else.

> # Version 2.11

> Summary

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> HTTP(S) Test Script Recorder improvements

> Following improvements have been made since major changes introduced in JMeter 2.10 on HTTP(S) Test Script Recorder:

> - Better detection of missing or invalid configuration of keytool utility
> - New system property `keytool.directory` (see `system.properties`) lets you configure directory containing keytool in case on non-standard installation

> JMS Publisher/Point to Point : Add ability to set typed values in JMS header properties

> In the samplers JMS Publisher and JMS Point-to-Point, you can now set up the class of values for the JMS header properties. Previously only String was possible.

> View Results Tree : Add an XPath Tester

> In View Results Tree listener, a new XPath tester can be used to test XPATH expressions.

> Ability to choose the client alias for the cert key in JsseSslManager such that Mutual SSL auth testing can be made more flexible

> When testing client based certificate authentications you have now better control on certificate you use through a new field "Variable name holding certificate alias", this field lets you select the certificate you want to send to server to authenticate. You can use a CSV Data Set as a holder for the variable value.

> Add a "Save as Test Fragment" option

> In the file menu, a new option allow to save a group of elements as a Test fragment.

> Summariser is be enabled by default in Non GUI mode

> When you run JMeter from command line, now JMeter displays some statistics from the Summariser mode.

> Transaction Controller:Change default property "Include duration of timer…" for newly created element

> Starting from 2.11, Transaction Controller is configured by default to exclude processing time of pre/post processors as long as timers pause.

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, the total number of threads only applies to a locally run test, otherwise it will show 0 (see Bug 55510 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629. A workaround is to use a Java 7 update 40 runtime which fixes this issue.

> Incompatible changes

> - When creating a new Transaction Controller, property "Include duration of timer and pre-post processors in generated sample" will be unchecked starting from version 2.11
> - In Non GUI mode, since 2.11 summariser is enabled with a 30 seconds frequency
> - JMeter is more lenient with redirect handling and relaxes on RFC2616 by allowing relative locations. See property "`jmeter.httpclient.strict_rfc2616`" in `jmeter.properties` to change this behaviour, see Bug 55717
> - When creating a new Response Assertion, property "Pattern Matching Rules" now defaults to Substring starting from version 2.11

> Bug fixes

> ### HTTP Samplers and Test Script Recorder

> - Bug 55815 - Proxy#getDomainMatch does not handle wildcards correctly
> - Bug 55717 - Bad handling of Redirect when URLs are in relative format by HttpClient4 and HttpClient3.1

> ### Other Samplers

> - Bug 55685 - OS Sampler: timeout option don't save and restore correctly value and don't init correctly timeout

> ### Controllers

> - Bug 55816 - Transaction Controller with "Include duration of timer…" unchecked does not ignore processing time of last child sampler

> ### Listeners

> - Bug 55826 - Unsynchronised concurrent accesses to list in field RespTimeGraphVisualizer.internalList

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 55694 - Assertions and Extractors : Avoid NullPointerException when scope is variable and variable is missing
> - Bug 55721 - HTTP Cache Manager - no-store directive is wrongly interpreted

> ### Functions

> - Bug 55871 - Wrong result with intSum() function when a space character is present before/after the number. Contributed by Milamber based on a proposal by James Liang.

> ### I18N

> ### General

> - Bug 55739 - Remote Test : Total threads in GUI mode shows invalid total number of threads

> Improvements

> ### HTTP Samplers and Proxy

> ### Other samplers

> - Bug 55589 - JMS Publisher/Point to Point : Add ability to set typed values in JMS header properties.

> ### Controllers

> - Bug 55854 - Transaction Controller:Change default property "Include duration of timer…" for newly created element

> ### Listeners

> - Bug 55610 - View Results Tree : Add an XPath Tester

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 55908 - Response assertion : Change Pattern Matching Rules default to Substring on creation for better performances
> - Bug 54977 - Ability to choose the client alias for the cert key in JsseSslManager such that Mutual SSL auth testing can be made more flexible. Contributed by UBIK Load Pack (support at ubikloadpack.com)

> ### Functions

> ### I18N

> ### General

> - Bug 55693 - Add a "Save as Test Fragment" option
> - Bug 55753 - Improve FilePanel behaviour to start from the value set in Filename field if any. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55756 - HTTP Mirror Server : Add ability to set Headers
> - Bug 55852 - Be more lenient in parsing when charset value is surrounded with single quotes
> - Bug 55857 - Performance : AbstractProperty should test for emptiness to avoid Exception throwing
> - Bug 55858 - Startup Performance : On Startup, BeanInfoSupport should test for key availability instead of throwing
> - Bug 55865 - Performance :Disable stale check by default in HttpClient 4 and 3.1
> - Bug 55512 - Summariser should be enabled by default in Non GUI mode

> Non-functional changes

> - Updated to rsyntaxtextarea-2.5.1.jar (from 2.5.0)
> - Updated to jodd-core-3.4.9.jar from (3.4.8) and jodd-lagarto-3.4.9.jar (from 3.4.9)
> - Updated to jsoup-1.7.3.jar (from 1.7.2)
> - Updated to mail-1.5.0-b01 (from 1.4.4)
> - Updated to mongo-java-driver-2.11.3 (from 2.11.2)

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - James Liang (jliang at andera.com)
> - UBIK Load Pack (support at ubikloadpack.com)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - John Natsioulas (john_natsioulas at yahoo.com.au)
> - Antonio Gomes Rodrigues (ra0077 at gmail.com)
> Apologies if we have omitted anyone else.

> # Version 2.10

> Summary

> - New and Noteworthy
> - Known bugs
> - Incompatible changes
> - Bug fixes
> - Improvements
> - Non-functional changes
> - Thanks

> New and Noteworthy

> Core Improvements

> New Performance improvements

> - A Huge performance improvement has been made on High Throughput Tests (no pause), see Bug 54777
> - An issue with unnecessary SSL Context reset has been fixed which improves performances of pure HTTP tests, see Bug 55023
> - Important performance improvement in parsing of Embedded resource in HTML pages thanks to a switch to JODD/Lagarto HTML Parser, see Bug 55632

> New CSS/JQuery Tester in View Tree Results

> A new CSS/JQuery Tester in View Tree Results that makes CSS/JQuery Extractor a first class citizen in JMeter, you can now test your expressions very easily

> Many improvements in HTTP(S) Recording have been made

> The "HTTP Proxy Server" test element has been renamed as "HTTP(S) Test Script Recorder".

> - Better recording of HTTPS sites, embedded resources using subdomains will more easily be recorded when using JDK 7. See Bug 55507 . See updated documentation: HTTP(S) Test Script Recorder
> - Redirection are now more smartly detected by HTTP Proxy Server, see Bug 55531
> - Many fixes on edge cases with HTTPS have been made, see Bug 55502 , Bug 55504 , Bug 55506
> - Many encoding fixes have been made, see Bug 54482 , Bug 54142 , Bug 54293

> You can now load test MongoDB through new MongoDB Source Config

> Kerberos authentication has been added to Auth Manager

> Device can now be used in addition to source IP address

> You can now do functional testing of MongoDB scripts through new MongoDB Script

> Timeout has been added to OS Process Sampler

> Query timeout has been added to JDBC Request

> New functions (__urlencode and __urldecode) are now available to encode/decode URL encoded chars

> Continuous Integration is now eased by addition of a new flag that forces NON-GUI JVM to exit after test end

> See jmeter property:

> `jmeterengine.force.system.exit`

> HttpSampler now allows DELETE Http Method to have a body (works for HC4 and HC31 implementations). This allows for example to test Elastic Search APIs

> 2 implementations of HtmlParser have been added to improve Embedded resources parsing

> You can choose the implementation to use for parsing Embedded resources in HTML pages: See jmeter.properties and look at property "htmlParser.className".

> - org.apache.jmeter.protocol.http.parser.LagartoBasedHtmlParser for optimal performances
> - org.apache.jmeter.protocol.http.parser.JSoupBasedHtmlParser for most accurate parsing and functional testing

> Distributed testing has been improved

> - Number of threads on each node are now reported to controller.

> - Performance improvement on BatchSampleSender(Bug 55423 )
> - Addition of 2 SampleSender modes (StrippedAsynch and StrippedDiskStore), see jmeter.properties

> ModuleController has been improved to better handle changes to referenced controllers

> Improved class loader configuration, see

> - New property "plugin_dependency_paths" for plugin dependencies
> - Properties "search_paths", "user.classpath" and "plugin_dependency_paths" now automatically add all jars from configured directories

> Best-practices section has been improved, ensure you read it to get the most out of JMeter

> See Best Practices

> GUI and ergonomy Improvements

> New Templates feature that allows you to create test plan from existing template or merge template into your Test Plan

> Workbench can now be saved

> Syntax color has been added to scripts elements (BeanShell, BSF, and JSR223), MongoDB and JDBC elements making code much more readable and allowing UNDO/REDO through CTRL+Z/CTRL+Y

> BSF Sampler with syntax color

> JSR223 Pre Processor with syntax color

> Better editors are now available for Test Elements with large text content, like HTTP Sampler, and JMS related Test Element providing line numbering and allowing UNDO/REDO through CTRL+Z/CTRL+Y

> JMeter GUI can now be fully Internationalized, all remaining issues have been fixed

> ##### Currently French has all its labels translated. Other languages are partly translated, feel free to contribute translations by reading Localisation (Translator's Guide)

> Moving elements in Test plan has been improved in many ways

> ##### Drag and drop of elements in Test Plan tree is now much easier and possible on multiple nodes

> Note that due to this bug in Java, you cannot drop a node after last node. The workaround is to drop it before this last node and then Drag and Drop the last node before the one you just dropped.

> ##### New shortcuts have been added to move elements in the tree.

> (alt + Arrow Up) and (alt + Arrow Down) move the element within the parent node
> (alt + Arrow Left) and (alt + Arrow Right) move the element up and down in the tree depth

> Response Time Graph Y axis can now be scaled

> JUnit Sampler gives now more details on configuration errors

> Known bugs

> - The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).
> - Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).
> - Webservice sampler does not consider the HTTP response status to compute the status of a response, thus a response 500 containing a non empty body will be considered as successful, see Bug 54006 . To workaround this issue, ensure you always read the response and add a Response Assertion checking text inside the response.
> - The numbers that appear to the left of the green box are the number of active threads / total number of threads, these only apply to a locally run test; they do not include any threads started on remote systems when using client-server mode, (see Bug 54152 ).
> - Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>        [java] WARNING: Couldn't flush user prefs:
>        java.util.prefs.BackingStoreException:
>        java.lang.IllegalArgumentException: Not supported: indent-number

>   This does not affect JMeter operation. This issue is fixed since Java 7b05.
> - With Java 1.6 and Gnome 3 on Linux systems, the JMeter menu may not work correctly (shift between mouse's click and the menu). This is a known Java bug (see Bug 54477 ). A workaround is to use a Java 7 runtime (OpenJDK or Oracle JDK).
> - With Oracle Java 7 and Mac Book Pro Retina Display, the JMeter GUI may look blurry. This is a known Java bug, see Bug JDK-8000629. A workaround is to use a Java 7 update 40 runtime which fixes this issue.

> Incompatible changes

> - SMTP Sampler now uses eml file subject if subject field is empty
> - With this version autoFlush has been turned off on PrintWriter in charge of writing test results. This results in improved throughput for intensive tests but can result in more test data loss in case of JMeter crash (extremely rare). To revert to previous behaviour set `jmeter.save.saveservice.autoflush` property to `true`.
> - Shortcut for Function Helper Dialog is now CTRL+SHIFT+F1 (CMD + SHIFT + F1 for Mac OS). The original key sequence (Ctrl+F1) did not work in some locations (it is consumed by the Java Swing ToolTipManager). It was therefore necessary to change the shortcut.
> - Webservice (SOAP) Request has been removed by default from GUI as Element is deprecated. (Use HTTP Request with Body Data, see also the Template Building a SOAP Webservice Test Plan), if you need to show it, see property `not_in_menu` in jmeter.properties
> - Transaction Controller now sets Response Code of Generated Parent Sampler (if Generated Parent Sampler is checked) to response code of first failing child in case of failure of one of the children, in previous versions Response Code was empty.
> - In previous versions, IncludeController could run Test Elements located inside a Thread Group, this behaviour (which was not documented) could result in weird behaviour, it has been removed in this version (see Bug 55464 ). The correct way to include Test Elements is to use Test Fragment as stated in documentation of Include Controller.
> - The retry count for the HttpClient 3.1 and HttpClient 4.x samplers has been changed to 0. Previously the default was 1, which could cause unexpected additional traffic.
> - Starting with this version, the HTTP(S) Test Script Recorder tries to detect when a sample is the result of a previous redirect. If the current response is a redirect, JMeter will save the redirect URL. When the next request is received, it is compared with the saved redirect URL and if there is a match, JMeter will disable the generated sample. To revert to previous behaviour, set the property `proxy.redirect.disabling=false`
> - Starting with this version, in HTTP(S) Test Script Recorder if Grouping is set to Put each group in a new Transaction Controller, the Recorder will create Transaction Controller instances with Include duration of timer and pre-post processors in generated sample set to false. This default value reflect more accurately response time.
> - `__escapeOroRegexpChars` function (which escapes ORO reserved characters) no longer trims the value (see Bug 55328 )
> - The commons-lang-2.6.jar has been removed from embedded libraries in `jmeter/lib` folder as it is not needed by JMeter at run-time (it is only used by Apache Velocity for generating documentation). If you use any plugin or third-party code that depends on it, you need to add it in `jmeter/lib` folder

> Bug fixes

> ### HTTP Samplers and Proxy

> - Bug 54627 - JMeter Proxy GUI: Type of sampler setting takes the whole screen when there are samplers with long names.
> - Bug 54629 - HTMLParser does not extract <object> tag urls.
> - Bug 55023 - SSL Context reuse feature (51380) adversely affects non-ssl request performance/throughput. based on analysis by Brent Cromarty (brent.cromarty at yahoo.ca)
> - Bug 55092 - Log message "WARN - jmeter.protocol.http.sampler.HTTPSamplerBase: Null URL detected (should not happen)" displayed when embedded resource URL is malformed.
> - Bug 55161 - Useless processing in SoapSampler.setPostHeaders. Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 54482 - HC fails to follow redirects with non-encoded chars.
> - Bug 54142 - HTTP Proxy Server throws an exception when path contains "|" character.
> - Bug 55388 - HC3 does not allow IP Source field to override httpclient.localaddress.
> - Bug 55450 - HEAD redirects should remain as HEAD
> - Bug 55455 - HTTPS with HTTPClient4 ignores cps setting
> - Bug 55502 - Proxy generates empty http:/ entries when recording
> - Bug 55504 - Proxy incorrectly issues CONNECT requests when browser prompts for certificate override
> - Bug 55506 - Proxy should deliver failed requests to any configured Listeners
> - Bug 55545 - HTTP Proxy Server GUI should not allow both Follow and Auto redirect to be selected

> ### Other Samplers

> - Bug 54913 - JMSPublisherGui incorrectly restores its state. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 55027 - Test Action regression, duration value is not recorded (nightly build).
> - Bug 55163 - BeanShellTestElement fails to quote string when calling testStarted(String)/testEnded(String).
> - Bug 55349 - NativeCommand hangs if no input file is specified and the application requests input.
> - Bug 55462 - System Sampler should not change the sampler label if a sample fails

> ### Controllers

> - Bug 54467 - Loop Controller: compute loop value only once per parent iteration.
> - Bug 54985 - Make Transaction Controller set Response Code of Generated Parent Sampler to response code of first failing child in case of failure of one of its children. Contributed by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 54950 - ModuleController : Changes to referenced Module are not taken into account if changes occur after first run and referenced node is disabled.
> - Bug 55201 - ForEach controller excludes start index and includes end index (clarified documentation).
> - Bug 55334 - Adding Include Controller to test plan (made of Include Controllers) without saving TestPlan leads to included code not being taken into account until save.
> - Bug 55375 - StackOverflowError with ModuleController in Non-GUI mode if its name is the same as the target node.
> - Bug 55464 - Include Controller running included thread group

> ### Listeners

> - Bug 54589 - View Results Tree have a lot of Garbage characters if html page uses double-byte charset.
> - Bug 54753 - StringIndexOutOfBoundsException at SampleResult.getSampleLabel() if key_on_threadname=false when using Statistical mode.
> - Bug 54685 - ArrayIndexOutOfBoundsException if "sample_variable" is set in client but not server.
> - Bug 55111 - ViewResultsTree: text not refitted if vertical scrollbar is required. Contributed by Milamber

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 54540 - "HTML Parameter Mask" are not marked deprecated in the IHM.
> - Bug 54575 - CSS/JQuery Extractor : Choosing JODD Implementation always uses JSOUP.
> - Bug 54901 - Response Assertion GUI behaves weirdly.
> - Bug 54924 - XMLAssertion uses JMeter JVM file.encoding instead of response encoding and does not clean threadlocal variable.
> - Bug 53679 - Constant Throughput Timer bug with localization. Reported by Ludovic Garcia

> ### Functions

> - Bug 55328 - __escapeOroRegexpChars trims spaces.

> ### I18N

> - Bug 55437 - ComboStringEditor does not translate EDIT and UNDEFINED strings on language change
> - Bug 55501 - Incorrect encoding for French description of __char function. Contributed by Antonio Gomes Rodrigues (ra0077 at gmail.com)

> ### General

> - Bug 54504 - Resource string not found: [clipboard_node_read_error].
> - Bug 54538 - GUI: context menu is too big.
> - Bug 54847 - Cut & Paste is broken with tree multi-selection. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54870 - Tree drag and drop may lose leaf nodes (affected nightly build). Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 55056 - wasted work in Data.append(). Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 55129 - Change Javadoc generation per CVE-2013-1571, VU#225657.
> - Bug 55187 - Integer overflow when computing ONE_YEAR_MS in HTTP CacheManager.
> - Bug 55208 - JSR223 language entries are duplicated; fold to lower case.
> - Bug 55203 - TestBeanGUI - wrong language settings found.
> - Bug 55065 - Useless processing in Spline3.converge(). Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 55064 - Useless processing in ReportTreeListener.isValidDragAction(). Contributed by Adrian Nistor (nistor1 at illinois.edu)
> - Bug 55242 - BeanShell Client jar throws exceptions after upgrading to 2.8.
> - Bug 55288 - JMeter should default to 0 retries for HTTP requests.
> - Bug 55405 - ant download_jars task fails if lib/api or lib/doc are missing. Contributed by Antonio Gomes Rodrigues.
> - Bug 55427 - TestBeanHelper should ignore properties not supported by GenericTestBeanCustomizer
> - Bug 55459 - Elements using ComboStringEditor lose the input value if user selects another Test Element
> - Bug 54152 - In distributed testing : activeThreads always show 0 in GUI and Summariser
> - Bug 55509 - Allow Plugins to be notified of remote thread number progression
> - Bug 55572 - Detail popup of parameter does not show a Scrollbar when content exceeds display
> - Bug 55580 - Help pane does not scroll to start for <a href="#"> links
> - Bug 55600 - JSyntaxTextArea : Strange behaviour on first undo
> - Bug 55655 - NullPointerException when Remote stopping /shutdown all if one engine did not start correctly. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55657 - Remote and Local Stop/Shutdown buttons state does not take into account local / remote status

> Improvements

> ### HTTP Samplers and Proxy

> - HTTP Request: Small user interaction improvements in Row parameter Detail Box. Contributed by Milamber
> - Bug 55255 - Allow Body in HTTP DELETE method to support API that use it (like ElasticSearch).
> - Bug 53480 - Add Kerberos support to Http Sampler (HttpClient4). Based on patch by Felix Schumacher (felix.schumacher at internetallee.de)
> - Bug 54874 - Support device in addition to source IP address. Based on patch by Dan Fruehauf (malkodan at gmail.com)
> - Bug 55488 - Add .ico and .woff file extension to default suggested exclusions in proxy recorder. Contributed by Antonio Gomes Rodrigues
> - Bug 55525 - Proxy should support alias for keyserver entry
> - Bug 55531 - Proxy recording and redirects. Added code to disable redirected samples.
> - Bug 55507 - Proxy SSL recording does not handle external embedded resources well
> - Bug 55632 - Have a new implementation of htmlParser for embedded resources parsing with better performances
> - Bug 55653 - HTTP(S) Test Script Recorder should set TransactionController property "Include duration of timer and pre-post processors in generated sample" to false

> ### Other samplers

> - Bug 54788 - JMS Point-to-Point Sampler - GUI enhancements to increase readability and ease of use. Contributed by Bruno Antunes (b.m.antunes at gmail.com)
> - Bug 54798 - Using subject from EML-file for SMTP Sampler. Contributed by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 54759 - SSLPeerUnverifiedException using HTTPS , property documented.
> - Bug 54896 - JUnit sampler gives only "failed to create an instance of the class" message with constructor problems.
> - Bug 55084 - Add timeout support for JDBC Request. Contributed by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 55403 - Enhancement to OS sampler: Support for timeout
> - Bug 55518 - Add ability to limit number of cached PreparedStatements per connection when "Prepared Select Statement", "Prepared Update Statement" or "Callable Statement" query type is selected

> ### Controllers

> - Bug 54271 - Module Controller breaks if test plan is renamed.

> ### Listeners

> - Bug 54532 - Improve Response Time Graph Y axis scale with huge values or small values (< 1000ms). Add a new field to define increment scale. Contributed by Milamber based on patch by Luca Maragnani (luca.maragnani at gmail.com)
> - Bug 54576 - View Results Tree : Add a CSS/JQuery Tester.
> - Bug 54777 - Improve Performance of default ResultCollector. Based on patch by Mikhail Epikhin (epihin-m at yandex.ru)
> - Bug 55389 - Show IP source address in request data

> ### Timers, Assertions, Config, Pre- & Post-Processors

> - Bug 54789 - XPath Assertion - GUI enhancements to increase readability and ease of use.

> ### Functions

> - Bug 54991 - Add functions to encode/decode URL encoded chars (__urlencode and __urldecode). Contributed by Milamber.

> ### I18N

> - Bug 55241 - Need GUI Editor to process fields which are based on Enums with localised display strings
> - Bug 55440 - ComboStringEditor should allow tags to be language dependent
> - Bug 55432 - CSV Dataset Config loses sharing mode when switching languages

> ### General

> - Bug 54584 - MongoDB plugin. Based on patch by Jan Paul Ettles (janpaulettles at gmail.com)
> - Bug 54669 - Add flag forcing non-GUI JVM to exit after test. Contributed by Scott Emmons
> - Bug 42428 - Workbench not saved with Test Plan. Contributed by Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Bug 54825 - Add shortcuts to move elements in the tree. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54834 - Improve Drag & Drop in the jmeter tree. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54839 - Set the application name on Mac. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54841 - Correctly handle the quit shortcut on Mac Os (CMD-Q). Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54844 - Set the application icon on Mac Os. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54864 - Enable multi selection drag & drop in the tree without having to start dragging before releasing Shift or Control. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54945 - Add Shutdown Hook to enable trapping kill or CTRL+C signals.
> - Bug 54990 - Download large files avoiding outOfMemory.
> - Bug 55085 - UX Improvement : Ability to create New Test Plan from Templates. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55172 - Provide plugins a way to add Top Menu and menu items.
> - Bug 55202 - Add syntax color for scripts elements (BeanShell, BSF, and JSR223) and JDBC elements with RSyntaxTextArea. Contributed by Milamber based on patch by Marko Vlahovic (vlahovic74 at gmail.com)
> - Bug 55175 - HTTPHC4Impl refactoring to allow better inheritance.
> - Bug 55236 - Templates - provide button to reload template details.
> - Bug 55237 - Template system should support relative fileName entries.
> - Bug 55423 - BatchSampleSender: Reduce locking granularity by moving listener.processBatch outside of synchronized block
> - Bug 55424 - Add Stripping to existing SampleSenders
> - Bug 55451 - Test Element GUI with JSyntaxTextArea scroll down when text content is long enough to add a Scrollbar
> - Bug 55513 - StreamCopier cannot be used with System.err or System.out as it closes the output stream
> - Bug 55514 - SystemCommand should support arbitrary input and output streams
> - Bug 55515 - SystemCommand should support chaining of commands
> - Bug 55606 - Use JSyntaxtTextArea for Http Request, JMS Test Elements
> - Bug 55651 - Change JMeter application icon to Apache plume icon

> Non-functional changes

> - Updated to jsoup-1.7.2
> - Bug 54776 - Update the dependency on Bouncy Castle to 1.48. Contributed by Emmanuel Bourg (ebourg at apache.org)
> - Updated to HttpComponents Client 4.2.6 (from 4.2.3)
> - Updated to HttpComponents Core 4.2.5 (from 4.2.3)
> - Updated to commons-codec 1.8 (from 1.6)
> - Updated to commons-io 2.4 (from 2.2)
> - Updated to commons-logging 1.1.3 (from 1.1.1)
> - Updated to commons-net 3.3 (from 3.1)
> - Updated to jdom-1.1.3 (from 1.1.2)
> - Updated to jodd-lagarto and jodd-core 3.4.8 (from 3.4.1)
> - Updated to junit 4.11 (from 4.10)
> - Updated to slf4j-api 1.7.5 (from 1.7.2)
> - Updated to tika 1.4 (from 1.3)
> - Updated to xmlgraphics-commons 1.5 (from 1.3.1)
> - Updated to xstream 1.4.4 (from 1.4.2)
> - Updated to BouncyCastle 1.49 (from 1.48)
> - Bug 54912 - JMeterTreeListener should use constants. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 54903 - Remove the dependency on the Activation Framework. Contributed by Emmanuel Bourg (ebourg at apache.org)
> - Moved commons-lang (2.6) to lib/doc as it's only needed by Velocity.
> - Re-organised and simplified NOTICE and LICENSE files.
> - Bug 55411 - NativeCommand could be useful elsewhere. Copied code to o.a.jorphan.exec.
> - Bug 55435 - ComboStringEditor could be simplified to make most settings final
> - Bug 55436 - ComboStringEditor should implement ClearGui
> - Bug 55463 - Component.requestFocus() is discouraged; use requestFocusInWindow() instead
> - Bug 55486 - New JMeter Logo. Contributed by UBIK Load Pack (support at ubikloadpack.com)
> - Bug 55548 - Tidy up use of TestElement.ENABLED; use TestElement.isEnabled()/setEnabled() throughout
> - Bug 55617 - Improvements to jorphan collection. Contributed by Benoit Wiart (benoit.wiart at gmail.com)
> - Bug 55623 - Invalid/unexpected configuration values should not be silently ignored
> - Bug 55626 - Rename HTTP Proxy Server as HTTP(S) Test Script Recorder

> Thanks

> We thank all contributors mentioned in bug and improvement sections above:

> - Bruno Antunes (b.m.antunes at gmail.com)
> - Emmanuel Bourg (ebourg at apache.org)
> - Scott Emmons
> - Mikhail Epikhin (epihin-m at yandex.ru)
> - Dzmitry Kashlach (dzmitrykashlach at gmail.com)
> - Luca Maragnani (luca.maragnani at gmail.com)
> - Milamber
> - Adrian Nistor (nistor1 at illinois.edu)
> - Antonio Gomes Rodrigues (ra0077 at gmail.com)
> - UBIK Load Pack (support at ubikloadpack.com)
> - Benoit Wiart (benoit.wiart at gmail.com)
> We also thank bug reporters who helped us improve JMeter.
> For this release we want to give special thanks to the following reporters for the clear reports and tests made after our fixes:
> - Immanuel Hayden (immanuel.hayden at gmail.com)
> - Danny Lade (dlade at web.de)
> - Brent Cromarty (brent.cromarty at yahoo.ca)
> - Wolfgang Heider (wolfgang.heider at racon.at)
> - Shmuel Krakower (shmulikk at gmail.com)
> Apologies if we have omitted anyone else.

> # Version 2.9

> ## New and Noteworthy

> ### Core Improvements:

> #### * A new Extractor that uses CSS or jquery-like selector syntax has been introduced, it allows using either JODD or JSOUP implementations

> Result: the title of the page in a JMeter variable

> #### * JMeter can now handle different types of documents (PDF, MsOffice files, Apache OpenOffice's files, …) within different elements

> - Regular Expression Extractor, extract text from documents
> - Assertion Response, check text in documents
> - View Results Tree, view as a text the documents

> #### * A new Regex User Parameters Pre-Processor that enables injecting input parameter names and values using a reference extracted by Regular Expression Extractor from a previous response

> #### * TCP Sampler: new options

> TCP Sampler has been enhanced with new options to allow setting Close Connection, SO_LINGER and End of line(EOL) byte value

> #### * A new function __escapeOroRegexpChars(,) has been introduced quote ORO regexp meta characters

> #### * ForEach Controller: new fields

> ForEach Controller has now 2 new fields to control start and end of loop

> #### * Result Status Action Handler now has a new option to "Start next thread loop"

> #### * JMS Publisher: new option

> JMS Publisher can now send Bytes Messages

> #### * Memory and performance improvements

> Significant improvements have been done in this version on memory usage per Thread and CPU when more than one Post Processor is used as child of a Sampler

> JSR223 Elements (enable using Groovy, Scala, … as scripting languages) have been improved to enable caching of Compilation results when scripts are passed in Text area

> Some configuration defaults have changed to improve performances by default(see Bug 54412 ), see description in New and Noteworthy section.

> - Distributed testing now uses MODE_STRIPPED_BATCH, which returns samples in batch mode (every 100 samples or every minute by default). Note also that MODE_STRIPPED_BATCH strips response data from SampleResult, so if you need it change to another mode (mode property in jmeter.properties)
> - Result data are now saved to CSV by default (jmeter.save.saveservice.output_format in jmeter.properties)

> #### * XPath Assertion now enables using a JMeter variable as input

> ### GUI and ergonomy Improvements:

> #### * Search feature has been improved to search within more internal fields of elements and expand search results

> #### * Copy/paste is now possible between 2 JMeter instances >= 2.9 version

> Copy element(s) from one JMeter instance:

> Paste element(s) into a second JMeter instance:

> #### * HTTP Header Manager

> Allow copy from clipboard to HeaderPanel, headers are supposed to be separated by new line and have the following form name:value

> #### * Module Controller

> Module Controller has been improved to better render referenced controller and expand it by clicking on a new button

> #### * HTTP Proxy Server

> HTTP Proxy Server now has a button to add a set of default exclusions for URL patterns, this list can be configured through property : proxy.excludes.suggested

> #### * Rendering of target controller has been improved in HTTP Proxy Server

> ### HTTP Proxy Server recording:

> * HTTP Proxy Server now automatically uses HTTP Request with Raw Post Body mode for samples that only have one unnamed argument (JSON, XML, GWT, …)

> * HTTP Proxy Server does not force user to select the type of Sampler in HTTP Sampler Settings, this allows easier switch between implementations as Sampler do not have this information set anymore

> * SamplerCreator interface has been enriched to meet new requirements for plug-in providers

> * It is now possible to create binary sampler for x-www-form-urlencoded POST request by modifying proxy.binary.types property to add application/x-www-form-urlencoded

> * Improved timestamp format auto-detection when reading CSV files

> ## Known bugs

> The Once Only controller behaves correctly under a Thread Group or Loop Controller, but otherwise its behaviour is not consistent (or clearly specified).

> Listeners don't show iteration counts when a If Controller has a condition which is always false from the first iteration (see Bug 52496 ). A workaround is to add a sampler at the same level as (or superior to) the If Controller. For example a Test Action sampler with 0 wait time (which doesn't generate a sample), or a Debug Sampler with all fields set to False (to reduce the sample size).

> Webservice sampler does not consider the HTTP response status to compute the status of a response, thus a response 500 containing a non empty body will be considered as successful, see Bug 54006 . To workaround this issue, ensure you always read the response and add a Response Assertion checking text inside the response.

> Changing language can break part of the configuration of the following elements (see Bug 53679 ):

> - CSV Data Set Config (sharing mode will be lost)
> - Constant Throughput Timer (Calculate throughput based on will be lost)

> The numbers that appear to the left of the green box are the number of active threads / total number of threads, these only apply to a locally run test; they do not include any threads started on remote systems when using client-server mode, (see Bug 54152 ).

> Note that there is a bug in Java on some Linux systems that manifests itself as the following error when running the test cases or JMeter itself:

>      [java] WARNING: Couldn't flush user prefs:
>      java.util.prefs.BackingStoreException:
>      java.lang.IllegalArgumentException: Not supported: indent-number

> This does not affect JMeter operation.

> ## Incompatible changes

> JMeter requires now a Java 6 runtime or higher.

> Some configuration defaults have changed to improve performances by default (see Bug 54412 ), see description in New and Noteworthy section.

> Webservice sampler now adds to request the headers that are set through Header Manager, these were previously ignored

> jdbcsampler.cachesize property has been removed, it previously limited the size of a per connection cache of Map < String, PreparedStatement > , it also limited the size of this map which held the PreparedStatement for SQL queries. This limitation provoked a bug Bug 53995 . It has been removed so now size of these 2 maps is not limited anymore. This change changes behaviour as starting from this version no PreparedStatement will be closed during the test.

